<?php
// Global defaults
/* NEWMAIL-POPUP-BEGIN */
$config["defaults"]["global"]["javascript"]			= 0;
/* NEWMAIL-POPUP-END */
$config["defaults"]["global"]["office_hours_start"]	= 8;          
$config["defaults"]["global"]["office_hours_end"]	= 18;          
$config["defaults"]["global"]["mstyle1"]			= 7;	// Default twiggi feature list style (bold hyperlinks)
$config["defaults"]["global"]["mstyle2"]			= 7;	// Default feature submenu style (non-bold hyperlinks)
$config["defaults"]["global"]["mailfoot"]			= 0;	// Disabled the display of the new mail indicator in the footer (0|1)
$config["defaults"]["global"]["timeformat"]			= 12;	// Default time format
$config["defaults"]["global"]["singletimeselector"]	= 0;
$config["defaults"]["global"]["dateformat"]			= 0;	// Default time format US
$config["defaults"]["global"]["colorscheme"]		= 1;	// Default business
$config["defaults"]["global"]["fontfamily"]			= 1;	// Default twiggi font family arial
$config["defaults"]["global"]["fontsize"]			= 1;	// Default twiggi font size small
$config["defaults"]["global"]["language"]			= "english";	// Default twiggi language
$config["defaults"]["global"]["helplanguage"]		= "";	// Default help language = language
$config["defaults"]["global"]["usecss"]				= 1;	// Use CSS

// Defaults pertaining to the main feature
/* NEWMAIL-POPUP-BEGIN */
$config["defaults"]["main"]["returntomain"]		= 0;
$config["defaults"]["main"]["refreshmain"]		= 0;
$config["defaults"]["main"]["newmailpopup"]		= TRUE;
/* NEWMAIL-POPUP-END */
$config["defaults"]["main"]["todo"]				= 0;	// Disable the display of the todo list in the main screen
$config["defaults"]["main"]["schedule"]			= 0;	// Disable the display of the schedule list in the main screen
$config["defaults"]["main"]["recentmail"]		= 0;	// Disable the display of the recent mail list in the main screen
$config["defaults"]["main"]["todaymail"]		= 1;	// Only show mails of today, if recentmail=0
$config["defaults"]["main"]["maxmail"]			= 10;            
$config["defaults"]["main"]["maxschedule"]		= 10;            
$config["defaults"]["main"]["maxtodo"]			= 10;            
$config["defaults"]["main"]["viewgrp"]			= "*"	;// Default group to display in the feature (*=All|0=Unfiled)
$config["defaults"]["main"]["onlyactivetodo"]	= "0";	// Do not show completed or cancelled todo items

// Defaults pertaining to the mail feature
$config["defaults"]["mail"]["linewrap"]				= 80;		// Where to wrap lines
$config["defaults"]["mail"]["pagesize"]				= 15;		// Default number of items to display in the mail list
$config["defaults"]["mail"]["sortby"]				= "date";	// Default sort order (date|from|subject)
$config["defaults"]["mail"]["sortorder"]			= 1;		// Default sort direction (0|1)
$config["defaults"]["mail"]["dande"]				= 0;		// Delete and Expunge simulatiniously? (0|1)
$config["defaults"]["mail"]["mande"]				= 0;		// Move and Expunge simulatiniously? (0|1)
$config["defaults"]["mail"]["savesent"]				= 1;		// Save sent messages in the send folder? (0|1)
$config["defaults"]["mail"]["sentfold"]				= "sent-mail";	// What folder to save sent messages to (can by anything,
																	// twiggi will create it if it does not exist)
$config["defaults"]["mail"]["draftfold"]		= "Drafts";	// What folder to save draft messages to (can by anything, 
															// twiggi will create it if it does not exist)
$config["defaults"]["mail"]["cmdline2"]			= 0;	// Display the second command line in mail (0|1)
$config["defaults"]["mail"]["newwindow"]		= 0;	// Display messages in new windows (0|1)
$config["defaults"]["mail"]["listcmds"]			= 0;	// Unused at the time
$config["defaults"]["mail"]["newcontact"]		= 1;	// Show the contacts list when composing a new message (0|1)
$config["defaults"]["mail"]["defaultsig"]		= 1;	// # of default signature
$config["defaults"]["mail"]["numup"]			= 1;	// Default number of attachments for new messages
$config["defaults"]["mail"]["mailtree"]			= 0;	// Display the mail view tree (0|1)
$config["defaults"]["mail"]["mtexpand"]			= 0;	// Allways expand all branches in the mail view tree (0|1)
$config["defaults"]["mail"]["mdn"]				= 0;	// Request a read receipts? (0|1)
$config["defaults"]["mail"]["mdn_mode"]			= 1;	// How to respond to MDN requests (0=never|1=manual|2=always)
$config["defaults"]["mail"]["areply"]			= 0;	// Included attached files when replying to a message (0|1)
$config["defaults"]["mail"]["aforward"]			= 1;	// Included attached files when forwarding a message (0|1)
$config["defaults"]["mail"]["clines"]			= 30;	// Number of body lines to display while composing a message
$config["defaults"]["mail"]["dreturn"]			= 0;	// Always return to the main message list after deleting a message (0|1)
$config["defaults"]["mail"]["checkbox_pos"]		= 1;	// Position of checkbox in mailbox view, 1=before subject column 
$config["defaults"]["mail"]["strike_deleted"]	= 1;	// 1=strike through deleted mails

// Defaults pertaining to the contacts feature
$config["defaults"]["contacts"]["sortby"]		= "nickname";	// Default sort order (nickname|name|company|group|email)
$config["defaults"]["contacts"]["sortorder"]	= 1;			// Default sort direction (0|1)
$config["defaults"]["contacts"]["dgroup"]		= "";			// Default group to add new items to (the group must alreay exist)
$config["defaults"]["contacts"]["pagesize"]		= 20;			// Default number of items to display in the main list
$config["defaults"]["contacts"]["viewgrp"]		= "*";			// Default group to display in the feature (*=All|0=Unfiled)
$config["defaults"]["contacts"]["tooltips"]		= 1;			// Show tooltips 
$config["defaults"]["contacts"]["dformat"]		= 0;			// pre-foramatted text for description
$config["defaults"]["contacts"]["descrwords"]	= 9999;			// number of description words shown in list view 

// Defaults pertaining to the schedule feature
$config["defaults"]["schedule"]["dgroup"]					= "";	// Default group to add new items to (the group must alreay exist)
$config["defaults"]["schedule"]["viewgrp"]					= "*";	// Default group to display in the feature (*=All|0=Unfiled)
$config["defaults"]["schedule"]["grid"]						= 0;	// Show grid in yearly view = 1
$config["defaults"]["schedule"]["tooltips"]					= 1;	// Show tooltips in all calendar views
$config["defaults"]["schedule"]["extended_monthly_view"]	= 1;	// show 3 monthes + full daily view in 'Monthly view screen'
$config["defaults"]["schedule"]["pagesize"]					= 20;	// Default number of items to display in the view list screen
$config["defaults"]["schedule"]["dformat"]					= 0;	// pre-foramatted text for description
$config["defaults"]["schedule"]["descrwords"]				= 9999;	// number of description words shown in list view 

// Defaults pertaining to the documents feature
$config["defaults"]["files"]["sortby"]		= "item";	// Default sort order 
$config["defaults"]["files"]["sortorder"]	= 1;		// Default sort direction (0|1)
$config["defaults"]["files"]["dgroup"]		= "";		// Default group to add new items to (the group must alreay exist)
$config["defaults"]["files"]["pagesize"]	= 20;		// Default number of items to display in the main list
$config["defaults"]["files"]["viewgrp"]		= "*";		// Default group to display in the feature (*=All|0=Unfiled)
$config["defaults"]["files"]["dformat"]		= 0;		// pre-foramatted text for description
$config["defaults"]["files"]["descrwords"]	= 9999;		// number of description words shown in list view 
$config["defaults"]["files"]["dperms"]    = 1;        // default permission 'change'

// Defaults pertaining to the todo feature
$config["defaults"]["todo"]["sortby"]		= "priority";	// Default sort order (item|group|priority)
$config["defaults"]["todo"]["sortorder"]	= 1;			// Default sort direction (0|1)
$config["defaults"]["todo"]["dgroup"]		= "";			// Default group to add new items to (the group must alreay exist)
$config["defaults"]["todo"]["priority"]		= 0;			// Default priorty to set new items to
$config["defaults"]["todo"]["pagesize"]		= 20;			// Default number of items to display in the main list
$config["defaults"]["todo"]["viewgrp"]		= "*";			// Default group to display in the feature (*=All|0=Unfiled)
$config["defaults"]["todo"]["duetype"]		= 0;			// Default due date type for items (0=Never|1=date|2=date/time)
$config["defaults"]["todo"]["dformat"]		= 0;			// pre-foramatted text for description
$config["defaults"]["todo"]["descrwords"]	= 9999;			// number of description words shown in list view 

// Defaults pertaining to the notes feature
$config["defaults"]["notes"]["sortby"]		= "item";		//  Default sort order (item|group)
$config["defaults"]["notes"]["sortorder"]	= 1;			// Default sort direction (0|1)
$config["defaults"]["notes"]["dgroup"]		= "";			// Default group to add new items to (the group must alreay exist)
$config["defaults"]["notes"]["width"]		= 80;			// Default number of columns wide to make the text field
$config["defaults"]["notes"]["height"]		= 24;			// Default number of rows long to make the text field
$config["defaults"]["notes"]["pagesize"]	= 10;			// Default number of items to display in the main list
$config["defaults"]["notes"]["viewgrp"]		= "*";			// Default group to display in the feature (*=All|0=Unfiled)
$config["defaults"]["notes"]["dformat"]		= 0;			// pre-foramatted text for description
$config["defaults"]["notes"]["descrwords"]	= 9999;			// number of description words shown in list view 

// Defaults pertaining to the bookmarks feature
$config["defaults"]["bookmarks"]["sortby"]		= "item";	// Default sort order (item|group|url)
$config["defaults"]["bookmarks"]["sortorder"]	= 1;		// Default sort direction (0|1)
$config["defaults"]["bookmarks"]["dgroup"]		= "";		// Default group to add new items to (the group must alreay exist)
$config["defaults"]["bookmarks"]["pagesize"]	= 20;		// Default number of items to display in the main list
$config["defaults"]["bookmarks"]["viewgrp"]		= "*";		// Default group to display in the feature (*=All|0=Unfiled)
$config["defaults"]["bookmarks"]["fullurl"]		= 0;		// Show full path of URL
$config["defaults"]["bookmarks"]["dformat"]		= 0;		// pre-foramatted text for description
$config["defaults"]["bookmarks"]["descrwords"]	= 9999;		// number of description words shown in list view 

?>
