<?php if ( $HTTP_SERVER_VARS["PHP_SELF"] != $config["basedir"] . "/index.php" ) {exit;}; ?>
<?php	// TWIG		Commonly used functions.	?>
<?php

if( !$included["common.inc.php"] ) 
	{
	Function timedebug_start ( $string )
		{
		GLOBAL $tdbg_start;
		STATIC $cnt=0;
		$tdbg_start[$cnt]["info"] = $string;
		$tdbg_start[$cnt]["time"] = getmicrotime();
		return $cnt++;
		}

	if ($config["tdbg"]) $common_inc_tdbg=timedebug_start ("TOTAL common.inc.php");

	Function timedebug_stop ( $id )
		{
		GLOBAL $tdbg_stop;
		$tdbg_stop[$id] =  getmicrotime();
		}

	Function timedebug_table ()
		{
		GLOBAL $config, $tdbg_start, $tdbg_stop;
		$k=count($tdbg_start);
		if ($k<1) return;
		echo "<table border=1 cellpadding=3 cellspacing=0>";
		for ( $i=0; $i<$k; $i++)
			{
				echo "<tr><td valign=center align=right><tt>";
				//ADMIN ++ ADDED (htmlentities -> TWIGhtmlentities)
				echo nl2br( TWIGhtmlentities($tdbg_start[$i]["info"] ) );
				echo "</tt></td><td valign=center align=right><tt>";
				printf ("%7.4f", ($tdbg_stop[$i] -  $tdbg_start[$i]["time"]) );
				echo "</tt></td></tr>";
			}
		echo "</table>";
		}


	Function TWIGGoToFeature( $GoToFeature )
		{
		GLOBAL $context;

   		$gtfeature = unserialize( URLDecode( stripslashes( $GoToFeature ) ) );

		$context["feature"] = $gtfeature["command"];
		$context["action"] = $gtfeature["action"];
		$context["options"] = $gtfeature["options"];
		}

 	Function TWIGPrintError( $string ) 
		{
		GLOBAL $TWIGphrase;

		if( !$TWIGphrase["Error"] ) { $TWIGphrase["Error"] = "Error"; }

  		echo "<b>" . $TWIGphrase["Error"] . "</b>: <i>$string</i><br>\n";
 		}

	Function TWIGDebug( $string, $level = 10 )
		{
		GLOBAL $config;

		if( $level < 1 ) { $level = 1; }

		if( $config["debug"] >= $level ) { echo "<font color=\"#FF0000\"><b>DEBUG:</b>" . $string . "</font><BR>\n"; flush(); }
		}

 	// Create link with some status info
 	Function TWIGLink( $text="", $feature="", $action="", $params="", $target="", $sother = "", $cother = "" , $font="", $tooltip="") 
		{
  		GLOBAL $config;
  		
		TWIGDebug( "TWIGLink( \"" . $text . "\", \"" . $feature  . "\", \"" . $action . "\", \"" . $params . "\", \"" . $target . "\" );", 30 );

		if ($font)
			{
			$text = "<font .$font>" . $text . "</font>";
			}
  		$str .= $config["baseurl"] . "?ts=" . TWIGbaseconvert(md5(uniqid(getmypid(),TRUE)), 16, 36);	// Make each URL unique 
  		$str .= TWIGSession( "get", $sother );
		$str .= TWIGContext( "get", $feature, $action, $cother );
  		if( $params ) { $str .= "&" . $params; }

		if( $tooltip )
			{
			$tooltip="TITLE=\"" . $tooltip . "\" ALT=\"$tooltip\"";
			}
 		return "<a $tooltip href=\"$str\" $target>$text</a>";
 		}

 	Function TWIGMailto( $address, $fullname = "" , $expandhost=1, $checklocal=0, $showaddress=0) 
		{
  		GLOBAL $config;
  		
		TWIGDebug( "TWIGMailto( \"" . $address. "\" );", 30 );

		if( !$address ) { $address = $config["defaults"]["mail"]["fromaddress"]; }

		if ( $checklocal && ( !strstr( $address, "@" ) || preg_match ("/@".$config["fromdomain"]."$/", $address ) ))
			{
			if ( !isset($config["localuser"][preg_replace ("/@.*$/", "", $address)]) )
				{
					return "$fullname ";
				}
			}

		if( !strstr( $address, "@") && $expandhost ) { $address .= "@" . $config["fromdomain"]; }

		if( acl( "w", "mail" ) ) // ACL send mail
			{
			if( $fullname )
				{
				$email = twigLink( $showaddress ? $address : $fullname, "mail", "compose", "form[to]=" . URLEncode( "\"" . $fullname . "\" <" . $address . ">" ) ) . "&nbsp;";
				}
			else
				{
				$email = twigLink( $address, "mail", "compose", "form[to]=" . URLEncode( "<" . $address . ">" ) ) . "&nbsp;";
				}
			}
		else
			{
			if( $fullname )
				{
				$email = "$fullname&nbsp;";
				}
			else
				{
				$email = "$address&nbsp;";
				}
			}

 		return $email;
 		}

	Function Permissions ($id, $table, $owner, $member, $member_with_write_perms)
	{
		GLOBAL $dbconfig, $login;
		$username = ($table == $dbconfig["groups_table"]) ? "owner" : "username"; // for groups
		$query="SELECT * FROM " . $table . " WHERE id = '" . $id . 
			"' AND ($username='" . $login["username"] ."' OR permtype=1 OR permtype=2)";
		$result=dbQuery( $query );
		if ( dbNumRows( $result ) == 0 ) return $member;
		$data = dbResultArray($result, 0);
		if( $data["username"] == $login["username"] ) return $owner;
		if( $data["permtype"] > 0 ) return $member_with_write_perms;
		return $member;
	}

	Function OwnerOf ($id, $table)
	{
		GLOBAL $dbconfig, $login;
		$username = ($table == $dbconfig["groups_table"]) ? "owner" : "username"; // for groups
		$result = dbQuery( "SELECT $username FROM " . $table . " WHERE id = '" . $id . "'" );
		return dbresult( $result, 0, "$username" ) == $login["username"] || !TWIGlUserExists ($id, $table);
	}

	Function ModDelPerms ($id, $table)
	{
		GLOBAL $dbconfig, $login;
		$username = ($table == $dbconfig["groups_table"]) ? "owner" : "username"; // for groups
		$query="SELECT * FROM " . $table . " WHERE id = '" . $id . "' AND ($username='" . $login["username"] ."' OR permtype=2)";
		$result=dbQuery( $query );
		if ( dbNumRows( $result ) == 0 ) 
			{
			return FALSE;
			}
		elseif ( dbResult( $result, 0, $username) == $login["username"] || TWIGlUserExists ($id, $table) )
			{
			return TRUE;
			}
		return !TWIGlUserExists ($id, $table) && !($table==$dbconfig["contact_table"] && IsAutoContact ($id));

	}

	Function ModifyPerms ($id, $table)
	{
		GLOBAL $dbconfig, $login;
		$username = ($table == $dbconfig["groups_table"]) ? "owner" : "username"; // for groups
		$query="SELECT * FROM " . $table . " WHERE id = '" . $id . "' AND ($username='" . $login["username"] ."' OR permtype=1 OR permtype=2)";
		$result=dbQuery( $query );
		if ( dbNumRows( $result ) == 0 ) 
			{
			return FALSE;
			}
		elseif ( dbResult( $result, 0, $username) == $login["username"] || TWIGlUserExists ($id, $table) )
			{
			return TRUE;
			}
		return !TWIGlUserExists ($id, $table) && !($table==$dbconfig["contact_table"] && IsAutoContact ($id));
	}

	// return TRUE if
	// current user is not owner but has no Modify permissions
	Function ReadOnlyPerms ($id, $table)
	{
		GLOBAL $dbconfig, $login;
		$username = ($table == $dbconfig["groups_table"]) ? "owner" : "username"; // for groups
		$query="SELECT * FROM " . $table . " WHERE id = '" . $id . "' AND ($username!='" . $login["username"] ."' AND permtype=0)";
		$result=dbQuery( $query );
		if ( dbNumRows( $result ) == 0 ) 
			{
			return FALSE;
			}
		elseif ( dbResult( $result, 0, $username) == $login["username"] || TWIGlUserExists ($id, $table) )
			{
			return TRUE;
			}
		return !TWIGlUserExists ($id, $table) && !($table==$dbconfig["contact_table"] && IsAutoContact ($id));
	}

	// does logged in user has permission to access item owned by username and assigned to group gid?
	Function ReadPerms ($username, $gid)
		{
		GLOBAL $login, $dbconfig;
		$query = "SELECT * FROM " . $dbconfig["members_table"] . " WHERE username = '" . $login["username"] . "' AND groupid=$gid";
		return ( $username==$login["username"] ) 
				|| ($gid>0 && OwnerOf ($gid, $dbconfig["groups_table"] ) 
				|| ($gid>0 && dbNumRows( dbQuery( $query ) ) > 0 )
				);
		}

	// has logged in user permission to access group with id?
	Function ReadPermsGroup ( $id )
		{
		GLOBAL $login, $dbconfig;
		$query = "SELECT * FROM " . $dbconfig["members_table"] . " WHERE username = '" . $login["username"] . "' AND groupid=$id";
		return  $id == 0 
				|| ($id>0 && OwnerOf ($id, $dbconfig["groups_table"] ) 
				|| ($id>0 && dbNumRows( dbQuery( $query ) ) > 0 )
				);
		}

	Function CompanyGroupID ()
	{
		GLOBAL $dbconfig;
		$result = dbQuery( "SELECT id FROM " . $dbconfig["groups_table"] . " WHERE type='autocontacts'" );
		if ( dbNumRows ($result) == 1)
			{
			return dbresult( $result, 0, "id" );
			}
		return -1;
	}

	Function IsAutoContactsGroup ($groupid)
	{
		GLOBAL $dbconfig;
		if( $groupid == "*" || $groupid == 0 ) return FALSE;
		$result = dbQuery( "SELECT * FROM " . $dbconfig["groups_table"] . " WHERE (id = '" . $groupid . "' AND type='autocontacts')" );
		return dbNumRows( $result ) == 1;
	}

	Function IsAutoContact ($id)
	{
		GLOBAL $dbconfig;
		$result = dbQuery( "SELECT * FROM " . $dbconfig["contact_table"] . " WHERE id='" . $id . "'" );
		if ( dbNumRows( $result ) == 0 ) 
			{
			return FALSE;
			}
		$gid =  dbresult( $result, 0, "groupid" );
		return IsAutoContactsGroup ($gid);
	}


	Function TWIGCheckAdmin( $username = "" ) 
		{
		GLOBAL $config, $login;
		TWIGDebug( "TWIGCheckAdmin( \"" . $username . "\");" );
		if( !$username ) { $username = $login["username"]; }
  		return is_array( $config["admin"] ) && in_array( $username, $config["admin"]);
 		}

	Function TWIGFormatDisplayString( $s )
		{
		GLOBAL $config;
		$s=preg_replace ("/\r/", "", $s );
		//ADMIN ++ ADDED (htmlentities -> TWIGhtmlentities)
		$s=TWIGhtmlentities(  $s );
		// use preg_replace() rather than nl2br()
		// nl2br() of newer PHP versions returns "<br />, which old browsers dont understand 
		$s = preg_replace ("/  /", " &nbsp;", preg_replace( "/\n/", "<br>", $s ) );
		return $s==" " ? "&nbsp;" : $s;
		}

	Function echosc ($s)
		{
		echo TWIGFormatDisplayString( $s ); 
		}

	Function twiggi_format_description ($s, $format, $forcestrip=FALSE )
		{
		GLOBAL $config, $formstext;
		if( $format )
			{
   			$p = "<font size=" . $config["ttfontsize"] . " color=\"" . $config["celltext"] . "\"><tt><pre>";
			}
		else
			{
   			$p =  "<font $formstext>";
			}
		if ( !$config["allow_html_input"] || $forcestrip )
			{
			//ADMIN ++ ADDED (htmlentities -> TWIGhtmlentities)
			$s = nl2br( TWIGhtmlentities( strip_tags ($s) ) ); 
			}
		if( $format )
			{
   			$t =  "</pre></tt></font>";
			}
		else
			{
   			$t =  "</font>";
			}
			$s=preg_replace( "/^ /", "&nbsp;", $s );
			return "$p$s$t";
		}

	Function TWIGFormatDescription ($descr, $no_words, $format=FALSE, $islist=FALSE )
	{
		GLOBAL $config;
		$d=preg_split ("/\b/", $descr);
		$wc = count($d);
		if ( $wc > $no_words+1 && $no_words > 0)
			{
			for ($i=0, $j=$wc-1, $c=0; $i<$j && $c<$no_words; $i++, $j--)
				{
				$head .= $d[$i];
				if (preg_match ("/^\w.*\w$/", $d[$i])) { $c++;} # word!
				$tail = $d[$j] . $tail;
				if (preg_match ("/^\w.*\w$/", $d[$j])) { $c++;} # word!
				}
			$descr = $head . ( $i<$j ? ($format ? "\n[...]\n" : " [...] " ) : "" ) . $tail;
			}
		$ret .= twiggi_format_description( $descr ? $descr : " ", 
				$format,  $islist && !$config["show_html_in_lists"] );
		return $ret;
	}

	Function TWIGMassage( $str ) 
		{ // Fixes fu for things like NetPositive
  		return htmlspecialchars( str_replace( "\r", "", $str ) );
 		} 

	Function TWIGFindHtml( $string = "" ,$sep=" ") 
		{  
		GLOBAL $config, $disabled, $login;

		TWIGDebug( "TWIGFindHtml( \"" . $string . "\" );", 30 );
  
		if( !$disabled["FindHTML"] )
			{

			$bstring = trim( $string );
			$bstring = eregi_replace( "[\\]", " ", $bstring );

	                $bstring = eregi_replace( "&lt;", " ", $bstring );
        	        $bstring = eregi_replace( "&gt;", " ", $bstring );
			$bstring = eregi_replace( "&quot;"," ", $bstring );
			$bstring = str_replace( "\t", " ", $bstring );
        	        $bstring = eregi_replace( "\[", " ", $bstring );
                	$bstring = eregi_replace( "\]", " ", $bstring );
			$bstring = eregi_replace( "[<>'()*]", " ", $bstring );
			$bstring = eregi_replace( "MAILTO:", " ", $bstring );
        	        $bstring = eregi_replace( "HTTP:", " http:", $bstring );
                	$bstring = eregi_replace( "HTTPS:", " https:", $bstring );
			$bstring = eregi_replace( "FTP:", " ftp:", $bstring );   

			$string_split = split( $sep , $bstring );
   
			$fstrings["http"] = array();
			$fstrings["ftp"] = array();
			$fstrings["nohttp"] = array();
			$fstrings["noftp"] = array();
			$fstrings["mail"] = array();

			for( $i = 0, $j = sizeof( $string_split ); $i < $j; $i++ )
				{
				$csplit = trim( strtoupper( $string_split[$i] ) );
				$string_split[$i] = trim( eregi_replace( "[,.;:]$", " ", $string_split[$i] ) );

   				if( strstr( $csplit, "HTTP://" ) || strstr( $csplit, "HTTPS://" ) ) { $fstrings["http"][$string_split[$i]] = 1; }
				else if( strstr( $csplit, "FTP://" ) ) { $fstrings["ftp"][$string_split[$i]] = 1; }
				else if( strstr( $csplit, "@" ) && strstr( $csplit, "." ) ) { $fstrings["mail"][$string_split[$i]] = 1; }
				else if( eregi( "WWW\..*\..", $csplit ) ) { $fstrings["nohttp"][$string_split[$i]] = 1; }
				else if( eregi( "FTP\..*\..", $csplit ) ) { $fstrings["noftp"][$string_split[$i]] = 1; }
				}
	
			$ret = $string;
		
			while( list( $key, $val ) = each( $fstrings["http"] ) ) 
				{
				$ret = eregi_replace( eregi_replace( "[?+$]", ".", $key ), "<a href=\"" . $key . "\" target=_blank>" . $key . "</a>", $ret );
				}
	
			while( list( $key, $val ) = each( $fstrings["ftp"] ) ) 
				{
				$ret = eregi_replace( eregi_replace( "[?+$]", ".", $key ), "<a href=\"" . $key . "\" target=_blank>" . $key . "</a>", $ret );
				}

			while( list( $key, $val ) = each( $fstrings["nohttp"] ) ) 
				{
				$ret = eregi_replace( eregi_replace( "[?+$]", ".", $key ), "<a href=\"http://" . $key . "\" target=_blank>" . $key . "</a>", $ret );
				}
	
			while( list( $key, $val ) = each( $fstrings["noftp"] ) ) 
				{
				$ret = eregi_replace( eregi_replace( "[?+$]", ".", $key ), "<a href=\"ftp://" . $key . "\" target=_blank>" . $key . "</a>", $ret );
				}

				if( acl( "w", "mail" ) ) // ACL send mail
				{
				while( list( $key, $val ) = each( $fstrings["mail"] ) ) 
					{
					$key = eregi_replace( ".* ", "", $key ); 
					$ret = eregi_replace( eregi_replace( "[?+$]", ".", $key ), "<a href=\"mailto:" . $key . "\">" . $key . "</a>", $ret );
					}
                
					$ret = eregi_replace( "=[ \"]mailto:", "=\"?" . twigsession() . twigcontext( "get", "mail", "compose" ) . "&form[to]=", $ret );
                
				}
		    	return $ret;
			}
		else 
			{ 
			return $string; 
			}
		}

	Function TWIGLoadLanguageFile( $filepath, $filename, $lang )
		{
		GLOBAL $config, $TWIGphrase, $dayNamesShort, $dayNames, $monthNames;

		TWIGDebug( "TWIGLoadLanguageFile( \"" . $filepath . "\", \"" . $filename . "\", \"" . $lang . "\" );" );

		if( !$filename ) { $sep = ""; } else { $sep = "."; }

 		if( file_exists( $filepath . $filename . $sep . $lang . ".strings.php" ) ) 
   			{
			TWIGDebug( "TWIGLoadLanguageFile() - including " . $filepath . $filename . $sep . $lang . ".strings.php", 20 );
   			include( $filepath . $filename . $sep . $lang . ".strings.php" );
   			} 
		else 
			{
			TWIGDebug( "TWIGLoadLanguageFile() " . $lang . " not found - including " . $filepath . $filename . ".english.strings.php", 20 );
   			include( $filepath . $filename . $sep . "english.strings.php" );
   			}
		}

	// Takes an array and generates TWIG menus
	//
	// Menu types include:	0 - traditional TWIG text
	//			1 - Drop Down List
	//			2 - Button Bar
	//			3 - traditional TWIG secondar bar
	//			4 - vertical bullited list
	//			5 - tab list  
	//			6 - Simple list
	//			7 - Button Bar Without Text
	//
	Function TWIGGenerateMenu( &$contents, $menutype = "", $imagepath = "primary", $sother = "", $cother = "" )
		{
		global $buttonstyle, $defaulttext, $config, $disabled, $context, $TWIGphrase, $dbconfig;

		TWIGDebug( "TWIGGenerateMenu( array, array );" );

		if( !$menutype ) { $menutype = GetPref( "mstyle1", $dbconfig["global_prefs_table"], $config["defaults"]["global"]["mstyle1"] ); }

		$j = count( $contents );

		if( $j == 0 ) return NULL;

		switch( $menutype )
 			{
			case 0:
				$ret = "<font $defaulttext>";

  				for( $i = 0; $i < $j; $i++ ) 
					{
					$ret .=  twigLink( "<B>" . $contents[$i]["desc"] . "</B>", $contents[$i]["command"], $contents[$i]["action"], $contents[$i]["options"], $contents[$i]["target"], $sother, $cother ); 

					if( $i + 1 < $j ) { $ret .= " &#149; "; } 
  					}

				$ret .= "</font>";
				break;
			case 1:
			    $ret .= "<table border=0 cellpadding=0 cellspacing=0>";
				$ret .= "<form method=post>";
				$ret .= TWIGSession( "put", $sother );
				$ret .= TWIGContext( "put", "", "", $cother );
				$ret .= "<tr><td nowrap>";
				$ret .= "<font $defaulttext>";
				$ret .= $TWIGphrase["Feature"] . ": ";
				$ret .= "<SELECT name=GoToFeature>";

  				for( $i = 0; $i < $j; $i++ ) 
					{
					if( ( $imagepath == "primary" && $context["feature"] == $contents[$i]["command"] ) || 
							( $imagepath != "primary" && $context["action"] == $contents[$i]["action"]) ) 
						{ 
						$selected = "SELECTED "; 
						}
					else 
						{ 
						$selected = ""; 
						}

					$ret .=  "<option " . $selected . "value=\"" . URLEncode( serialize( $contents[$i] ) ) . "\">" . $contents[$i]["desc"] . "</option>"; 
  					}
				$ret .= "</select><input $buttonstyle type=submit value=\"" . $TWIGphrase["Go"] . "\"></font>";
				$ret .= "</td></tr></form></table>";
				break;
			case 2:
  				for( $i = 0; $i < $j; $i++ ) 
					{
					if ( $i%8 == 7  ) { $ret .="<br>";}
 					$ret .= twigLink( "<img border=1 src=\"" . $config["imgdir"] . "menus/" . $imagepath ."/" . $config["language"] . "/" . $contents[$i]["image"] . "\" border=0 title=\"" . $contents[$i]["desc"] . "\">", $contents[$i]["command"], $contents[$i]["action"], $contents[$i]["options"], $contents[$i]["target"], $sother, $cother ); 
  					}
				break;
			case 3:
				$ret = "<font face=\"" . $config["cellfont"] . "\" size=" . $config["textfontsize"] . ">";

  				for( $i = 0; $i < $j; $i++ ) 
					{
					$ret .=  twigLink( $contents[$i]["desc"], $contents[$i]["command"], $contents[$i]["action"], $contents[$i]["options"], $contents[$i]["target"], $sother, $cother ); 

					if( $i + 1 < $j ) { $ret .= " &#149; "; } 
  					}

				$ret .= "</font>";
				break;
			case 4:
				$ret = "<font $defaulttext>";
  				for( $i = 0; $i < $j; $i++ ) 
					{
					$ret .=  "&#149;&nbsp;" . twigLink( $contents[$i]["desc"], $contents[$i]["command"], $contents[$i]["action"], $contents[$i]["options"], $contents[$i]["target"], $sother, $cother ) . "<BR>\n"; 
  					}
				$ret .= "</font>";

				break;
			case 5:
				$selected = -1;

  				for( $i = 0; $i < $j; $i++ ) 
					{
					if( $context["feature"] == $contents[$i]["command"] && $context["action"] == $contents[$i]["action"]) { $selected = $i;}
					$tabcontents[$i] =  twigLink( $contents[$i]["desc"], $contents[$i]["command"], $contents[$i]["action"], $contents[$i]["options"], $contents[$i]["target"], $sother, $cother ); 
  					}
				$ret = TWIGGenerateTabs( $tabcontents, $selected );

				break;
			case 6:
				$ret = "<font $defaulttext>";
  				for( $i = 0; $i < $j; $i++ ) 
					{
					$ret .=  twigLink( $contents[$i]["desc"], $contents[$i]["command"], $contents[$i]["action"], $contents[$i]["options"], $contents[$i]["target"], $sother, $cother ); 

					if( $i + 1 < $j ) { $ret .= " &#149; "; } 
  					}
				$ret .= "</font>";

				break;
			case 7:
				$ret = "<table border=0 cellspacing=0 cellpadding=1><tr><td bgcolor=\"" . $config["cellheadcolor"] . "\">";
  				for( $i = 0; $i < $j; $i++ ) 
					{
					$tooltip="title=\"" . $contents[$i]["desc"] . "\" alt=\"" . $contents[$i]["desc"] . "\"";
					if ( $imagepath == "primary" && ($contents[$i]["action"] == "main" || $contents[$i]["action"] == "prefs") && $contents[$i]["command"] == $context["feature"] )
						{
 						$ret .= twigLink( "<img vspace=2 hspace=3 heigth=" . ($config["ntimgsize"]-4) . " width=" . ($config["ntimgsize"]-4) . "  src=\"" . $config["imgdir"] . "menus-nt/" . $imagepath ."/" . $contents[$i]["image"] . "\" border=0 $tooltip>", $contents[$i]["command"], $contents[$i]["action"], $contents[$i]["options"], $contents[$i]["target"], $sother, $cother ); 
						}
					elseif ( $contents[$i]["command"] == "schedule" && $contents[$i]["command"] == $context["feature"] && $contents[$i]["action"] == $context["action"] )
						{
 						$ret .= twigLink( "<img vspace=2 hspace=3 heigth=" . ($config["ntimgsize"]-4) . " width=" . ($config["ntimgsize"]-4) . "  src=\"" . $config["imgdir"] . "menus-nt/" . $imagepath ."/" . $contents[$i]["image"] . "\" border=0 $tooltip>", $contents[$i]["command"], $contents[$i]["action"], $contents[$i]["options"], $contents[$i]["target"], $sother, $cother ); 

						}
					else 
						{
 						$ret .= twigLink( "<img hspace=1 heigth=" . $config["ntimgsize"] . " width=" . $config["ntimgsize"] . "  src=\"" . $config["imgdir"] . "menus-nt/" . $imagepath ."/" . $contents[$i]["image"] . "\" border=0 $tooltip>", $contents[$i]["command"], $contents[$i]["action"], $contents[$i]["options"], $contents[$i]["target"], $sother, $cother ); 
						}
  					}
				$ret.= "</td></tr></table>";
				break;
			}

		return $ret;
		}

  	Function TWIGGenerateTable( &$headers, &$contents, $columns = 0, $mono="")
		{
		GLOBAL $usecss, $headtext, $celltext, $config, $img;

		TWIGDebug( "TWIGGenerateTable( array, array, \"" . $columns . "\" );" );

		if( !$columns ) { $columns = count( $headers ); }

		$fo="<font $headtext>"; // fix me
		$fc="</font>";


		$ret="";
		for( $i = 0, $j = 0; $i < $columns && $j < $columns; $j++, $i++ ) 
			{
			if( is_array( $headers[$i] ) )
				{
				if( $headers[$i]["bgcolor"] ) { $bgcolor = $headers[$i]["bgcolor"]; } else { $bgcolor = $config["cellheadcolor"]; }
				if( $headers[$i]["colspan"] ) { $colspan = " COLSPAN=" . $headers[$i]["colspan"]; $j += $headers[$i]["colspan"] - 1; } else { $colspan = ""; }
				if( $headers[$i]["align"] ) { $align = " align=" . $headers[$i]["align"]; } else { $align = ""; }
				if( $headers[$i]["valign"] ) { $valign = " valign=" . $headers[$i]["valign"]; } else { $valign = ""; }
				if( $headers[$i]["width"] ) { $width = " width=" . $headers[$i]["width"]; } else { $width = ""; }
				if( $headers[$i]["nowrap"] ) { $nowrap = " NOWRAP"; } else { $nowrap = ""; }

			  	$ret .= "<td bgcolor=\"". $bgcolor. "\"". $colspan. $width. $align. $valign. $nowrap. ">";
				$ret .= "$fo<b>". $headers[$i]["header"]. "</b>$fc</td>"; 
				}
			else
				{
				$ret .= "<td";
				if ( !$mono )
					{
					$ret .= " bgcolor=\"". $config["cellheadcolor"] . "\">$fo"; 
					}
				else
					{
					$ret .= "<font $celltext>";
					}
			  	$ret .= "<b>". $headers[$i]. "</b>$fc</td>"; 
				}
			}

		$um = "<tr bgcolor=\"$bgcolor\"><td colspan=$columns><img src=\"" 
				. $img["empty"] . "\" height=1></td></tr>\n";
		$lm = "<tr bgcolor=\"$bgcolor\"><td colspan=$columns><img src=\"" 
				. $img["empty"] . "\" height=3></td></tr>\n";

		$ret = "<table border=0 cellspacing=0 cellpadding=0 width=100%>\n$um\n<tr>$ret</tr>\n$lm"; 

		if( $usecss )
			{
			$fo="";
			$fc="";
			}
		else
			{
			$fo="<font $celltext>";
			$fc="</font>";
			}

		for( $i = 0, $j = count( $contents ), $tg=0; $i < $j; $i++, $tg++ )
			{
			if ( !$mono )
				{
				if ( $contents[$i]["nocolortoggle"] ) $tg++;
				$ret .= "<tr bgcolor=\"";
				if( $tg % 2 ) 
					{ 
					$ret .= $config["cellcoloralt"]; 
					} 
				else 
					{ 
					$ret .= $config["cellcolor"]; 
				}
				$ret .= "\">";
				}
	
			for( $k = 0, $l = 0; $k < $columns && $l < $columns; $l++, $k++ )
				{
				if( is_array( $contents[$i][$k] ) )
					{
					if( $contents[$i][$k]["bgcolor"] ) { $bgcolor = " bgcolor=\"" . $contents[$i][$k]["bgcolor"] . "\">"; } else { $bgcolor = ""; }
 					if( $contents[$i][$k]["colspan"] ) { $colspan = " COLSPAN=" . $contents[$i][$k]["colspan"]; $l += $contents[$i][$k]["colspan"] - 1; } else { $colspan = ""; }
					if( $contents[$i][$k]["align"] ) { $align = " align=\"" . $contents[$i][$k]["align"] . "\""; } else { $align = ""; }
					if( $contents[$i][$k]["valign"] ) { $valign = " valign=\"" . $contents[$i][$k]["valign"] . "\""; } else { $valign = " valign=center"; }
					if( $contents[$i][$k]["width"] ) { $width = " width=\"" . $contents[$i][$k]["width"] . "\""; } else { $width = ""; }
					if( $contents[$i][$k]["nowrap"] ) { $nowrap = " NOWRAP"; } else { $nowrap = ""; }
					if( $contents[$i][$k]["title"] ) { $title = " title=\"" . $contents[$i][$k]["title"] . "\""; } else { $title = ""; }

				  	$ret .= "<td". $bgcolor. $colspan. $width. $align. $valign. $title. $nowrap. ">$fo" . $contents[$i][$k]["contents"] . "$fc</td>";
					}
				else
					{
				  	$ret .= "<td valign=center>$fo" . $contents[$i][$k] . "$fc</td>"; 
					}
				}
		
			$ret .= "</tr>\n";
			}

		$ret .= "</table>\n"; 
		return $ret;
		}

	Function TWIGGenerateTabs( &$contents, $selected = -1 )
		{
		GLOBAL $img, $config;

		TWIGDebug( "TWIGGenerateTabs( array, \"" . $selected . "\" );" );

		if( !$config["tabcolorlight"] ) { $config["tabcolorlight"] = "#c6c6c6"; }
		if( !$config["tabcolordark"] ) { $config["tabcolordark"] = "#848484"; }

 		$tabbuffer = "<table border=0 cellpadding=0 cellspacing=0>\n";
 		$tabbuffer .= "<tr align=bottom>\n";
		
		for( $i = 0, $j = count( $contents ); $i < $j; $i++ )
			{
		 	$tabbuffer .= "<td>\n";
	  		$tabbuffer .= "<table border=0 cellpadding=0 cellspacing=0>\n";
			if( $i == $selected ) 
				{
				$tabbuffer .= "<tr height=1><td height=1 width=1><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1 width=1 bgcolor=\"#FFFFFF\"><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1 width=1 bgcolor=\"#FFFFFF\"><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1 width=1 bgcolor=\"" . $config["tabcolordark"] . "\"><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1 bgcolor=\"" . $config["tabcolordark"] . "\"><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1 width=1 bgcolor=\"" . $config["tabcolordark"] . "\"><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1 width=1 bgcolor=\"#000000\"><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1 width=1 bgcolor=\"#FFFFFF\"><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1 width=1 bgcolor=\"#FFFFFF\"><img src=\"" . $img["empty"] . "\" alt=\"\"></td></tr>\n";
				$tabbuffer .= "<tr height=1><td height=1 width=1 bgcolor=\"#FFFFFF\"><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1 width=1 bgcolor=\"#FFFFFF\"><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1 width=1 bgcolor=\"" . $config["tabcolordark"] . "\"><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1 width=1 bgcolor=\"" . $config["tabcolordark"] . "\"><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1 bgcolor=\"" . $config["tabcolordark"] . "\"><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1 width=1 bgcolor=\"" . $config["tabcolordark"] . "\"><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1 width=1 bgcolor=\"" . $config["tabcolordark"] . "\"><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1 width=1 bgcolor=\"#000000\"></td><td height=1 width=1 bgcolor=\"#FFFFFF\"><img src=\"" . $img["empty"] . "\" alt=\"\"></td></tr>\n";
				$tabbuffer .= "<tr height=20><td height=20 bgcolor=\"#FFFFFF\"><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=20 bgcolor=\"" . $config["tabcolordark"] . "\"><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=20 bgcolor=\"" . $config["tabcolordark"] . "\"><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=20 bgcolor=\"" . $config["tabcolordark"] . "\"><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td nowrap height=20 bgcolor=\"" . $config["tabcolordark"] . "\"><font face=\"" . $config["cellfont"] . "\" size=" . $config["textfontsize"] . "><b>" . $contents[$i] . "</b></font></td><td height=20 bgcolor=\"" . $config["tabcolordark"] . "\"><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=20 bgcolor=\"" . $config["tabcolordark"] . "\"><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=20 bgcolor=\"" . $config["tabcolordark"] . "\"><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=20 bgcolor=\"#000000\"><img src=\"" . $img["empty"] . "\" alt=\"\"></td></tr>\n";
				$tabbuffer .= "<tr height=4><td height=4 bgcolor=\"#FFFFFF\"><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=4 bgcolor=\"" . $config["tabcolordark"] . "\"><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=4 bgcolor=\"" . $config["tabcolordark"] . "\"><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=4 bgcolor=\"" . $config["tabcolordark"] . "\"><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=4 bgcolor=\"" . $config["tabcolordark"] . "\"><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=4 bgcolor=\"" . $config["tabcolordark"] . "\"><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=4 bgcolor=\"" . $config["tabcolordark"] . "\"><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=4 bgcolor=\"" . $config["tabcolordark"] . "\"><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=4 bgcolor=\"#000000\"><img src=\"" . $img["empty"] . "\" alt=\"\"></td></tr>\n";
				}
			else
				{
				$tabbuffer .= "<tr height=1><td height=1 width=1><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1 width=1><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1 width=1><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1 width=1><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1 width=1><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1 width=1><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1 width=1><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1 width=1><img src=\"" . $img["empty"] . "\" alt=\"\"></td></tr>\n";
				$tabbuffer .= "<tr height=1><td height=1 width=1><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1 width=1><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1 width=1><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1 width=1><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1 width=1><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1 width=1><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1 width=1><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1 width=1><img src=\"" . $img["empty"] . "\" alt=\"\"></td></tr>\n";
				$tabbuffer .= "<tr height=1><td height=1 width=1><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1 width=1><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1 width=1><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1 width=1><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1 width=1><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1 width=1><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1 width=1><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1 width=1><img src=\"" . $img["empty"] . "\" alt=\"\"></td></tr>\n";
				$tabbuffer .= "<tr height=1><td height=1 width=1><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1 width=1><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1 width=1><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1 width=1><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1 width=1><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1 width=1><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1 width=1><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1 width=1><img src=\"" . $img["empty"] . "\" alt=\"\"></td></tr>\n";
				$tabbuffer .= "<tr height=1><td height=1 width=1><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1 width=1 bgcolor=\"#FFFFFF\"><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1 width=1 bgcolor=\"#FFFFFF\"><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1 width=1 bgcolor=\"" . $config["tabcolorlight"] . "\"><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1 bgcolor=\"" . $config["tabcolorlight"] . "\"><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1 width=1 bgcolor=\"" . $config["tabcolorlight"] . "\"><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1 width=1 bgcolor=\"#000000\"><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1 width=1 bgcolor=\"#FFFFFF\"><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1 width=1 bgcolor=\"#FFFFFF\"><img src=\"" . $img["empty"] . "\" alt=\"\"></td></tr>\n";
				$tabbuffer .= "<tr height=1><td height=1 width=1 bgcolor=\"#FFFFFF\"><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1 width=1 bgcolor=\"#FFFFFF\"><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1 width=1 bgcolor=\"" . $config["tabcolorlight"] . "\"><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1 width=1 bgcolor=\"" . $config["tabcolorlight"] . "\"><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1 bgcolor=\"" . $config["tabcolorlight"] . "\"><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1 width=1 bgcolor=\"" . $config["tabcolorlight"] . "\"><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1 width=1 bgcolor=\"" . $config["tabcolorlight"] . "\"><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=1 width=1 bgcolor=\"#000000\"></td><td height=1 width=1 bgcolor=\"#FFFFFF\"><img src=\"" . $img["empty"] . "\" alt=\"\"></td></tr>\n";
				$tabbuffer .= "<tr height=20><td height=20 bgcolor=\"#FFFFFF\"><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=20 bgcolor=\"" . $config["tabcolorlight"] . "\"><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=20 bgcolor=\"" . $config["tabcolorlight"] . "\"><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=20 bgcolor=\"" . $config["tabcolorlight"] . "\"><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td nowrap height=20 bgcolor=\"" . $config["tabcolorlight"] . "\"><font face=\"" . $config["cellfont"] . "\" size=" . $config["textfontsize"] . ">" . $contents[$i] . "</font></td><td height=20 bgcolor=\"" . $config["tabcolorlight"] . "\"><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=20 bgcolor=\"" . $config["tabcolorlight"] . "\"><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=20 bgcolor=\"" . $config["tabcolordark"] . "\"><img src=\"" . $img["empty"] . "\" alt=\"\"></td><td height=20 bgcolor=\"#000000\"><img src=\"" . $img["empty"] . "\" alt=\"\"></td></tr>\n";
				}
			$tabbuffer .= "</table>\n";
 			$tabbuffer .= "</td>\n";
			}

 		$tabbuffer .= "</tr></table>\n";

		return $tabbuffer;
		}

	Function TWIGPrevNext( $currentlow, $total, $pagesize, $context, $linkoption )
	  	{
	  	GLOBAL $buttonstyle, $img, $config, $TWIGphrase, $dbconfig;

	  	if( $pagesize < 1 ) { $pagesize = 1; }
	  	if( $currentlow > $total ) { $currentlow = $total; }

	  	$currenthigh = $currentlow + $pagesize - 1;

	  	if( $currenthigh > $total ) { $currenthigh = $total; }
	  	if( $currentlow == $currenthigh ) { $current = $currentlow; } else { $current = $currentlow . " - " . $currenthigh; } 

	  	if( $currentlow > 1 )
	    		{
	    		$prevhigh = $currentlow - 1;
	    
			if( ( $currentlow - $pagesize ) > 0) { $prevlow = $currentlow - $pagesize; } else { $prevlow = 1; }

	    		if( $prevlow == $prevhigh ) { $prev = "$prevlow"; } else { $prev = $prevlow . " - " . $prevhigh; }
	    		}

	  	if( $currenthigh < $total )
	    		{
	    		$nextlow = $currenthigh + 1;
	    		$nexthigh = $currenthigh + $pagesize; 

	    		if( $nexthigh > $total ) { $nexthigh = $total; }
	    		if( $nextlow == $nexthigh ) { $next = "$nextlow"; } else { $next = $nextlow . " - " . $nexthigh; }
	    		}

	  	if( $pagesize > 1 ) 
	    		{
	    		if( ( $current + $pagesize ) > $total ) { $currentstr = $current - $total; } else { $currentstr = $current . " - " . ( $current + $pagesize - 1 ); }
	    		}

        $out = "<table border=0 cellpadding=1 cellspacing=0>\n";
        $out.= "<form action=" . $config["baseurl"] . "  method=post>\n";
        $out.= "<tr>\n<td nowrap>";
     
        // Is there a previous screen?
        if ($prev)
          {
          $out.= twigLink( "<img src=\"" . $img["prev"] . "\" border=0 align=top title=\"[$prev]\">", $context["feature"], $context["action"], "$linkoption=$prevlow" );
          }
        else
          {
          $out.= "<img src=\"" . $img["prev-none"] . "\" border=0 align=top title=\"" . $TWIGphrase["No previous screen"] . "\">";
          }
        $out.= "</td>\n";
     
     
        $out.= "<td nowrap>";
        $out.= TWIGSession( "put" );
        $out.= TWIGContext( "put" );
        $out.= "<SELECT name=$linkoption>\n";
        $selectlow = 1;
        while ($selectlow <= $total)
          {
          $selecthigh = $selectlow + $pagesize - 1;
          if ($selecthigh > $total) {$selecthigh = $total;}
          $out.= "<OPTION ";
          if (($currentlow >= $selectlow) && ($currentlow <= $selecthigh)) { $out.= "SELECTED "; }
          $out.= "value=$selectlow>$selectlow";
          if ($selectlow < $selecthigh)
            { $out.= " - $selecthigh"; }
          $out.= "</OPTION>\n";
          $selectlow = $selecthigh + 1;
          }
        $out.= "</SELECT>\n<INPUT $buttonstyle type=submit value=\"" . $TWIGphrase["Go"] . "\"></td>";
        $out .= "<td nowrap>";
     
        // Is there a next screen?
        if ($next)
          {
          $out.= twigLink("<img src=\"" . $img["next"] ."\" border=0 align=top title=\"[$next]\">", $context["feature"], $context["action"], "$linkoption=$nextlow");
          }
        else
          {
          $out .= "<img src=\"" . $img["next-none"] . "\" border=0 align=top title=\"" . $TWIGphrase["No next screen"] . "\">";
          }
     
     
        $out.= "</td></tr></FORM></table>";

	  	return $out;
	  	}

	// Function to decode a MIME-encoded string
	// Returns the original string, if not MIME
	// See rfc1522 for details
	// Unabashedly ripped from imp - anoah
	Function TWIGDecodeMimeString( $string ) 
  		{
   		GLOBAL $config;
  
		TWIGDebug( "TWIGDecodeMimeString( \"" . $string . "\" );", 30 );

  		$pos = strpos( $string, "=?" );

  		if( !is_int( $pos ) ) {	return $string;	}
  
  		$preceding = substr( $string, 0, $pos ); // save any preceding text
  
   		$end = strlen( $string );
   		$search = substr( $string, $pos+2, $end - $pos - 2 ); // the mime header spec says this is the longest a single encoded word can be

  		$d1 = strpos( $search, "?" );
  		if( !is_int( $d1 ) ) { return $string; }
  
   		$charset = strtolower(substr( $string, $pos+2, $d1 ));
  		$search = substr( $search, $d1+1 );
  
  		$d2 = strpos( $search, "?" );
  		if( !is_int( $d2 ) ) { return $string; }
  
  		$encoding = substr( $search, 0, $d2 );
  		$search = substr( $search, $d2+1 );
  
  		$end = strpos( $search, "?=" );
  		if( !is_int( $end ) ) { return $string; }
  
  		$encoded_text = substr( $search, 0, $end );
  		$rest = substr( $string, ( strlen( $preceding . $charset . $encoding . $encoded_text ) + 6 ) );
  
  		switch( $encoding ) 
			{
  			case "Q":
  			case "q":
				// the new twig way: str_replace is faster
    				$encoded_text = str_replace( "_", " ", $encoded_text );
    				$decoded = quoted_printable_decode( $encoded_text );

				// the old twig way: ereg is slower, but works in old php
    				// $encoded_text = ereg_replace( '_', ' ', $encoded_text );
    				// $decoded = quoted_printable_decode( $encoded_text );

    				break;
  			case "B":
  			case "b":
    				$decoded = urldecode( base64_decode( $encoded_text ) );

    				break;
  			default:
    				$decoded = "=?" . $charset . "?" . $encoding . "?" . $encoded_text . "?=";

    				break;
  			}

   		if( $config["globalcharset"] ) 
			{ 
  			if( $config["globalcharset"] != $charset ) 
				{
 				$from = $config["charactersets"][$charset];
				$to =  $config["charactersets"][$config["globalcharset"]];

  				if( $from && $to ) { $decoded = convert_cyr_string( $decoded, $from, $to ); }	
  				}
  			}
  
  		return $preceding . $decoded . TWIGDecodeMimeString( $rest );
		}

	Function TWIGEncodeMimeString( $string ) 
  		{
		TWIGDebug( "TWIGDecodeMimeString( \"" . $string . "\" );", 30 );
		if ( preg_match("/[\177-\377]+/", $string ) )
			{
			return  '=?ISO-8859-1?Q?' . imap_8bit( $string ) . '?=';
			}
	    return $string;		
		}

	Function TWIGProcessGPCString( $string )
		{
		global $config;

		if( !$config["GMQGPC"] ) { $config["GMQGPC"] = get_magic_quotes_gpc() + 1; }

		if( $config["GMQGPC"] == 2 )
			{
			return stripslashes( $string );
			}
		else
			{
			return $string;
			}
		}

 	Function TWIGFormatMailAdressString ($string)
		{
 		$string=preg_replace ("/INVALID_ADDRESS@\.SYNTAX-ERROR\./", ",", $string);
 		$string=preg_replace ("/ *, */", ",", $string);
 		$string=preg_replace ("/ *, *,* */", ", ", $string);
 		$string=preg_replace ("/^ *,*/", "", $string);
 		$string=preg_replace ("/,* *$/", "", $string);
		return $string;
 		}

	Function TWIGProcessGPCtoSQL( $string )
		{
		global $config;

		if( !$config["GMQGPC"] ) { $config["GMQGPC"] = get_magic_quotes_gpc() + 1; }

		if( $config["GMQGPC"] == 1 )
			{
			return addslashes( $string );
			}
		else
			{
			return $string;
			}
		}

        Function TWIGBytesToText( $size = 0 )
                {
                $ranges = array( "B", "KB", "MB", "GB", "TB" );

                if( $size == 0 ) { return "0" . $ranges[0]; }

                $range = floor( floor( log10( $size ) ) / 3 );
                $val = substr( $size / pow( 10, 3 * $range), 0, 3 );

                $ret = sprintf( "%1.0f%s", $val, $ranges[$range] );

                return $ret;
                }	

	Function TWIGdate($format, $timestamp)
		{
		GLOBAL $dayNames, $monthNames;
	
		$str = gmdate ( $format, $timestamp );
		$str = str_replace( gmdate ( "l", $timestamp ), $dayNames[gmdate ( "w", $timestamp )], $str );
		$str = str_replace( gmdate ( "F", $timestamp ), $monthNames[gmdate ( "n", $timestamp )], $str );

		return $str;
		}

	Function TWIGLocaldate($format, $timestamp)
		{
		GLOBAL $dayNames, $monthNames;
	
		$str = date ( $format, $timestamp );
		$str = str_replace( date ( "l", $timestamp ), $dayNames[date ( "w", $timestamp )], $str );
		$str = str_replace( date ( "F", $timestamp ), $monthNames[date ( "n", $timestamp )], $str );

		return $str;
		}

  	Function TWIGExecuteServerCommands( $opencon, $CmdArray )
 		{
 		$cmdtotal = count( $CmdArray );
		$fnum = 0;
 	
 		for( $cmdnum = 0; $cmdnum < $cmdtotal; $cmdnum++ )
 			{
 			if( $CmdArray[$cmdnum][0] ) { fwrite( $opencon, $CmdArray[$cmdnum][0] . "\r\n" ); }
 	
 			if( $CmdArray[$cmdnum][1] )
 				{
 				$chr = "";
 				$rstring = "";
 				while( ord( $chr ) != 10 ) 
 					{ 
 					$rstring .= $chr;
 					$chr = fgetc( $opencon );
 					}
 			
 				if( substr( $rstring, 0, strlen( $CmdArray[$cmdnum][1] ) ) != $CmdArray[$cmdnum][1] ) 
					{	
					$failures[$fnum]["sequence"] = $cmdnum;
					$failures[$fnum]["command"] = $CmdArray[$cmdnum][0];
					$failures[$fnum]["expected"] = $CmdArray[$cmdnum][1];
					$failures[$fnum]["result"] = $rstring;
					$failures[$fnum]["type"] = $CmdArray[$cmdnum][2];
						
					$fnum++;

					if( $CmdArray[$cmdnum][2] == 0 )
						{
						return $failures;
						}
					}
 				}
 			}
 	
		$failures["count"] = $fnum;

		return $failures;
 		}

	Function TWIGPrintESCErrors( $ESCErrors )
		{
		for( $i = 0; $i < $ESCErrors["count"]; $i++ )
			{
			if( $ESCErrors[$i]["type"] == 1 )
				{
				TWIGPrintError( "Warning on server command(" . $ESCErrors[$i]["sequence"] . "): " . $ESCErrors[$i]["command"] . " expected result: " . $ESCErrors[$i]["expected"] . " received result: " . $ESCErrors[$i]["result"] . " (" . substr( $ESCErrors[$i]["result"], 0, strlen( $ESCErrors[$i]["expected"] ) ) . ")" );
				}
			else
				{
				TWIGPrintError( "Error on server command(" . $ESCErrors[$i]["sequence"] . "): " . $ESCErrors[$i]["command"] . " expected result: " . $ESCErrors[$i]["expected"] . " received result: " . $ESCErrors[$i]["result"] . " (" . substr( $ESCErrors[$i]["result"], 0, strlen( $ESCErrors[$i]["expected"] ) ) . ")" );
				}
			}
		}

	Function TWIGGetTimeFormat()
		{
		GLOBAL $config, $dbconfig;

		$ret = $config["timeformat"][GetPref( "timeformat", $dbconfig["global_prefs_table"], $config["defaults"]["global"]["timeformat"] )];

		if( !$ret ) { $ret = $config["timeformat"]["12"]; }

		return $ret;
		}

	Function TWIGSetDateFormat()
		{
		GLOBAL $config, $dbconfig;

		$idx=GetPref( "dateformat", $dbconfig["global_prefs_table"], $config["defaults"]["global"]["dateformat"] );
		$config["shortdateformat"]=$config["dateformat"][$idx]["short"];
		$config["longdateformat"]=$config["dateformat"][$idx]["long"];
		}


  	Function TWIGCheckTimeFormat( $fstring )
  		{
  		GLOBAL $config;
 
  		// there should be either "h", "g", "H" or "G" in timeformat, if unsure use "am/pm" 
  
  		if( ereg( "H|G", $fstring ) ) { return 24; }
  		else { return 12; }
  		}
  
  	Function TWIGTimeSelector( $prefix, $hour, $minute )
  		{
		GLOBAL $dbconfig, $config;
		if ( GetPref( "singletimeselector", $dbconfig["global_prefs_table"], $config["defaults"]["global"]["singletimeselector"] ) )
			{
  			return TWIGTimeSelector_2( $prefix, $hour, $minute );
			}
		else
			{
  			return TWIGTimeSelector_1( $prefix, $hour, $minute );
			}
		}

  	Function TWIGTimeSelector_1( $prefix, $hour, $minute )
  		{
  		GLOBAL $config;
  
  		$timeformat = TWIGCheckTimeFormat( TWIGGetTimeFormat() );
 
  		if( $timeformat == 24 ) 
 			{ 
 			$hour_start = 0; 
 			$hour_end = 23; 
 			}
  		else
  			{
  			$hour_start=1;
  			$hour_end=12;
 
  			if( $hour > 11 )
  				{
  				$hour -= 12;
  				$ampm = "PM";
  				}
  			else 
 				{ 
 				$ampm = "AM"; 
 				}
 
  			if( $hour == 0 ) { $hour = 12; }
  			}
  			
  		$hour_str = "<select name=\"" . $prefix . "Hour\">\n";
  
  		for( $i = $hour_start; $i <= $hour_end; $i++ )
  			{
  			if( $hour == $i ) { $hour_str .= "<option selected>" . $i . "</option>";}
  			else { $hour_str .= "<option>" . $i . "</option>"; }
  			}
 
  		$hour_str .= "\n</select>";
  
  		$min_str = "<select name=\"" . $prefix . "Minute\">\n";
 
  		for( $i = 0; $i < 60; $i += 5 )
  			{
  			$min = $i;
 
  			if( $min < 10 ) { $min = "0" . $min; }
 
  			if( $minute == $min) { $min_str .= "<option selected>" . $min . "</option>";}
  			else { $min_str .= "<option>" . $min . "</option>"; }
  			}
 
  		$min_str .= "\n</select>\n";
  
  		if( $timeformat == 12 )
  			{
  			$ampm_str = "<select name=\"" . $prefix . "AMPM\">";
 
  			if( $ampm == "AM" ) { $ampm_str .= "<option selected>AM</option>\n<option>PM</option>\n"; }
  			else { $ampm_str .= "<option>AM</option>\n<option selected>PM</option>\n"; }
 
  			$ampm_str .= "</select>\n";
  			}
  		else 
 			{ 
 			$ampm_str = ""; 
 			}
  
  		return $hour_str . "<b>:</b>\n" . $min_str . $ampm_str;
  		}
 
  	Function TWIGTimeSelector_2( $prefix, $hour, $minute )
  		{
  		GLOBAL $config;
  
  		$timeformat = TWIGCheckTimeFormat( TWIGGetTimeFormat() );
 
  		if( $timeformat == 24 ) 
 			{ 
 			$hour_start = 0; 
 			$hour_end = 23; 
 			}
  		else
  			{
  			$hour_start=1;
  			$hour_end=12;
 
  			if( $hour > 11 )
  				{
  				$hour -= 12;
  				$ampm = "PM";
  				}
  			else 
 				{ 
 				$ampm = "AM"; 
 				}
 
  			if( $hour == 0 ) { $hour = 12; }
  			}
  			
  		$time_str = "<select name=\"" . $prefix . "HourMinute\">\n";
  
  		for( $i = $hour_start; $i <= $hour_end; $i++ )
  			{
  			for( $k = 0; $k < 60; $k += 5 )
  				{
				$s=sprintf ("%02d:%02d", $i, $k);
  				if( $hour == $i && $minute == $k ) 
					{ 
					$time_str .= "<option selected>" . $s . "</option>";
					}
  				else 
					{ 
					$time_str .= "<option>" . $s . "</option>"; 
					}
				}
  			}
 
  		$time_str .= "\n</select>";
  
  
  		if( $timeformat == 12 )
  			{
  			$ampm_str = "<select name=\"" . $prefix . "AMPM\">";
 
  			if( $ampm == "AM" ) { $ampm_str .= "<option selected>AM</option>\n<option>PM</option>\n"; }
  			else { $ampm_str .= "<option>AM</option>\n<option selected>PM</option>\n"; }
 
  			$ampm_str .= "</select>\n";
  			}
  		else 
 			{ 
 			$ampm_str = ""; 
 			}
  
  		return $time_str . $ampm_str;
  		}


	Function DaySelector($fields, $day )
		{
   		GLOBAL $config, $TWIGphrase, $monthNames;
		if( $fields["day"] ) 
			{
	    		$ret = "<SELECT name=" . $fields["day"] . ">\n";
        
      			for( $i = 1; $i <= 31; $i++ )
        				{
        				$ret .= "<option ";
		       			if( $day == $i ) 
							{
							if ( $fields["eq_day"] == TRUE)
								{
								$ret .= "value=\"=\" selected>=</option><option ";
								}
							else
								{
								$ret .= "selected "; 
								}
							}
        				$ret .= "value=" . $i . ">" . $i . "</option>";
        				}
    
	 		$ret .= "</SELECT>\n";
 			}
			return $ret;
		}

	Function MonthSelector($fields, $month )
		{
   		GLOBAL $config, $TWIGphrase, $monthNames;
		if( $fields["month"] ) 
			{
	      		$ret = "<SELECT name=" . $fields["month"] . ">\n";
      
 			for( $i = 1; $i <= 12; $i++ )
        				{
        				$ret .= "<option ";
        				if( $month == $i )
							{
							if ( $fields["eq_month"] == TRUE)
								{
								$ret .= "value=\"=\" selected>=</option><option ";
								}
							else
								{
								$ret .= "selected "; 
								}
							}
	        			$ret .= "value=" . $i . ">" . $monthNames[$i] . "</option>\n";
        				}
        
 			$ret .= "</SELECT>\n";
			return $ret;
 			}
		}


   	Function TWIGDateSelector( $fields, $year, $month, $day)
   		{
   		GLOBAL $config, $dbconfig, $TWIGphrase, $monthNames;

 
 		if( !is_array( $fields ) ) { $fields = array( "year"=>"thisYear", "month"=>"thisMonth", "day"=>"thisDay" ); }
 
 		if (GetPref( "dateformat", $dbconfig["global_prefs_table"], $config["defaults"]["global"]["dateformat"] )==1)
			{
 			$ret .= DaySelector( $fields ,$day );
 			$ret .= MonthSelector( $fields, $month  );
			}
		else
			{
 			$ret .= MonthSelector( $fields, $month );
 			$ret .= DaySelector( $fields ,$day);
			}


		if( $fields["year"] ) 
			{
	    		$ret .= "<SELECT name=" . $fields["year"] . ">\n";
 	
      			for( $i = $year - 10, $j = $year + 10; $i < $j; $i++ )
        				{
        				$ret .= "<option ";
        				if( $year == $i ) 
							{ 
							if ( $fields["eq_year"] == TRUE )
								{
								$ret .= "value=\"=\" selected>=</option><option ";
								}
							else
								{
								$ret .= "selected "; 
								}
							}
	        			$ret .= "value=" . $i . ">" . $i . "</option>\n";
        				}
 
    			$ret .= "</SELECT>\n";
 			}

 		return $ret;
 		}

Function TWIGSearchDBSelector ($xfilter, $xfilterstring, $fopts, $text1="", $text2="", $gobutton=TRUE, $resetbutton=TRUE)
	{
	GLOBAL $TWIGphrase, $config, $buttonstyle, $context, $filter, $filterstring;
	$ret  = "<table border=0 cellpadding=0 cellspacing=0><tr>";
	$ret .= "<td nowrap valign=center>";
	$ret .= "<font face=\"" . $config["cellfont"] . "\" size=" . $config["textfontsize"] . ">";
	$ret .= "$text1&nbsp;";
	$ret .= "</font>";
	$ret .= "</td>";
	$ret .= "<td nowrap valign=center>";
	$ret .= "<input type=text size=10 name=\"filterstring[". $context["feature"] . $context["action"] . "]\" value=\"" . $filterstring[$context["feature"] . $context["action"]] . "\">";
	$ret .= "</td>";
	$ret .= "<td nowrap valign=center>";
	$ret .= "<font face=\"" . $config["cellfont"] . "\" size=" . $config["textfontsize"] . ">";
	$ret .= "&nbsp;$text2&nbsp;";
	$ret .= "</font>";
	$ret .= "</td>";
	$ret .= "<td nowrap valign=center>";
	$ret .="<select name=\"filter[". $context["feature"] . $context["action"] . "]\">";
	while ( list( $k, $v ) = each ( $fopts ) )
	   {
	   $selected = $filter[$context["feature"] . $context["action"]] == $k ? " selected" : "";
	   $ret .= "<option value=\"$k\"$selected>$v</option>"; 
	   }
	$ret .= "</select>";
	$ret .= "</td>";
	$ret .= "<td nowrap valign=center>";
	if ( $gobutton )
		{
		$ret .= "<input $buttonstyle type=submit name=newsearch value=\"" . $TWIGphrase["Go"] . "\">";
		}
	if ( $resetbutton )
		{
		$ret .= "&nbsp;<input $buttonstyle  title=\"" . $TWIGphrase["Reset search"] . "\"type=submit name=resetfilter value=\"C \">";
		}
	$ret .= "</td></tr></table>";
	return $ret;
	}

Function TWIGSearchDBQuery () 
	{
	GLOBAL $session, $context, $filter, $filterstring, $resetfilter, $patternquery;
	$idx=$context["feature"] . $context["action"];
	if ( $resetfilter )
		{
		$filter[$idx]="";
		$filterstring[$idx]="";
		}
	if ( isset( $filter[$idx] ) )
	   {
	   $session[$context["feature"] . $context["action"] . "filter"]=$filter[$idx];
	   }
	else
	   {
	   $filter[$idx]=$session[$context["feature"] . $context["action"] . "filter"];
	   }

	if ( isset( $filterstring[$idx] ) )
	   {
	   $session[$context["feature"] . $context["action"] . "filterstring"]=$filterstring[$idx];
	   }
	else
	   {
	   $filterstring[$idx]=$session[$context["feature"] . $context["action"] . "filterstring"];
	   }
	$filterstring[$idx]=trim(strtolower($filterstring[$idx]));

	if ( $filterstring[$idx] != "" && $filter[$idx]!="NONE" )
		{
		$pat=SQLString($filterstring[$idx]);
		$patternquery=" AND ( " . preg_replace ("/:/", " LIKE '%$pat%' OR ", $filter[$idx]) . " LIKE '%$pat%' )";
		}
	}


Function TWIGPermsSelector ($name, $default, $owner=TRUE, $options=NULL )
	{
	GLOBAL $perms_text;
	$ret = "<select name=$name>\n";
	$i=0;
	while (TWIGGetPermsText($i))
		{
		if( ($owner || $i==$default) && ( !is_array( $options) || $options[$i] ) )
			{
			$selected= ($i==$default) ? "SELECTED" : "";
			$ret .= "<option value=$i $selected>" . TWIGGetPermsText($i) . "</option>\n";
			}
		$i++;
		}
	$ret .= "</select>\n";
	return $ret;
	}

Function TWIGGetPermsText ($type)
	{
	GLOBAL $perms_text, $TWIGphrase;
	$perms_text=array(
		$TWIGphrase["Read only"], 
		$TWIGphrase["Update"], 
		$TWIGphrase["Update and delete"], 
	//	$TWIGphrase["User defined"],
	);
	return $perms_text[$type];
	}

Function TWIGGenerateViewTitle ($title, $data, $newitem=FALSE, $alt="&nbsp;")
	{
	GLOBAL $TWIGphrase, $config;
	$cdate=convertSQLTimetoUTime($data["cdate"]);
	$thedate=convertSQLTimetoUTime($data["thedate"]);
	if ($cdate<=0) {$cdate=$thedate;}
	$username = $data["username"] ? $data["username"] : $data["owner"]; // for groups feature!
	$cuser=$data["cuser"];
	if (!$cuser) {$cuser=$username;}

   	echo "<table width=100% border=0 cellspacing=0 cellpadding=5><tr>";
  	echo "<td width=1% bgcolor=\"" . $config["cellheadcolor"] . "\" valign=top align=left nowrap>";
   	echo "<font face=\"" . $config["cellfont"] . "\" size=" .  $config["titlefontsize"] . " color=\"" . $config["cellheadtext"] . "\">";
    echo "<b>" . $title . "</b>";
   	echo "</font>";
   	echo "</td>";
	echo "<td width=99% bgcolor=\"" . $config["cellcolor"] . "\" valign=top align=left nowrap>";
	echo "<font face=\"" . $config["cellfont"] . "\" size=" . $config["textfontsize"] . " color=\"" . $config["celltext"] . "\">";
	if (!$newitem)
		{
		echo $TWIGphrase["Added by"] . "&nbsp;";
		//ADMIN ++ ADDED (htmlentities -> TWIGhtmlentities)
		echo TWIGMailto( $username, TWIGhtmlentities ( TWIGGetRealname( $username ) ), 1, 1 );
		echo $TWIGphrase["on"] . "&nbsp;";
		echo TWIGdate( $config["shortdateformat"] . ", " . TWIGGetTimeFormat(), $cdate);
		if ($cuser!=$username || $cdate!=$thedate)
			{
			echo "<br>";
			echo $TWIGphrase["Modified by"] . "&nbsp;";
			//ADMIN ++ ADDED (htmlentities -> TWIGhtmlentities)
			echo TWIGMailto( $cuser, TWIGhtmlentities ( TWIGGetRealname( $cuser ) ), 1, 1 );
			echo $TWIGphrase["on"] . "&nbsp;";
			echo TWIGdate( $config["shortdateformat"] . ", " . TWIGGetTimeFormat(), $thedate);
			}
		}
	else
		{
		echo "<b>" . $alt . "</b>";
		}
	echo "</font>";
	echo "</td></tr></table>";
	}

Function TWIGGetRealname ($user) 
	{
	GLOBAL $config, $TWIGphrase;
	if ($user=="twiggi groupware") { return $user; } // pseudo user for autocontacts feature
	return isset($config["localuser"][$user]) 
		? 
		$config["localuser"][$user] 
		: 
		$TWIGphrase["Unkown"] . ($user ? " (". $TWIGphrase["formerly"] . " <$user>)" : "" );
}

Function TWIGGetRealnameLF ($user) 
	{
	$s =  preg_replace( "/^(.* )(.*)$/", "\\2, \\1", TWIGGetRealname( $user ) );
	return $s;
	}

Function TWIGFormatUsername ($user) {
	GLOBAL $config;
	//ADMIN ++ ADDED (htmlentities -> TWIGhtmlentities)
	return isset($config["localuser"][$user]) ? TWIGhtmlentities( "<" . $user . ">" ) : "&nbsp;";
}

Function make_uniq_item ($table, $id, $groupid, $item, $moveaction=FALSE)
{
	GLOBAL $dbconfig, $TWIGphrase, $login;
	if( !$groupid ) { $groupid=0; }
	$ext=2;
	$old_item=$item;
	$item = trim($item);
	$item = ereg_replace ("--[0-9]+$", "", $item);
	if ( $item == "" ) { $item=$TWIGphrase["[no name]"];}

	if ( $table == $dbconfig["groups_table"] )
		{
		$gq="";
		$icol="groupname";
		}
	else 
		{
		$icol="item";
		if ( $table == $dbconfig["contact_table"] )
			{ // item names of contacts must be uniq, even if they belong to different groups
			if ( $moveaction )
				{
				return $old_item; // cancel, check not needed
				}
			$gq=" AND " . TWIGGroupsCreateSQLGroupQuery( $login["username"], array_merge ( TWIGGroupsMembership( $login["username"] ), $groupsO = TWIGGroupsOwnership( $login["username"] ) ) );
			// replace RFC822 special characters by underscore
			$item = preg_replace ("/[()<>@,;:\\\"\.\[\]]/", "_", $item);
			}
		elseif( $groupid<0 )
			{
			$gq="";
			}
		else
			{
			$gq=" AND groupid='" . $groupid . "' ";
			}
		}

	$new_item=$item;
	$flag=1;
	while ($flag) 
		{
		$query = "SELECT id,$icol FROM $table WHERE ( $icol = '" . SQLString ($new_item) . "' $gq )";
		$result = dbQuery( $query );
 	 	for( $i = 0, $j = dbnumrows( $result ), $flag=0; ($i < $j) && !$flag; $i++ )
			{
			$data = dbResultArray( $result, $i );
			$data[$icol] = trim ( $data[$icol] );
			if (strtolower($data[$icol]) == strtolower($new_item) && $data["id"] != $id)
				{
					$new_item=$item . "--$ext";
					$ext++;
					$flag=1;
				}

			}
	}
	return $new_item;
}

Function TWIGToDoStatus( $data )
	{
	switch( $data["completed"] )
		{
		case 1:
			$status = "Complete";
			break;
		case 2:
			$status = "Working";
			break;
		case 3:
			$status = "Pending";
			break;
		case 4:
			$status = "Canceled";
			break;
		default:
			$status = "not started";
			break;
		}

	return $status;
	}

Function TWIGisLocalUser ( $user ) {
	GLOBAL $config;
	return isset($config["localuser"][$user]) || $user=="twiggi groupware";
}

Function TWIGlUserExists ($id, $table)
{
	GLOBAL $dbconfig, $login;
	$username = ($table == $dbconfig["groups_table"]) ? "owner" : "username"; // for groups
	$result = dbQuery( "SELECT $username FROM " . $table . " WHERE id = '" . $id . "'" );
	return dbNumRows($result)>0 && TWIGisLocalUser( dbresult( $result, 0, "$username" ) );
	
}

Function decode_qp ($str) {
	return imap_qprint (preg_replace ("/=[?](?:.*?)Q[?](.*?)[?]=/", "\\1", $str));
}

Function TWIGItemUpdateOwner( $id , $table, $newowner )
	{
	$query = "UPDATE " . $table . " SET username='$newowner' WHERE id=" . $id;
	$return = dbQuery( $query );
	}

Function TWIGGetMailDate( $headers )
	{
	GLOBAL $config;
	if ( $config["fix_imap_maildir_date_bug"] == TRUE )
		{
		// use headerfield Delivery-date: if present
		if ( $headers->DeliveryDate )
			{
			// try to fix bad date formats
			$date=strtotime(preg_replace( "/^(.*?[0-9][0-9]:[0-9][0-9]:[0-9][0-9]) 0000/", "\\1 -0000", $headers->DeliveryDate ) );
			}
		else // otherwise use Date:
			{
			// try to fix bad date formats
			$date=strtotime(preg_replace( "/^(.*?[0-9][0-9]:[0-9][0-9]:[0-9][0-9]) 0000/", "\\1 -0000", $headers->date ) );
			}
		}
	else
		{
		// internal date / unix timestamp
		$date = $headers->udate;
		}

	return $date;
	}

Function TWIGAttachmentToolTip ( $parts )
	{
	GLOBAL $TWIGphrase;
	if( $parts ) 
		{ 
		$tta=$TWIGphrase["attachment"];
		for ( $a=1; $a<count ($parts); $a++ )
			{
			if ( $parts[$a]->parameters[0]->attribute == "NAME" )
				{
				$tta .= "&#10 " . TWIGDecodeMimeString ($parts[$a]->parameters[0]->value );
				}
			else
				{
				$tta .= "&#10 " . $TWIGphrase["[no name]"];
				}
			}
		}
	return $tta;
	}

Function GetUploadDir ()
	{
	GLOBAL $login;
	// system upload directory
	$upload_tmp_dir = get_cfg_var("upload_tmp_dir");
	if ( empty( $upload_tmp_dir ) ) {$upload_tmp_dir="/tmp";}
	// twiggi's users specific upload directory
	$uldir="$upload_tmp_dir/twiggi" ;
	if ( !is_dir($uldir) ) {mkdir( $uldir, 0700 );}
	$uldir .= "/" . $login["username"];
	if ( !is_dir($uldir) ) {mkdir( $uldir, 0700 );}
	return $uldir;
	}

Function CleanupUploadDir ( $uldir )
	{
	GLOBAL $config;
	// remove all file older than 24h
	$ATT=opendir ($uldir);
	$yesterday=mktime()-86400;
	$done=FALSE;
	while ( $f=readdir( $ATT ) )
		{
			if ( is_file("$uldir/$f") && preg_match ("/\.att$/", $f) )
				{
					$ctime=filectime("$uldir/$f");
					if ( $ctime < $yesterday )
						{
						unlink ("$uldir/$f");
						$done=TRUE;
						}
					else
						{
						$ufc[$ctime]["name"] = "$uldir/$f";
						$ufc[$ctime]["size"] = filesize( "$uldir/$f" );
						$total_ul += $ufc[$ctime]["size"];
						}
				}
		}

	// if upload limit is exeeded, remove old files silently
	if ( isset( $ufc ) )
		{
		ksort( $ufc );
		while ( $total_ul > $config["upload_limit_in_meg"]*1048576 && list( $t, $f )=each( $ufc ) )
			{
			unlink ($f["name"]);
			$total_ul -= $f["size"];
			$done=TRUE;
			}
		}
	return $done;
	}

Function GetmaxUploadSize ()
	{
	 $ranges = array( "B"=>1, "K"=>1e3, "M"=>1e6, "G"=>1e9, "T"=>1e12 );
	 $upload_max_filesize=get_cfg_var("upload_max_filesize");
	 if (empty($upload_max_filesize)) {$upload_max_filesize="2M";}
	 $mult=$ranges[preg_replace("/.*([BKMG])$/", "\\1", $upload_max_filesize)];
	 if (empty($mult)) {$mult=1;}
	 $upload_max_filesize=preg_replace("/[BKMG]$/","", $upload_max_filesize)*$mult;
	 $post_max_size=get_cfg_var("post_max_size");
	 if (empty($post_max_size)) {$post_max_size="8M";}
	 $mult=$ranges[preg_replace("/.*([BKMG])$/", "\\1", $post_max_size)];
	 if (empty($mult)) {$mult=1;}
	 $post_max_size=preg_replace("/[BKMG]$/","", $post_max_size)*$mult;
	 return $upload_max_filesize < $post_max_size ? $upload_max_filesize : $post_max_size;
	}

Function GetCacheDir ()
	{
	GLOBAL $login;
	$upload_tmp_dir = get_cfg_var("upload_tmp_dir");
	if ( empty( $upload_tmp_dir ) ) {$upload_tmp_dir="/tmp";}
	$cachedir = "$upload_tmp_dir/twiggi/" . $login["username"] . "/cache";
	if ( !is_dir($cachedir) ) 
		{
		$c=explode("/", $cachedir);
		$cachedir = "/";
		for ( $i=0; $i<count ($c) ; $i++)
			{
			$cachedir .= $c[$i] . "/";
			if ( !is_dir($cachedir) ) mkdir( $cachedir, 0700 );
			}
		}
	return $cachedir;
	}


if ($config["tdbg"]) timedebug_stop ($common_inc_tdbg);

	$included["common.inc.php"] = 1;
	}

$javascript_enabled=TRUE;
Function javascript ()
	{
	GLOBAL $javascript_enabled, $config, $dbconfig, $disabled;

	if( $javascript_enabled && !$disabled["javascript"] && GetPref( "javascript", $dbconfig["global_prefs_table"], $config["defaults"]["global"]["javascript"] ) )
		{
		$javascript_enabled=TRUE;
		}
	else
		{
		$javascript_enabled=FALSE;
		}
	return $javascript_enabled;

	}



/*
http://px.sklar.com/code.html?code_id=63
By: Richard Lynch <lynch@lscorp.com>
*/
	function textwrap($text, $wrap=80, $break='<BR>\n'){
		$len = strlen($text);
		if ($len > $wrap){
			$h = '';
			$lastWhite = 0;
			$lastChar = 0;
			$lastBreak = 0;
			while ($lastChar < $len){
				$char = substr($text, $lastChar, 1);
				if (($lastChar - $lastBreak > $wrap) && ($lastWhite > $lastBreak)){
					$h .= substr($text, $lastBreak, ($lastWhite - $lastBreak)) . $break;
					$lastChar = $lastWhite + 1;
					$lastBreak = $lastChar;
				}
				/* You may wish to include other characters as valid whitespace... */
				if ($char == ' ' || $char == chr(13) || $char == chr(10)){
					$lastWhite = $lastChar;
				}
				$lastChar = $lastChar + 1;
			}
			$h .= substr($text, $lastBreak);
		}
		else{
			$h = $text;
		}
		return $h;
	}
	


Function js_start()
	{
	if( javascript() )
		{
		echo "<script language=\"JavaScript\">\n";
		}
	else 
		{
		echo "<!-- Javascript has been disabled -->\n";
		}
	}

Function js_end()
	{
	if( javascript() )
		{
		echo "</script>\n";
		}
	}

Function is_refresh_page ($feature, $action, $localaccess)
	{
	GLOBAL $disabled, $dbconfig, $config;
	if( $disabled["pagerefresh"] == 2 ||
		 $disabled["pagerefresh"] == 1 && !$localaccess || 
		 "$feature" != "main" && !GetPref( "returntomain", $dbconfig["main_prefs_table"], $config["defaults"]["main"]["returntomain"] ) ||
		 "$feature" == "main" && !GetPref( "refreshmain", $dbconfig["main_prefs_table"], $config["defaults"]["main"]["refreshmain"] ) )
		{
		return FALSE;
		}
	
	$pwr=array( 
	"main.main"			=> TRUE,

	"mail.main"			=> TRUE,
	"mail.folders"		=> TRUE,
	"mail.foldover"		=> TRUE,  // ?
	"mail.msgview"		=> TRUE,
	"mail.transfer_to"	=> TRUE,  // ?
	"mail.delete"		=> TRUE,
	"mail.expunge"		=> TRUE,

	"contacts.main"		=> TRUE,
	"contacts.view"		=> TRUE,
	"contacts.lview"	=> TRUE,
	"contacts.import"	=> TRUE,  // ?

	"schedule.main"		=> TRUE,
	"schedule.week"		=> TRUE,
	"schedule.month"	=> TRUE,
	"schedule.year"		=> TRUE,
	"schedule.list"		=> TRUE,
	"schedule.maint"	=> TRUE,  // ?
	"schedule.view"		=> TRUE,

	"todo.main"			=> TRUE,
	"todo.view"			=> TRUE,

	"notes.main"		=> TRUE,
	"notes.view"		=> TRUE,
	
	"bookmarks.main"	=> TRUE,
	"bookmarks.view"	=> TRUE,
	
	"groups.main"		=> TRUE,
	"groups.view"		=> TRUE,
	


	);

	return $pwr["$feature.$action"];
	}



Function acl( $type, $feature=NULL )
	{
	GLOBAL $login, $context, $dbconfig, $acldefs, $errortext;
	if( !is_array( $acldefs ) ) include "features/admin/modules/acldefs.inc.php";
	$feature = $feature ? $feature : $context["feature"];
	$dbcol = $acldefs[$feature]["dbcol"];
	$query = "SELECT $dbcol FROM " . $dbconfig["access_table"] 
		. " WHERE username='" . $login["username"] . "'";
  	$result = dbQuery( $query );
	if( dbNumRows( $result ) == 0 )
		{
		$query = "SELECT $dbcol FROM " . $dbconfig["access_table"] 
			. " WHERE username='DEFAULT USER'";
  			$result = dbQuery( $query );
		if( dbNumRows( $result ) == 0 )
			{ // create default user
			$defaultuser["username"]='DEFAULT USER';
			$defaultuser["twiggi"]=0x03;
			$defaultuser["mail"]=0x03;
			$defaultuser["contacts"]=0x03;
			$defaultuser["schedule"]=0x03;
			$defaultuser["files"]=0x03;
			$defaultuser["resources"]=0x01; // default: resource user
			$defaultuser["todo"]=0x03;
			$defaultuser["notes"]=0x03;
			$defaultuser["bookmarks"]=0x03;
			$defaultuser["groups"]=0x03;
			$defaultuser["prefs"]=0x7fffff; // 23 bits
			$ins = MakeInsertString( $defaultuser );
			$query = "INSERT INTO " . $dbconfig["access_table"] . " (" . $ins["fields"] . ") VALUES (" . $ins["values"] . ")";
  			$result = dbQuery( $query );
			return acl( $type, $feature); // now set
			}
		}
	$data=dbResult( $result, $feature, 0 ); 
	if( !isset( $acldefs[$feature]["type"][$type] ) )
		{
		echo "<font $errortext><br><b>";
		echo "Function acl(): Unkown type<br>type=$type, feature=$feature, dbcol=$dbcol<br>";
		echo "</b><br></font>";
		}
	return $data & $acldefs[$feature]["type"][$type];
	}

	Function DimColor ($c, $dim)
		{
		$R=base_convert( preg_replace( "/^#*(..)..../", "\\1", $c), 16, 10); 
		$G=base_convert( preg_replace( "/^#*..(..)../", "\\1", $c), 16, 10 );
		$B=base_convert( preg_replace( "/^#*....(..)/", "0x\\1", $c), 16, 10); 
	
		$R = $R / 255;
		$G = $G / 255;
		$B = $B / 255;
	
		$Y = 0.299 * $R + 0.587 * $G + 0.114 * $B; // Luminanz
		$U = $B -$Y; // Farbton
		$V = $R- $Y; // Saettigung
	
		$Y = $Y*$dim;
	
		$R = $V + $Y;
		$B = $U + $Y;
		$G = ($Y - 0.114 * $B - 0.299 * $R ) / 0.587;
	
		$R = intval( $R * 255 );
		$G = intval( $G * 255 );
		$B = intval( $B * 255 );

		return sprintf( "#%02x%02x%02x", $R, $G, $B );
		}

	Function inc_sched_month ( &$Date )
		{
		$Date["month"]++;
		if ( $Date["month"] > 12 )
			{
			$Date["month"]=1;
			$Date["year"]++;
			}
		}
	
	Function dec_sched_month (  &$Date )
		{
		$Date["month"]--;
		if ( $Date["month"] < 1 )
			{
			$Date["month"]=12;
			$Date["year"]--;
			}
		}

	Function get_holidays( $syear, $smonth, $sday, $eyear, $emonth, $eday, $workingday=FALSE, $startdate=NULL, $enddate=NULL )
		{
		GLOBAL $dbconfig;
		if ( !$startdate )
			{
			$startdate=sprintf( "%04d%02d%02d000000", $syear, $smonth, $sday );
			}
		if ( !$enddate )
			{
			$enddate=sprintf( "%04d%02d%02d000000", $eyear, $emonth, $eday );
			}
		$query="SELECT nid FROM " . $dbconfig["holiday_selection_table"] . 
			" WHERE type='" . ( $workingday ? 1 : 2 ) . "'";
		$result=dbQuery( $query );
		for( $i=0, $k=dbNumRows( $result ); $i<$k; $i++ )
			{
			$wquery[$i]=dbresult( $result, $i, "nid" );
			}
		if( is_array( $wquery ) )
			{
			$wqs = " ( nid='" . implode( $wquery, "' OR nid='" ) . "' )";
			$query="SELECT * FROM " . $dbconfig["holiday_names_table"] . " WHERE $wqs";
			$result=dbQuery( $query );
			for( $i=0, $k=dbNumRows( $result ); $i<$k; $i++ )
				{
				$data = dbResultArray($result, $i);
				$names[$data["nid"]] = $data["name"];
				}

			$query="SELECT * FROM " . $dbconfig["holiday_dates_table"] . 
				" WHERE ( thedate>='$startdate' AND thedate<='$enddate' ) AND $wqs";
			$result=dbQuery( $query );
			for( $i=0, $k=dbNumRows( $result ); $i<$k; $i++ )
				{
				$data = dbResultArray($result, $i);
				if( $ret[$data["thedate"]] ) $ret[$data["thedate"]] .= ", ";
				$ret[$data["thedate"]] .=  $names[$data["nid"]];
				}
			}
		return $ret;
		}
	
	//ADMIN ++ ADDED (htmlentities -> TWIGhtmlentities)
	Function TWIGhtmlentities ($retstr)
	    {
	    GLOBAL $config;
	    $retstr = htmlspecialchars ($retstr,ENT_QUOTES);
	    return $retstr;
	    }

?>
