<?php if ( $HTTP_SERVER_VARS["PHP_SELF"] != $config["basedir"] . "/index.php" ) {exit;}; ?>
<?php	// TWIG		Group Manager ?>
<?php 

if( !acl( "w" ) ) return;

if( $data_id ) { $session["thisGroup"] = $data_id; } 

	if ( !ReadPermsGroup ( $session["thisGroup"] ) )
		{
		echo "<font $errortext><br><b>";
		echo $TWIGphrase["Error: You don't have permission for this operation."];
		echo "</b><br></font>";
		exit; // stop here
		}

include( "features/shared/newlists.inc.php" );

if ( $action == "New" ) 
	{
	unset ($session["thisGroup"]);
	$newgroup=TRUE;
	}

if (  $submitbutton["update"] && !ReadOnlyPerms ($session["thisGroup"], $dbconfig["groups_table"]) )
	{
	$oldmembers = TWIGGroupsMembers( $session["thisGroup"] );
	while ($hmember && list($k,$v)=each($hmember))
		{
		if ( !$oldmembers || !in_array( $v, $oldmembers ) )
			{
			TWIGGroupsCreateMember ($login["username"], $session["thisGroup"], $v);
			$flag=1;
			}
		}
	while ($oldmembers && list($k,$v)=each($oldmembers))
		{
		if ( !$hmember || !in_array( $v, $hmember ) )
			{
			TWIGGroupsDeleteMember ($login["username"], $session["thisGroup"], $v);
			$flag=1;
			}
		}

	if ( $permtype != $oldpermtype )
		{
		TWIGGroupsUpdatePerms ($session["thisGroup"], $permtype);
		$flag=1;
		}

	if ( $flag || $newgroupname != TWIGGroupsGetName( $session["thisGroup"] ) )
		{
		TWIGGroupsUpdateGroupName( $login["username"], $session["thisGroup"] , $newgroupname );
		}
	
	if ( !TWIGlUserExists ( $session["thisGroup"], $dbconfig["groups_table"] ) )
		{
		TWIGGroupsUpdateOwner( $session["thisGroup"] , $login["username"] );
		}
 	include( "features/groups/groups.view.inc.php" );
	return;

	}
elseif ( $submitbutton["delete"] && ModDelPerms ($session["thisGroup"], $dbconfig["groups_table"]) )
	{
	TWIGGroupsDeleteGroup( $session["thisGroup"] );
 	// Now change all items to unfiled
	TWIGGroupsBulkMoveItems( $login["username"], $session["thisGroup"], 0, TRUE /* all*/  );
 	$session["thisGroup"] = 0;
 	include( "features/groups/groups.main.inc.php" );
	return;
	}
elseif ( $submitbutton["add"] || isset($data["groupname"]) )
	{
	$session["thisGroup"]=TWIGGroupsCreateGroup( $login["username"], $login["username"], TWIGProcessGPCtoSQL( $data["groupname"] ) ); 
	$permtype=GetPref( "dperms", $dbconfig["groups_prefs_table"], 0 );
	$oldpermtype=$permtype;
	TWIGGroupsUpdatePerms ($session["thisGroup"], $permtype);
	TWIGGroupsCreateMember ($login["username"], $session["thisGroup"], $login["username"]);
	$newgroup=FALSE;
	}
?>


<table border=0 width=100% cellspacing=0 cellpadding=0>
  <tr>
    <td align=right> 
    <?php
      $i = 0;
	  if ( !$newgroup )
	  	{
      	$groupmenu[$i] = array( "command" => "groups", "desc" => $TWIGphrase["back"], "action" => "view", "options" => "", "target" => "", "image" => "backto.gif" ); $i++;
		}
	   else
	   	{
      	$groupmenu[$i] = array( "command" => "groups", "desc" => $TWIGphrase["Back to Groups"], "action" => "main", "options" => "", "target" => "", "image" => "backto.gif" ); $i++;
		}

      echo TWIGGenerateMenu( $groupmenu, GetPref( "mstyle2", $dbconfig["global_prefs_table"], $config["defaults"]["global"]["mstyle2"] ), "groups" );
    ?>
    </td>
  </tr>
  <tr>
  <td colspan=2><img src=<?php echo $img["blackpix"] ?> width=100% height=1 vspace=3></td>
  </tr>

<?php

echo "<form action=" . $config["baseurl"] . " method=POST>\n";
echo TWIGSession( "put" );
echo TWIGContext( "put" );
echo "</table>";

if (!$newgroup)
	{
	$query = "SELECT * FROM " . $dbconfig["groups_table"] . " WHERE id='" . $session["thisGroup"] . "'";
	$result = dbQuery( $query );
	$data=dbResultArray( $result, 0 );

	if ( (!$submitbutton["submember"] && !$submitbutton["unsubmember"] ) )
		{
		$smember = TWIGGroupsMembers( $session["thisGroup"] );
		}
	else
		{
		$smember = $hmember;
		}
	
	
	if ($submitbutton["submember"] && $add_member )
		{
		if (!$smember) { $smember[0]=""; array_pop ($smember); }
		for ($i=0; $i<count($add_member); $i++)
			{
			array_push ($smember, $add_member[$i]);
			}
		}
	
	if ($submitbutton["unsubmember"] && $smember && $remove_member )
		{
		for ($i=0; $i<count($smember); $i++)
			{
			if ( in_array ($smember[$i], $remove_member) && !(!OwnerOf ($session["thisGroup"], $dbconfig["groups_table"]) && $smember[$i]==$login["username"] ) )
				{
					$smember[$i]=$smember[0];
					array_shift ($smember);
					$i--;
				}
			}
		}
	
	$umember[0]=""; array_pop ($umember);
	while (list($k,$v)=each($config["localuser"]))
		{
		if ( !$smember || !in_array ($k, $smember) )
			{
			array_push ($umember, $k);
			}
		}

	echo "<table border=0 cellspacing=0 cellpadding=0>";
	echo "<tr>";
	echo "<td bgcolor=\"" . $config["formscolor"] . "\" valign=top align=left nowrap>";
	TWIGGenerateViewTitle ($TWIGphrase["Edit group"], $data);	
	echo "</td>";
	echo "</tr>";
	echo "<tr></tr>";
	echo "<tr>";
	echo "<td bgcolor=\"" . $config["formscolor"] . "\" valign=top align=left nowrap>";

	echo "<table width=100% border=0 cellspacing=0 cellpadding=5>";

	echo "<tr>";
	echo "<td bgcolor=\"" . $config["formscolor"] . "\" valign=top align=left nowrap>";

	echo "<table border=0 cellspacing=0 cellpadding=0>";
	echo "<tr>";
	echo "<td valign=top>";
	echo "<font face=\"" . $config["cellfont"] . "\" size=" . $config["textfontsize"] . " color=\"" . $config["celltext"] . "\">";
	echo "<b>" . $TWIGphrase["Group"] . ": </b><br>";
	echo "<input size=10 type=text name=newgroupname value=\"" . TWIGGroupsGetName( $session["thisGroup"] ) . "\">";
	echo "</font>";
	echo "</td>";

	echo "<td>";
	echo "&nbsp;&nbsp;";
	echo "</td>";

	echo "<td valign=top>";
	echo "<font $formstext>";


	if ( $data["owner"]==$login["username"] || !$data["id"]  )
		{
		echo "<b>" . $TWIGphrase["Permissions granted to group members"] . ":</b><br>";
		if (!$data["id"]) { $data["permtype"]=GetPref( "dperms", $dbconfig["groups_prefs_table"], 0 ); }
		echo TWIGPermsSelector("permtype", $data["permtype"], !$data["id"] || OwnerOf( $data["id"], $dbconfig["groups_table"] ));
		echo "<input type=hidden name=oldpermtype value=" . $data["permtype"] . ">";
		}
	else
		{
		echo "&nbsp;";
		}


	echo "</font>";
	echo "</td>";

	echo "</tr>";
	echo "</table>";
	
	
	echo "</td>";
	echo "</tr>";
	echo "<tr>";
	echo "<td align=left>";

	echo "<table border=0 cellspacing=0 cellpadding=5>";
	echo "<tr>";
	echo "<td>";

	echo "<font face=\"" . $config["cellfont"] . "\" size=" . $config["textfontsize"] . " color=\"" . $config["celltext"] . "\">";
	echo "<b>" . $TWIGphrase["not member"] . ": </b>";
	echo "</font>";
	echo "</td>";
	
	echo "<td>";
	echo "&nbsp;";
	echo "</td>";
	
	echo "<td>";
	echo "<font face=\"" . $config["cellfont"] . "\" size=" . $config["textfontsize"] . " color=\"" . $config["celltext"] . "\">";
	echo "<b>" . $TWIGphrase["Members"] . ": </b>";
	echo "</font>";
	echo "</td>";
	
	echo "</tr>";
	echo "<tr>";
	
	echo "<td>";
	echo "\n<select name=add_member[] size=20 multiple>\n";
	reset( $umember );
	unset( $na );
	while (list($k,$v)=each($umember))
		{
		if( $v ) $na[$v]=TWIGGetRealnameLF($v) . " <$v>";
		}
	if( is_array( $na ) )
		{
		natcasesort ($na);
		reset( $na );
		while (list($k,$v)=each($na))
			{
			//ADMIN ++ ADDED (htmlentities -> TWIGhtmlentities)
			echo "<option value=\"" . $k . "\">" . TWIGhtmlentities( $v ) . "</option>\n";
			}
		}
	echo "<option value=\"\">" . str_repeat ("&nbsp;", 60) . "</option>";
	?>
	</select></td><td>
    <input type=image src="<?php echo $img["select"]?>" border=0 name=submitbutton[submember]><BR><BR><BR>
    <input type=image src="<?php echo $img["unselect"]?>" border=0 name=submitbutton[unsubmember]>
	</td><td><select name=remove_member[] size=20 multiple>
	<?php
	if( is_array( $smember ) )
		{
		reset( $smember );
		unset( $na );
		while (list($k,$v)=each($smember))
			{
			if( $v ) $na[$v]=TWIGGetRealnameLF($v) . " <$v>";
			}
		if( is_array( $na ) )
			{
			natcasesort ($na);
			reset( $na );
			while (list($k,$v)=each($na))
				{
				//ADMIN ++ ADDED (htmlentities -> TWIGhtmlentities)
				echo "<option value=\"" . $k . "\">" . TWIGhtmlentities( $v ) . "</option>\n";
				}
			}
		}
	echo "<option value=\"\">" . str_repeat ("&nbsp;", 60) . "</option>";
	echo "</select>\n";
	echo "</td>";
	echo "</tr>";
	
	echo "</table>";

	echo "</td>";
	echo "</tr>";
	echo "<tr>";
	echo "<td bgcolor=\"" . $config["bgcolor"] . "\">";

	for ($i=0; $i<count ($smember); $i++)
		{
		echo "<input type=hidden name=hmember[$i] value=" . $smember[$i] . ">\n";
		}
	echo TWIGListItemEditFormFooter( $newgroup, "", "*", $dbconfig["groups_table"], $data["id"], "" ); 
	
	echo "</td>";
	echo "</tr>";
	echo "</table>";
	
	echo "</td>";
	echo "</tr>";
	echo "</table>";
	}

else
	{
	echo "<table border=0 cellspacing=0 cellpadding=0>";
	echo "<tr>";
	echo "<td bgcolor=\"" . $config["formscolor"] . "\" valign=top align=left nowrap>";
	TWIGGenerateViewTitle ($TWIGphrase["Edit group"], $data, 1);	
	echo "</td>";
	echo "</tr>";
	echo "<tr></tr>";
	echo "<tr>";
	echo "<td bgcolor=\"" . $config["formscolor"] . "\" valign=top align=left nowrap>";

	echo "<table width=100% border=0 cellspacing=0 cellpadding=5>";

	echo "<tr>";
	echo "<td bgcolor=\"" . $config["formscolor"] . "\" valign=top align=left nowrap>";
	echo "<font face=\"" . $config["cellfont"] . "\" size=" . $config["textfontsize"] . " color=\"" . $config["celltext"] . "\">";
	echo "<b>" . $TWIGphrase["New group"] . ":&nbsp;</b>" . TWIGGroupsNewGroupForm ( $login["username"] );
	echo "</font>";
	echo "</td></tr>";
	echo "</table>";
	echo "</td></tr>";
	echo "</table>";
	}
echo "</form>";
?>
