<?php if ( $HTTP_SERVER_VARS["PHP_SELF"] != $config["basedir"] . "/index.php" ) {exit;}; ?>
<?php

	$havemail=acl("r", "mail");
	$haveschedule=acl("r", "schedule");
	$havetodo=acl("r", "todo");

	$session["feature-return"] = "main"; 
	$viewgrp=GetPref( "viewgrp", $dbconfig["main_prefs_table"], $config["defaults"]["main"]["viewgrp"] );
	if ( $viewgrp == "*" )
		{
		$groupquery=TWIGGroupsCreateSQLGroupQuery( $login["username"], array_merge( TWIGGroupsMembership( $login["username"] ), TWIGGroupsOwnership( $login["username"] ) ));
		$grpwarn = "";
		}
	else
		{
		if ( $viewgrp == 0 ) 
			{
			$groupquery="( username='" . $login["username"] . "' AND groupid=$viewgrp )";
			}
		else
			{
			$groupquery="groupid=$viewgrp";
			}
		$grpwarn = " " . $TWIGphrase["for group"] . " ". TWIGGroupsGetName ( $viewgrp );
		}
	$schcuryear=date("Y", mktime());
	$schcurmonth=date("m", mktime());
	$schcurday=date("d", mktime());
	$todaystart = intval( gmmktime () / 86400)*86400;
	$wday = gmdate ( "w", $todaystart );

	// save preview status for return from view item
	if ( !isset ($preview) )
		{
		$preview=$session["todaypreview"];
		}
	else
		{
		$session["todaypreview"] = $preview;
		}

	if ( $preview == 1)
		{
		if ( $wday == 5)  // Friday
			{ 
			$future=86400*3; 
			}
		elseif ( $wday == 6) // Saturday
			{ 
			$future=86400*2; 
			}
		else
			{
			$future=86400; 
			}
		}
	elseif ($preview == 6)
		{
		$future=86400*6; 
		}
	else
		{
		$future=0;
		}
	$todayend=$todaystart+86400-1 + $future;
	$sql_todaystart = convertUTimeToSQLTime( $todaystart );
	$sql_todayend = convertUTimeToSQLTime( $todayend );
	$todaystart_formail =  mktime ()-86400;  // not really today, but last 24h
	if ( $wday == 0) // Sunday
		{
		$todaystart_formail -= 86400;
		$today_past= " / " . TWIGdate( "l", $todaystart-86400 ) ;
		}
	elseif ( $wday == 1) // Monday
		{
		$todaystart_formail -= 86400;
		$today_past= " / " . TWIGdate( "l", $todaystart-86400 ) ;
		$todaystart_formail -= 86400;
		$today_past.= " / " . TWIGdate( "l", $todaystart-86400*2 ) ;
		}
?>
<table border=0 width=100% cellpadding=0 cellspacing=0>
<?php
if( TWIGCheckAdmin() ) 
	{
	echo "<tr><td align=right colspan=2 valign=top bgcolor=\"" . $config["cellcolor"] . "\">";
	echo "<font $celltext><b>";
	echo TwigLink( $TWIGphrase["Administration"], "admin", "", "", "", "", "", "" );
	echo "</b></font></td></tr> ";
	}
?>
 <tr>
  <?php 
	if( $config["announcements"] == "advanced" )
		{
  ?>  
  <td valign=top bgcolor="<?php echo $config["cellheadcolorlight"]?>" colspan=2>
   <font <?php echo $headtextlight?>>
   <b><?php echo $TWIGphrase["announcements"]; ?></b>
   </font>
  </td>
  <?php 
		}
   ?>
 </tr>
 <tr>
  <td valign=center bgcolor="<?php echo $config["cellcolor"]?>"><font <?php echo $smallcelltext?>>&nbsp;<?php echo $TWIGphrase["Welcome to TWIG version"] . " " . $version?></font></td>
  <td align=right valign=center bgcolor="<?php echo $config["cellcolor"]?>">
   <?php 
   if( $haveschedule || $havetodo )
   	{
   	echo "<font $smallcelltext>" . $TWIGphrase["Preview"] . ": ";
   	echo TwigLink( $TWIGphrase["none"],"main", "", "preview=0", "", "", "", "" );
   	echo "&nbsp;&#149;&nbsp;";
   	if ( $preview==1 ) { echo "<b>";}
   	echo TwigLink( $TWIGphrase["next weekday"],"main", "", "preview=1#s", "", "", "", "" );
   	if ( $preview==1 ) { echo "</b>";}
   	echo "&nbsp;&#149;&nbsp;";
   	if ( $preview==6 ) { echo "<b>";}
   	echo TwigLink( $TWIGphrase["6 days"],"main", "", "preview=6#s", "", "", "", "" );
   	if ( $preview==6 ) { echo "</b>";}
   	echo "</font>";
	}
   else
	{
	echo "&nbsp;";
	}
   ?>
  </td>
 </tr>
 <tr>
  <?php 
	if( $config["announcements"] == "advanced" )
		{
		$select = "SELECT * FROM " . $dbconfig["announce_table"] . " WHERE thedate < '" . convertUTimeToSQLTime( gmmktime () ) . "' ORDER BY thedate DESC";
		$result = dbquery( $select );

		echo "<td align=center valign=top bgcolor=\"" . $config["cellcolor"] . "\" colspan=2>\n";
		echo "<table border=0 width=99% cellpadding=0 cellspacing=0 align=right>\n";
		echo "<tr>\n";
		echo "<td NOWRAP bgcolor=\"" . $config["cellheadcolor"] . "\"><font face=\"" . $config["cellfont"] . "\" size=" . $config["textfontsize"] . " color=\"" . $config["cellheadtext"] . "\"><b>" . $TWIGphrase["Date"] . "</b></font></td>\n";
		echo "<td bgcolor=\"" . $config["cellheadcolor"] . "\">&nbsp;</td>\n";
		echo "<td bgcolor=\"" . $config["cellheadcolor"] . "\"><font face=\"" . $config["cellfont"] . "\" size=" . $config["textfontsize"] . " color=\"" . $config["cellheadtext"] . "\"><b>" . $TWIGphrase["Subject/Announcement"] . "</b></td>\n";
		echo "<td bgcolor=\"" . $config["cellheadcolor"] . "\">&nbsp;</td>\n";
		echo "<td colspan=2 NOWRAP bgcolor=\"" . $config["cellheadcolor"] . "\"><font face=\"" . $config["cellfont"] . "\" size=" . $config["textfontsize"] . " color=\"" . $config["cellheadtext"] . "\"><b>" . $TWIGphrase["By"] . "</b></td>\n";
		echo "</tr>\n";

		for( $i = 0, $j = dbnumrows( $result ); $i < $j; $i++ )
			{
			$data = dbresultarray( $result, $i );

			echo "      <tr>\n";
			echo "        <td bgcolor=\"" . $config["cellcolor"] . "\" NOWRAP>";
 			echo "<font face=\"" . $config["cellfont"] . "\" size=" . $config["textfontsize"] . " color=\"" .  $config["celltext"] . "\">";
			echo TWIGDate( $config["shortdateformat"] . " " . TWIGGetTimeFormat(), convertSQLTimetoUTime( $data["thedate"] ) );
			echo "</font>";
			echo "</td>\n";
			echo "<td bgcolor=\"" . $config["cellcolor"] . "\">&nbsp;</td>\n";
			echo "<td bgcolor=\"" . $config["cellcolor"] . "\">";
 			echo "<font face=\"" . $config["cellfont"] . "\" size=" . $config["textfontsize"] . " color=\"" .  $config["celltext"] . "\">";
			echo "<b>";
			echo $data["subject"];
			echo "</b>";
			echo "</font>";
			echo "</td>\n";
			echo "<td bgcolor=\"" . $config["cellcolor"] . "\">&nbsp;</td>\n";
			if( $data["email"] )
				{
				echo "<td bgcolor=\"" . $config["cellcolor"] . "\" colspan=2>";
 				echo "<font face=\"" . $config["cellfont"] . "\" size=" . $config["textfontsize"] . " color=\"" .  $config["celltext"] . "\">";
				echo TWIGMailto( $data["email"], $data["username"] );
				echo "</font>";
				echo "</td>\n";
				}
			else
				{
				echo "        <td bgcolor=\"" . $config["cellcolor"] . "\" colspan=2>";
 				echo "<font face=\"" . $config["cellfont"] . "\" size=" . $config["textfontsize"] . " color=\"" .  $config["celltext"] . "\">";
				echo TWIGMailto( $data["username"], $data["username"] );
				echo "</font>";
				echo "</td>\n";
				}
			echo "</tr>\n";
			echo "<tr>\n";
			echo "<td bgcolor=\"" . $config["cellcoloralt"] . "\" colspan=2>&nbsp;</td>\n";
			echo "<td bgcolor=\"" . $config["cellcoloralt"] . "\" colspan=4>";
 			echo "<font face=\"" . $config["cellfont"] . "\" size=" . $config["textfontsize"] . " color=\"" .  $config["celltext"] . "\">";
			echo $data["announce"];
			echo "</font>";
			echo "</td>";
			echo "</tr>";

			if( $i != $j - 1 )
				{
				echo "      <tr>\n";
				echo "        <td colspan=6><HR></td>\n";
				echo "      </tr>\n";
				}
			}

		echo "	  </table>\n";
		echo "  </td>\n";
		}
   ?>
 </tr>

<?php    // --------------- today's mail begin --------------
 if( $havemail && !GetPref( "recentmail", $dbconfig["main_prefs_table"], $config["defaults"]["main"]["recentmail"] ) )
	{
	$maxmail=GetPref( "maxmail", $dbconfig["main_prefs_table"], $config["defaults"]["main"]["maxmail"] );
	$real_maxmail=$maxmail;
	$todaymail=GetPref( "todaymail", $dbconfig["main_prefs_table"], $config["defaults"]["main"]["todaymail"] );
	if ( $todaymail && $config["fix_imap_maildir_date_bug"] )
		{
		$maxmail *= 3; // try to catch all recent mails
		}
	unset( $tableheaders );
	unset( $tablecontents );
	$i = 0;
	$sother[0]["item"] = "mailbox";
	$sother[0]["value"] = "INBOX";

	$mbox = TWIGOpenMB( "INBOX" );
	$mbx = TWIGMailGetFolderString( $config["imap_server"], $config["imap_port"], "", "INBOX" );
	$sorted = MailCacheGetSortedList ($mbox, $mbx, 1, 1); 
	$session["mailbox_sorted_list"]=serialize($sorted);

	$c=count( $sorted );
 	for( $ii = 0; $ii < $c && $i<$maxmail ; $ii++ ) 
		{
      	$headers = @TWIGMailHeader( $mbox, $sorted[$ii], 0, 0, $config["fromdomain"] );
		$headers->DeliveryDate = TWIGDeliveryDate( $mbox, $sorted[$ii] );
		if( is_object( $headers ) ) 
			{ 
			$headerdate=TWIGGetMailDate( $headers );
			if ( $todaymail && $headerdate < $todaystart_formail-172800 ) 
				{ 
				$trig++; 
				if ($trig>10) { break;} // murks, murks, murks!
				}
			else
				{
				$trig=0;
				}

			if ( $headers->Deleted != "D"  && ( !$todaymail || $headerdate>=$todaystart_formail ) )
				{ 
     			if( $headers->Unseen == "U" ) 
					{ 
					$ttp="title=\"" . $TWIGphrase["unread"] . "\" alt=\"" . $TWIGphrase["unread"] . "\"";
					$itemp = "<img src=\"" . $img["unread"] . "\" $ttp border=0>"; 
					}
     			elseif ( $headers->Answered == "A" ) 
					{ 
					$ttp="title=\"" . $TWIGphrase["answered"] . "\" alt=\"" . $TWIGphrase["answered"] . "\"";
					$itemp = "<img src=\"" . $img["answered"] . "\" $ttp border=0>"; 
					}
     			else 
					{ 
					$ttp="title=\"" . $TWIGphrase["read"] . "\" alt=\"" . $TWIGphrase["read"] . "\"";
					$itemp = "<img src=\"" . $img["read"] . "\" $ttp border=0>"; 
					}

				$struct = TWIGMailFetchStructure( $mbox, $sorted[$ii] );
				if( $struct->parts && $img["attachment"] ) 
					{ 
					$ttp = "\"" . TWIGAttachmentToolTip ( $struct->parts ) . "\"";
					$atemp = "<img hspace=5 src=\"" . 
								$img["attachment"] . "\" title=$ttp alt=$ttp border=0>"; 
					}
				else { $atemp = "&nbsp;"; }

				if( !$headers->Subject ) { $headers->Subject = $TWIGphrase["[no subject]"]; }

					if ( $headerdate >= mktime (0,0,0) ) 
						{
						$maildate=TWIGLocaldate( TWIGGetTimeFormat(), $headerdate ); 
						} 
					else 
						{
						$maildate=TWIGLocaldate( $config["shortdateformat"], $headerdate );
						}
				$ix=0;
				$tablecontents[$i][$ix]["contents"]=$itemp;
				$tablecontents[$i][$ix]["valign"]="top";
				$tablecontents[$i][$ix]["align"]="center";
				$ix++;
				$tablecontents[$i][$ix]["contents"]=$atemp;
				$tablecontents[$i][$ix]["valign"]="top";
				$tablecontents[$i][$ix]["align"]="center";
				$ix++;
				$datetable[$i]=$headerdate; // for sort functiom
				$tablecontents[$i][$ix]["contents"]=$maildate;
				$tablecontents[$i][$ix]["valign"]="top";
				$tablecontents[$i][$ix]["align"]="center";
				$tablecontents[$i][$ix]["nowrap"]=TRUE;
				$tablecontents[$i][$ix]["headerdate"]=$headerdate; // for sort function below
				$ix++;
				$tablecontents[$i][$ix]["contents"]="&nbsp;&nbsp;";
				$ix++;
				$tablecontents[$i][$ix]["contents"]=HTMLSpecialChars( TWIGDecodeMimeString( ereg_replace( "<.*>", "", $headers->fromaddress ) ) );
				$tablecontents[$i][$ix]["valign"]="top";
				$tablecontents[$i][$ix]["align"]="left";
				$ix++;
				$tablecontents[$i][$ix]["contents"]="&nbsp;&nbsp;";
				$ix++;
				$tablecontents[$i][$ix]["contents"]=twigLink( HTMLSpecialChars( TWIGDecodeMimeString( $headers->Subject ) ), "mail", "msgview", "path=" . $sorted[$ii], "", $sother );
				$tablecontents[$i][$ix]["valign"]="top";
				$tablecontents[$i][$ix]["align"]="left";

				$i++;
        		} 
       		}
     	}


	$ix=0;
	$tableheaders[$ix]["header"]="&nbsp;";
	$tableheaders[$ix]["width"]="1%";
	$ix++;
	$tableheaders[$ix]["header"]="&nbsp;";
	$tableheaders[$ix]["width"]="1%";
	$ix++;
	$tableheaders[$ix]["header"]= $todaymail ? $TWIGphrase["Time"] : $TWIGphrase["date"];
	$tableheaders[$ix]["align"]="center";
	$tableheaders[$ix]["width"]="1%";
	$ix++;
	$tableheaders[$ix]["header"]="&nbsp;";
	$tableheaders[$ix]["align"]="left";
	$ix++;
	$tableheaders[$ix]["header"]=$TWIGphrase["from"];
	$tableheaders[$ix]["align"]="left";
	$ix++;
	$tableheaders[$ix]["header"]="&nbsp;";
	$tableheaders[$ix]["align"]="left";
	$ix++;
	$tableheaders[$ix]["header"]=$TWIGphrase["subject"];
	$tableheaders[$ix]["align"]="left";

	
?>
 <tr>
  <td valign=top bgcolor="<?php echo $config["cellheadcolorlight"]?>" colspan=2>
   <b>&nbsp;<?php echo TWIGLink( $todaymail ? $TWIGphrase["Today's mail"] . $today_past : $TWIGphrase["recent mail"], "mail", "main", "newmailbox=INBOX&startmsg=1","", "", "", $headtextlight  );?></b>
  </td>
 </tr>
 <tr>
  <td valign=top bgcolor=<?php echo $config["cellcolor"]?> colspan=2>
  
 	<table cellpadding=0 cellspacing=0 border=0 width=99% align=right>
 	<tr>
 	<td>
    <?php 
	Function sorttable ($a, $b)
		{
			GLOBAL $tablecontents;
			if ( $a[2]["headerdate"] < $b[2]["headerdate"] )
				{
				return 1;
				}
			else
				{
				return -1;
				}
		}
	if ( $i>0 )   // Only display this block if there are any messages
		{
		usort ($tablecontents, "sorttable"); // sort by date, because of IMAP date bug
		$tablecontents=array_slice ($tablecontents, 0, $real_maxmail);
		$ri=count ($tablecontents);
		if ( ($todaymail && $i>$ri) || ( !$todaymail && $c>$i)  )
			{
			$num = $todaymail ? "" : "&nbsp;" . ($c-$ri) . "&nbsp;";
			$tablecontents[$ri][0]["contents"]=TWIGLink( "<b>$num" .  $TWIGphrase["more"] . "...<b>", "mail", "main", "newmailbox=INBOX&startmsg=$maxmail" );
			$tablecontents[$ri][0]["colspan"]=$ix;
			}

		echo TWIGGenerateTable( $tableheaders, $tablecontents );
		}
	else
		{
		echo "<font $celltext>";
		echo $TWIGphrase["No mails received today"] . ".";
		echo "</font>";
		}
	?>
  	</td>
  	</tr>
 	<tr>
 	<td>
	&nbsp;
  	</td>
  	</tr>
  	</table>
  </td>
 </tr>
<?php
	}
	// --------------- today's mail end -------------- 
?>
<?php // --------------- today's schedule begin -------------- 
	if( $haveschedule && !GetPref( "schedule", $dbconfig["main_prefs_table"], $config["defaults"]["main"]["schedule"] ) )
		{
	?>
<a name=s></a>
 <tr>
  <td colspan=2 valign=top bgcolor="<?php echo $config["cellheadcolorlight"]?>">
   <b>&nbsp;<?php echo TwigLink( $TWIGphrase["Today's schedule"],"schedule", "", "schcuryear=$schcuryear&schcurmonth=$schcurmonth&schcurday=$schcurday", "", "", "", $headtextlight )?></b>
  </td>
 </tr>
 <tr>
 <td valign=top bgcolor=<?php echo $config["cellcolor"]?> colspan=2>

 <table cellpadding=0 cellspacing=0 border=0 width=99% align=right>
 <tr>
 <td>

<?php
	$maxschedule=GetPref( "maxschedule", $dbconfig["main_prefs_table"], $config["defaults"]["main"]["maxschedule"] );
	include( "features/schedule/schedule.inc.php" );
	unset( $tableheaders );
	unset( $tablecontents );
	$ix=0;
	$tableheaders[$ix]["header"]="&nbsp;";
	$tableheaders[$ix]["width"]="1%";
	$ix++;
	$tableheaders[$ix]["header"]= $TWIGphrase["Start Time"];
	$tableheaders[$ix]["align"]="left";
	$tableheaders[$ix]["width"]="1%";
	$tableheaders[$ix]["nowrap"]=TRUE;
	$ix++;
	$tableheaders[$ix]["header"]="&nbsp;&nbsp;&nbsp;";
	$tableheaders[$ix]["width"]="1%";
	$ix++;
	$tableheaders[$ix]["header"]=$TWIGphrase["End Time"];
	$tableheaders[$ix]["align"]="left";
	$tableheaders[$ix]["width"]="1%";
	$tableheaders[$ix]["nowrap"]=TRUE;
	$ix++;
	$tableheaders[$ix]["header"]="&nbsp;&nbsp;&nbsp;";
	$tableheaders[$ix]["width"]="1%";
	$ix++;
	$tableheaders[$ix]["header"]= $TWIGphrase["Group"];
	$tableheaders[$ix]["align"]="left";
	$tableheaders[$ix]["width"]="1%";
	$tableheaders[$ix]["nowrap"]=TRUE;
	$ix++;
	$tableheaders[$ix]["header"]="&nbsp;&nbsp;";
	$tableheaders[$ix]["width"]="1%";
	$ix++;
	$tableheaders[$ix]["header"]= $TWIGphrase["Subject"];
	$tableheaders[$ix]["align"]="left";
	$tableheaders[$ix]["width"]="99%";

	for ($z=$todaystart; $z<$todayend; $z+=86400)
		{
			list( $ae, $timeentries, $notimeentries ) = TWIGScheduleGetItems( $z, $z+86400 );
			$c=count( $ae );
			for( $i = 0; $i<$c; $i++ )
				{
				$ae[$i]["weekday"]=TWIGdate( "l", $z ); 
				}
			$allentries=array_merge($allentries, $ae);
		}

	$wday = TWIGdate( "l", $todaystart ); 
	$prev_wday=$wday;

	$c=count( $allentries );
	$k=0;
	$not_today=FALSE;
	$count=-1;
 	for( $i = 0; $i<$c; $i++ ) 
 		{
		$data = $allentries[$i];
		if ( $prev_wday != $data["weekday"] )
			{
				if ( $count > $maxschedule )
				{
				$tablecontents[$k][0]["contents"]=TwigLink( "&nbsp;<b>" . ($count+1-$maxschedule) . "&nbsp;" . $TWIGphrase["more"] . "...<b>","schedule", "", "startmsg=1" );
					$tablecontents[$k][0]["colspan"]=8;
					$k++;
				}
				$count=-1;
				$prev_wday=$data["weekday"];
				$tablecontents[$k][0]["contents"]="<b>" . $data["weekday"] ."</b>";
				$tablecontents[$k][0]["valign"]="top";
				$tablecontents[$k][0]["align"]="left";
				$tablecontents[$k][0]["nowrap"]=TRUE;
				$tablecontents[$k][0]["colspan"]=8;
				$k++;
				$not_today=TRUE;
			}

		$count++;
		if ( $count >= $maxschedule ) { continue; };

		$ix=0;
		$icon=Permissions( $data["id"], $dbconfig["schedule_table"], 
			$img["dotowner"], 
			$img["dotmember"], 
			$img["dotrw"] );
		$tablecontents[$k][$ix]["contents"]=twigLink( "<img src=" . $icon . " border=0 title=\"" . $TWIGphrase["View Item"] . "\">", "schedule", "view", "action=Edit&ItemID=" . $data[id] );
		$tablecontents[$k][$ix]["valign"]="top";
		$tablecontents[$k][$ix]["nowrap"]=TRUE;
		$ix++;

		if ( $data["notime"] )
			{
			if ($data["itemstart"]>=$sql_todaystart && $data["itemstart"]<=$sql_todayend )
				{
				$istart = $not_today ?  $TWIGphrase["Day"] : $TWIGphrase["today"];
				}
			else
				{
				$istart=TWIGdate( $config["shortdateformat"], convertSQLTimetoUTime( $data["itemstart"] ) );
				}
			if ($data["itemstop"]>=$sql_todaystart && $data["itemstop"]<=$sql_todayend )
				{
				$istop = $not_today ? "&nbsp;" : $TWIGphrase["today"];
				}
			else
				{
				$istop=TWIGdate( $config["shortdateformat"], convertSQLTimetoUTime( $data["itemstop"] ) );
				}
			}
		else
			{
			if ($data["itemstart"]>=$sql_todaystart && $data["itemstart"]<=$sql_todayend )
				{
				$istart=TWIGdate( TWIGGetTimeFormat(), convertSQLTimetoUTime( $data["itemstart"] ) );
				}
			else
				{
				$istart=TWIGdate( $config["shortdateformat"], convertSQLTimetoUTime( $data["itemstart"] ) );
				}

			if ($data["itemstop"]>=$sql_todaystart && $data["itemstop"]<=$sql_todayend )
				{
				$istop=TWIGdate( TWIGGetTimeFormat(), convertSQLTimetoUTime( $data["itemstop"] ) );
				}
			else
				{
				$istop=TWIGdate( $config["shortdateformat"], convertSQLTimetoUTime( $data["itemstop"] ) );
				}
			}

		$tablecontents[$k][$ix]["contents"]=$istart;
		$tablecontents[$k][$ix]["valign"]="top";
		$tablecontents[$k][$ix]["align"]="left";
		$tablecontents[$k][$ix]["nowrap"]=TRUE;
		$ix++;

		$tablecontents[$k][$ix]["contents"]="&nbsp;";
		$ix++;
		
		$tablecontents[$k][$ix]["contents"]=$istop;
		$tablecontents[$k][$ix]["valign"]="top";
		$tablecontents[$k][$ix]["align"]="left";
		$tablecontents[$k][$ix]["nowrap"]=TRUE;
		$ix++;

		$tablecontents[$k][$ix]["contents"]="&nbsp;";
		$ix++;
		
		if ( $data["groupid"]!=0 )
			{
			$groupname = twigLink( TWIGGroupsGetName( $data["groupid"] ), "groups", "view", "data_id=" . $data["groupid"] . "&ReturnFeature=" . $context["feature"] . "&ReturnAction=" . $context["action"] ."&ReturnOptions=ItemID=$ItemID" . "&BackPhrase=" . "Back to twiggi today");
			}
		else
			{
			$groupname = TWIGGroupsGetName( $data["groupid"] );
			}
		$tablecontents[$k][$ix]["contents"]=$groupname;
		$tablecontents[$k][$ix]["valign"]="top";
		$tablecontents[$k][$ix]["align"]="left";
		$tablecontents[$k][$ix]["nowrap"]=TRUE;
		$ix++;

		$tablecontents[$k][$ix]["contents"]="&nbsp;";
		$ix++;
		
		$tablecontents[$k][$ix]["contents"]=twigLink(  $data["item"], "schedule", "view", "ItemID=" . $data["id"] );
		$tablecontents[$k][$ix]["valign"]="top";
		$tablecontents[$k][$ix]["align"]="left";
		$k++;
		}
	if ( $count > $maxschedule )
	{
		$tablecontents[$k][0]["contents"]=TwigLink( "&nbsp;<b>" . ($count+1-$maxschedule) . "&nbsp;" . $TWIGphrase["more"] . "...<b>","schedule", "", "startmsg=1" );
		$tablecontents[$k][0]["colspan"]=8;
		$k++;
	}
	if ( $tablecontents )   // Only display this block if there are any items
		{
		echo TWIGGenerateTable( $tableheaders, $tablecontents );
		}
	else
		{
		echo "<font $celltext>";
		echo $TWIGphrase["No scheduled items"] . $grpwarn . ".";
		echo "</font>";
		}
?>
  </td>
  </tr>
  </table>
  </td>
 </tr>
<tr>
<td valign=top bgcolor=<?php echo $config["cellcolor"]?> colspan=2>
&nbsp;
</td>
</tr>
<?php // --------------- today's schedule end -------------- 
	}
?>



<?php
    // --------------- today's todo begin -------------- 
 if( $havetodo && !GetPref( "todo", $dbconfig["main_prefs_table"], $config["defaults"]["main"]["todo"] ) )
 	{
	$maxtodo=GetPref( "maxtodo", $dbconfig["main_prefs_table"], $config["defaults"]["main"]["maxtodo"] );
?>
<tr>
  <td colspan=2 valign=top bgcolor="<?php echo $config["cellheadcolorlight"]?>">
   <b>&nbsp;<?php echo TwigLink( $TWIGphrase["Today's Todo"],"todo", "", "startmsg=1", "", "", "", $headtextlight )?></b>
  </td>
</tr>
<tr>
 <td valign=top bgcolor=<?php echo $config["cellcolor"]?> colspan=2>
 <font face="<?php echo $config["cellfont"]?>" size=<?php echo $config["textfontsize"];?>>

 <table cellpadding=0 cellspacing=0 border=0 width=99% align=right>
 <tr>
 <td>
<?php
unset( $tableheaders );
unset( $tablecontents );

$ix=0;
$tableheaders[$ix]["header"]="&nbsp;";
$tableheaders[$ix]["width"]="1%";
$ix++;
$tableheaders[$ix]["header"]= $TWIGphrase["due date"];
$tableheaders[$ix]["align"]="left";
$tableheaders[$ix]["nowrap"]=TRUE;
$tableheaders[$ix]["width"]="1%";
$ix++;
$tableheaders[$ix]["header"]="&nbsp;&nbsp;";
$tableheaders[$ix]["width"]="1%";
$ix++;
$tableheaders[$ix]["header"]= $TWIGphrase["group"];
$tableheaders[$ix]["align"]="left";
$tableheaders[$ix]["nowrap"]=TRUE;
$tableheaders[$ix]["width"]="1%";
$ix++;
$tableheaders[$ix]["header"]="&nbsp;&nbsp;";
$tableheaders[$ix]["width"]="1%";
$ix++;
$tableheaders[$ix]["header"]= $TWIGphrase["priority"];
$tableheaders[$ix]["align"]="center";
$tableheaders[$ix]["nowrap"]=TRUE;
$tableheaders[$ix]["width"]="1%";
$ix++;
$tableheaders[$ix]["header"]="&nbsp;&nbsp;";
$tableheaders[$ix]["width"]="1%";
$ix++;
$tableheaders[$ix]["header"]= $TWIGphrase["status"];
$tableheaders[$ix]["align"]="center";
$tableheaders[$ix]["nowrap"]=TRUE;
$tableheaders[$ix]["width"]="1%";
$ix++;
$tableheaders[$ix]["header"]="&nbsp;&nbsp;";
$tableheaders[$ix]["width"]="1%";
$ix++;
$tableheaders[$ix]["header"]= $TWIGphrase["item"];
$tableheaders[$ix]["align"]="left";
$tableheaders[$ix]["width"]="99%";
$ix++;

$query = "SELECT * FROM " . $dbconfig["todo_table"] . " WHERE " 
	. " duedate<='$sql_todayend' " 
	. " AND ($groupquery) AND (duetype='1' OR duetype='2') "
	. " AND completed!='1' AND completed!='4' ORDER BY duedate ";

$result = dbQuery( $query );
$c = dbNumRows( $result );
$k=0;
$count=-1;
$wday = TWIGdate ( "l", $todaystart );
$prev_wday=$wday;
$todayname=$TWIGphrase["today"];
for ($i=0; $i<$c; $i++)
	{
	$ix=0;
	$data = dbResultArray( $result, $i );
	$wday = TWIGdate ( "l", convertSQLTimetoUTime( $data["duedate"] ) );
	if ( $prev_wday != $wday )
		{
			if ( $count > $maxtodo )
			{
				$tablecontents[$k][0]["contents"]=TwigLink( "&nbsp;<b>" . ($count+1-$maxtodo) . "&nbsp;" . $TWIGphrase["more"] . "...<b>","todo", "", "startmsg=1" );
				$tablecontents[$k][0]["colspan"]=10;
				$k++;
			}
			$prev_wday=$wday;
			if ( $data["duedate"] >= $sql_todaystart )
				{
				if ($data["duedate"] < convertUTimeToSQLTime($todaystart+86400) )
					{
					$tablecontents[$k][0]["contents"]="<b>" . $TWIGphrase["today"] ."</b>";
					}
				else
					{
					$tablecontents[$k][0]["contents"]="<b>" . $wday ."</b>";
					}
				$tablecontents[$k][0]["valign"]="top";
				$tablecontents[$k][0]["align"]="left";
				$tablecontents[$k][0]["nowrap"]=TRUE;
				$tablecontents[$k][0]["colspan"]=10;
				$k++;
				}
			$todayname=$TWIGphrase["Day"];
			$count=-1;
		}

	$count++;
	if ( $count >= $maxtodo ) { continue; };


	$icon=Permissions( $data["id"], $dbconfig["todo_table"], 
		$img["dotowner"], 
		$img["dotmember"], 
		$img["dotrw"] );
	$tablecontents[$k][$ix]["contents"]=twigLink( "<img src=" . $icon . " border=0 title=\"" . $TWIGphrase["View Item"] . "\">", "todo", "view", "action=Edit&ItemID=" . $data["id"] );
	$tablecontents[$k][$ix]["valign"]="top";
	$tablecontents[$k][$ix]["nowrap"]=TRUE;
	$ix++;

	if ( $data["duedate"] < $sql_todaystart )
		{
		$ddtemp = "<font $warntext><b>" . TWIGdate( $config["shortdateformat"], convertSQLTimetoUTime( $data["duedate"] ) ) . "</b></font>";
		}
	elseif ( $data["duetype"]==2 )
		{
		$ddtemp = TWIGdate( TWIGGetTimeFormat(), convertSQLTimetoUTime( $data["duedate"] ) );
		}
	else
		{
		$ddtemp=$todayname;
		}
	$tablecontents[$k][$ix]["contents"]=$ddtemp;
	$tablecontents[$k][$ix]["valign"]="top";
	$tablecontents[$k][$ix]["nowrap"]=TRUE;
	$ix++;

	$tablecontents[$k][$ix]["contents"]="&nbsp;";
	$ix++;

	if ( $data["groupid"]!=0 )
		{
		$groupname = twigLink( TWIGGroupsGetName( $data["groupid"] ), "groups", "view", "data_id=" . $data["groupid"] . "&ReturnFeature=" . $context["feature"] . "&ReturnAction=" . $context["action"] ."&ReturnOptions=ItemID=$ItemID" . "&BackPhrase=" . "Back to twiggi today");
		}
	else
		{
		$groupname = TWIGGroupsGetName( $data["groupid"] );
		}
	$tablecontents[$k][$ix]["contents"]=$groupname;
	$tablecontents[$k][$ix]["valign"]="top";
	$tablecontents[$k][$ix]["nowrap"]=TRUE;
	$ix++;

	$tablecontents[$k][$ix]["contents"]="&nbsp;";
	$ix++;

	if( !isset( $data["priority"] ) )
		{
		$priority = "&nbsp;";
		}
	else
		{
		$priority = $data["priority"];
		}
	$tablecontents[$k][$ix]["contents"]=$priority;
	$tablecontents[$k][$ix]["valign"]="top";
	$tablecontents[$k][$ix]["align"]="center";
	$tablecontents[$k][$ix]["nowrap"]=TRUE;
	$ix++;

	$tablecontents[$k][$ix]["contents"]="&nbsp;";
	$ix++;

	$status = TWIGToDoStatus( $data );
	$itemp = "<img src=\"" . $img[$status] . "\" border=0 title=\"" . $TWIGphrase[$status] . "\">";
	$tablecontents[$k][$ix]["contents"]=$itemp;
	$tablecontents[$k][$ix]["valign"]="top";
	$tablecontents[$k][$ix]["align"]="center";
	$tablecontents[$k][$ix]["nowrap"]=TRUE;
	$ix++;

	$tablecontents[$k][$ix]["contents"]="&nbsp;";
	$ix++;

	$tablecontents[$k][$ix]["contents"]=twigLink(  $data["item"], "todo", "view", "ItemID=" . $data["id"] );
	$tablecontents[$k][$ix]["valign"]="top";
	$k++;
	}
	if ( $count > $maxtodo )
	{
		$tablecontents[$k][0]["contents"]=TwigLink( "&nbsp;<b>" . ($count+1-$maxtodo) . "&nbsp;" . $TWIGphrase["more"] . "...<b>","todo", "", "startmsg=1" );
		$tablecontents[$k][0]["colspan"]=10;
		$k++;
	}

	if ( $tablecontents )   // Only display this block if there are any items
		{
		echo TWIGGenerateTable( $tableheaders, $tablecontents );
		}
	else
		{
		echo "<font $celltext>";
		echo $TWIGphrase["No ToDo items"] . $grpwarn . ".";
		echo "</font>";
		}

?>
  </td>
  </tr>
  </table>
<tr>
<td valign=top bgcolor=<?php echo $config["cellcolor"]?> colspan=2>
&nbsp;
</td>
</tr>
<?php
    // --------------- today's todo end -------------- 
	}
?>
</td>
</tr>
</table>

