<?php if ( $HTTP_SERVER_VARS["PHP_SELF"] != $config["basedir"] . "/index.php" ) {exit;}; ?>
<?php	// TWIG		User Preferences Feature Module ?>
<?php

register_globals (array(

	# GET

), array(

	# POST
	"prefs_dgroup", "prefs_dperms", "prefs_viewgrp", "prefs_sortby", "prefs_sortbyway", 
	"prefs_width", "prefs_height", "prefs_pagesize", "prefs_descrwords",
	"prefs_dformat", "update", 
) );

if( !acl( "a", "prefs" ) || !acl( "r", "prefsnotes" ) ) return;
$canwrite = acl( "w", "prefsnotes" ) && acl( "a", "prefs" );

if( $update && $canwrite )
	{
	PutPref( "sortby", TWIGProcessGPCtoSQL( $prefs_sortby ), $dbconfig["notes_prefs_table"] );
	PutPref( "dgroup", TWIGProcessGPCtoSQL( $prefs_dgroup ), $dbconfig["notes_prefs_table"] );
	PutPref( "dperms", TWIGProcessGPCtoSQL( $prefs_dperms ), $dbconfig["notes_prefs_table"] );
	PutPref( "width", TWIGProcessGPCtoSQL( $prefs_width ), $dbconfig["notes_prefs_table"] );
	PutPref( "height", TWIGProcessGPCtoSQL( $prefs_height ), $dbconfig["notes_prefs_table"] );
	PutPref( "pagesize", TWIGProcessGPCtoSQL( $prefs_pagesize ), $dbconfig["notes_prefs_table"] );
	PutPref( "viewgrp", TWIGProcessGPCtoSQL( $prefs_viewgrp ), $dbconfig["notes_prefs_table"] );
	
	if( $prefs_sortbyway == "on" ) { PutPref( "sortorder", 1, $dbconfig["notes_prefs_table"] ); } else { PutPref( "sortorder", 0, $dbconfig["notes_prefs_table"] ); }
	PutPref( "descrwords", TWIGProcessGPCtoSQL( intval( abs( $prefs_descrwords) ) ), $dbconfig["notes_prefs_table"] );
	if( $prefs_dformat == "on" ) { PutPref( "dformat", 1, $dbconfig["notes_prefs_table"] ); } else { PutPref( "dformat", 0, $dbconfig["notes_prefs_table"] ); }
	}

$entry = 0;

$tableheaders = array( $TWIGphrase["Preference"], "&nbsp", $TWIGphrase["Setting"] );

$temp = "<select name=prefs_dgroup>\n";
$temp .= TWIGGroupsSelect( $login["username"], GetPref( "dgroup", $dbconfig["notes_prefs_table"], $config["defaults"]["notes"]["dgroup"] ) );
$temp .= "</select>\n";

$tablecontents[$entry] = array( array( "contents"=>"<b>" . $TWIGphrase["Default group for new items"] . ":</b>", "align"=>"right" ), "&nbsp", $temp ); $entry++;

$temp=TWIGPermsSelector("prefs_dperms", GetPref( "dperms", $dbconfig["notes_prefs_table"], 0 ));
$tablecontents[$entry] = array( array( "contents"=>"<b>" . $TWIGphrase["Default permissions for new items"] . ":</b>", "align"=>"right" ), "&nbsp", $temp ); $entry++;

$temp = "<select name=prefs_viewgrp>\n";
$temp .= TWIGGroupsSelect( $login["username"], GetPref( "viewgrp", $dbconfig["notes_prefs_table"], $config["defaults"]["notes"]["viewgrp"] ), 1 );
$temp .= "</select>\n";

$tablecontents[$entry] = array( array( "contents"=>"<b>" . $TWIGphrase["Default group to view in feature"] . ":</b>", "align"=>"right" ), "&nbsp", $temp ); $entry++;

$temp = "<select name=prefs_sortby>\n";

$sortoptions = array( "item", "date", "group" );

$j = count( $sortoptions );
$currentsort = GetPref( "sortby", $dbconfig["notes_prefs_table"], $config["defaults"]["notes"]["sortby"] );

for( $i = 0; $i < $j; $i++ )
	{
	if( $sortoptions[$i] == $currentsort ) { $selected = " selected"; } else { $selected = ""; }
 	$temp .= "<option value=\"" . $sortoptions[$i] . "\" " . $selected . ">" . $TWIGphrase[$sortoptions[$i]] . "</option>\n";
	}

$temp .= "</select>\n";

$tablecontents[$entry] = array( array( "contents"=>"<b>" . $TWIGphrase["Default sort order for notes list"] . ":</b>", "align"=>"right" ), "&nbsp", $temp ); $entry++;

if( GetPref( "sortorder", $dbconfig["notes_prefs_table"], $config["defaults"]["notes"]["sortorder"] ) )
	{
	$temp = "<input type=checkbox name=prefs_sortbyway checked>";
	}
else
	{
	$temp = "<input type=checkbox name=prefs_sortbyway>";
	}

$tablecontents[$entry] = array( array( "contents"=>"<b>" . $TWIGphrase["Invert sort order"] . ":</b>", "align"=>"right" ), "&nbsp", $temp ); $entry++;

$temp = GetPref( "width", $dbconfig["notes_prefs_table"], $config["defaults"]["notes"]["width"] );

$tablecontents[$entry] = array( array( "contents"=>"<b>" . $TWIGphrase["Width of text field"] . ":</b>", "align"=>"right" ), "&nbsp;", "<input name=prefs_width size=4 value=" . $temp .">" ); $entry++;

$temp = GetPref( "height", $dbconfig["notes_prefs_table"], $config["defaults"]["notes"]["height"] );

$tablecontents[$entry] = array( array( "contents"=>"<b>" . $TWIGphrase["Height of text field"] . ":</b>", "align"=>"right" ), "&nbsp;", "<input name=prefs_height size=4 value=" . $temp .">" ); $entry++;
$tablecontents[$entry] = array( array( "contents"=>"<b>" . $TWIGphrase["Number of items to index on one screen"] . ":</b>", "align"=>"right" ), "&nbsp", "<input name=prefs_pagesize size=5 value=\"" . GetPref( "pagesize", $dbconfig["notes_prefs_table"], $config["defaults"]["notes"]["pagesize"] ) . "\">" ); $entry++;

$tablecontents[$entry] = array( array( "contents"=>"<b>" . $TWIGphrase["Number of words of description text to be shown in list views"] . ":</b>", "align"=>"right" ), "&nbsp", "<input name=prefs_descrwords size=6 value=\"" . GetPref( "descrwords", $dbconfig["notes_prefs_table"], $config["defaults"]["notes"]["descrwords"] ) . "\">" ); $entry++;

if( GetPref( "dformat", $dbconfig["notes_prefs_table"], $config["defaults"]["notes"]["dformat"] ) )
	{
	$temp = "<input type=checkbox name=prefs_dformat checked>";
	}
else
	{
	$temp = "<input type=checkbox name=prefs_dformat>";
	}

$tablecontents[$entry] = array( array( "contents"=>"<b>" . $TWIGphrase["Default: Preserve format of description text"] . ":</b>", "align"=>"right" ), "&nbsp", $temp ); $entry++;


include "features/prefs/modules/submitbutton.inc.php";
?>
