<?php if ( $HTTP_SERVER_VARS["PHP_SELF"] != $config["basedir"] . "/index.php" ) {exit;}; ?>
<?php	// TWIG		User Preferences Feature Module ?>
<?php

register_globals (array(

	# GET

), array(

	# POST
	"prefs_dgroup", "prefs_dperms", "prefs_viewgrp", "prefs_pagesize", "prefs_descrwords", 
	"prefs_grid", "prefs_tooltips", "prefs_dformat", "update", 

) );

if( !acl( "a", "prefs" ) || !acl( "r", "prefsschedule" ) ) return;
$canwrite = acl( "w", "prefsschedule" ) && acl( "a", "prefs" );

if( $update && $canwrite )
	{
	PutPref( "dgroup", TWIGProcessGPCtoSQL( $prefs_dgroup ), $dbconfig["schedule_prefs_table"] );
	PutPref( "dperms", TWIGProcessGPCtoSQL( $prefs_dperms ), $dbconfig["schedule_prefs_table"] );
	PutPref( "pagesize", TWIGProcessGPCtoSQL( $prefs_pagesize ), $dbconfig["schedule_prefs_table"] );
	PutPref( "viewgrp", TWIGProcessGPCtoSQL( $prefs_viewgrp ), $dbconfig["schedule_prefs_table"] );
	PutPref( "descrwords", TWIGProcessGPCtoSQL( intval( abs( $prefs_descrwords) ) ), $dbconfig["schedule_prefs_table"] );
	if( $prefs_dformat == "on" ) { PutPref( "dformat", 1, $dbconfig["schedule_prefs_table"] ); } else { PutPref( "dformat", 0, $dbconfig["schedule_prefs_table"] ); }
	if( $prefs_grid == "on" ) { PutPref( "grid", 1, $dbconfig["schedule_prefs_table"] ); } else { PutPref( "grid", 0, $dbconfig["schedule_prefs_table"] ); }
	if( $prefs_tooltips == "on" ) { PutPref( "tooltips", 1, $dbconfig["schedule_prefs_table"] ); } else { PutPref( "tooltips", 0, $dbconfig["schedule_prefs_table"] ); }
	}

$entry = 0;

$tableheaders = array( $TWIGphrase["Preference"], "&nbsp", $TWIGphrase["Setting"] );

$temp = "<select name=prefs_dgroup>\n";
$temp .= TWIGGroupsSelect( $login["username"], GetPref( "dgroup", $dbconfig["schedule_prefs_table"], $config["defaults"]["schedule"]["dgroup"] ) );
$temp .= "</select>\n";

$tablecontents[$entry] = array( array( "contents"=>"<b>" . $TWIGphrase["Default group for new items"] . ":</b>", "align"=>"right" ), "&nbsp", $temp ); $entry++;

$temp=TWIGPermsSelector("prefs_dperms", GetPref( "dperms", $dbconfig["schedule_prefs_table"], 0 ));
$tablecontents[$entry] = array( array( "contents"=>"<b>" . $TWIGphrase["Default permissions for new items"] . ":</b>", "align"=>"right" ), "&nbsp", $temp ); $entry++;

$temp = "<select name=prefs_viewgrp>\n";
$temp .= TWIGGroupsSelect( $login["username"], GetPref( "viewgrp", $dbconfig["schedule_prefs_table"], $config["defaults"]["schedule"]["viewgrp"] ), 1 );
$temp .= "</select>\n";

$tablecontents[$entry] = array( array( "contents"=>"<b>" . $TWIGphrase["Default group to view in feature"] . ":</b>", "align"=>"right" ), "&nbsp", $temp ); $entry++;

$tablecontents[$entry] = array( array( "contents"=>"<b>" . $TWIGphrase["Number of items to index on list view screen"] . ":</b>", "align"=>"right" ), "&nbsp", "<input name=prefs_pagesize size=6 value=\"" . GetPref( "pagesize", $dbconfig["schedule_prefs_table"], $config["defaults"]["schedule"]["pagesize"] ) . "\">" ); $entry++;

$tablecontents[$entry] = array( array( "contents"=>"<b>" . $TWIGphrase["Number of words of description text to be shown in list views"] . ":</b>", "align"=>"right" ), "&nbsp", "<input name=prefs_descrwords size=6 value=\"" . GetPref( "descrwords", $dbconfig["schedule_prefs_table"], $config["defaults"]["schedule"]["descrwords"] ) . "\">" ); $entry++;

if( GetPref( "dformat", $dbconfig["schedule_prefs_table"], $config["defaults"]["schedule"]["dformat"] ) )
	{
	$temp = "<input type=checkbox name=prefs_dformat checked>";
	}
else
	{
	$temp = "<input type=checkbox name=prefs_dformat>";
	}

$tablecontents[$entry] = array( array( "contents"=>"<b>" . $TWIGphrase["Default: Preserve format of description text"] . ":</b>", "align"=>"right" ), "&nbsp", $temp ); $entry++;


if( GetPref( "grid", $dbconfig["schedule_prefs_table"], $config["defaults"]["schedule"]["grid"] ) )
	{
	$temp = "<input type=checkbox name=prefs_grid checked>";
	}
else
	{
	$temp = "<input type=checkbox name=prefs_grid>";
	}

$tablecontents[$entry] = array( array( "contents"=>"<b>" . $TWIGphrase["Narrow calender view"] . ":</b>", "align"=>"right" ), "&nbsp", $temp ); $entry++;

if( GetPref( "tooltips", $dbconfig["schedule_prefs_table"], $config["defaults"]["schedule"]["tooltips"] ) )
	{
	$temp = "<input type=checkbox name=prefs_tooltips checked>";
	}
else
	{
	$temp = "<input type=checkbox name=prefs_tooltips>";
	}
$tablecontents[$entry] = array( array( "contents"=>"<b>" . $TWIGphrase["Tooltips in calender views"] . ":</b>", "align"=>"right" ), "&nbsp", $temp ); $entry++;

include "features/prefs/modules/submitbutton.inc.php";
?>
