<?php 

//	twiggi web-based groupware: http://www.neddix.de/twiggi-gw 
//	is based on TWIG: http://twig.screwdriver.net

$version="1.10.3";


 $inDemoMode =  preg_match ("/\/twiggidemo/", $HTTP_SERVER_VARS["PHP_SELF"]) ;

 $cfdir="config";
 $ts1 = getmicrotime();
 $config = array();
 $dbconfig = array();
 $vhosts = array();
 $img = array();

 // Load the config options
 require( "$cfdir/config.inc.php" );	// Global Configuration Variables

 // Load the image source files
 require( "$cfdir/images.inc.php" );

 // Load the database config file
 require("$cfdir/dbconfig.inc.php");

 //ADMIN ++ ADDED (start)
 // Load the database config file
 require("$cfdir/edumail.inc.php");
 //ADMIN ++ ADDED (end)

 // Allow for virtual hosting
 $config_dir = $cfdir;
 if( $vhosts[$SERVER_NAME] ) 
	{ 
   	$config_dir = $cfdir . $vhosts[$SERVER_NAME]; 
   	include( $config_dir . "/config.inc.php" );
   	include( $config_dir . "/dbconfig.inc.php" );
   	include( $config_dir . "/images.inc.php" );
	//ADMIN ++ ADDED (start)
   	include( $config_dir . "/edumail.inc.php" );
	//ADMIN ++ ADDED (end)
 	}

 // Get the default preferences and load the prefs code.
 require( "$cfdir/defaults.inc.php" );
 if( $vhosts[$SERVER_NAME] ) { include( $config_dir . "/defaults.inc.php" ); }

if ( $inDemoMode )  // paranoia
	{
 	if (is_file( $cfdir . "/democustom.inc.php" )) { require( $cfdir . "/democustom.inc.php" ); }
 	if( $vhosts[$SERVER_NAME] ) 
		{ 
 		if (is_file( $config_dir . "/democustom.inc.php" )) { require( $config_dir . "/democustom.inc.php" ); }
		}
	}
else
	{
 	if (is_file( $cfdir . "/custom.inc.php" )) { require( $cfdir . "/custom.inc.php" ); }
 	if( $vhosts[$SERVER_NAME] ) 
		{ 
 		if (is_file( $config_dir . "/custom.inc.php" )) { require( $config_dir . "/custom.inc.php" ); }
		}
	}


# register global GET and POST vars
$refreshed_get=$HTTP_GET_VARS["refreshed"];
if ( $config["session_handler"] == "get" )
	{
	register_globals (
	# GET
	array( "ts", "twig_session", "twig_context", "test", "refreshed", "logout" ), 
	# POST
	array( "ts", "twig_session", "twig_context", "GoToFeature" ),
	FALSE );
	}
elseif ( $config["session_handler"] == "get2" )
	{
	register_globals (
	# GET
	array( "ts", "s", "c", "test", "refreshed", "logout" ), 
	# POST
	array( "ts", "s", "c", "GoToFeature" ), 
	FALSE );
	}
else
	{
	register_globals (
	# GET
	array( "ts", "ses", "ctx", "test", "refreshed", "logout"), 
	# POST
	array( "ts", "ses", "ctx", "GoToFeature"), 
	FALSE );
	}

if ( $test == "yes" )
	{
	include ("test.php");
	exit;
	}


if ( $inDemoMode ) 
	{
	$config["basedir"] = "/twiggidemo";
	$dbconfig["defaultdb"] = "twiggidemo";
	$config["login_handler"]    = "base64cookie"; // allow synchronous use of the same account
	$config["auth_logout_redirect"] = $config["basedir"] . "/" . $config["index"] ; 
	}

$quad=explode (".", $HTTP_SERVER_VARS["REMOTE_ADDR"]);
$remote_addr = ($quad[0]*16777216) + ($quad[1]*65536) + ($quad[2]*256) + $quad[3];
$localaccess=FALSE;
for ($i=0, $y=count ($config["first_local_addr"]); $i<$y; $i++)
	{
	if ( (double)$remote_addr >= (double)$config["first_local_addr"][$i] 
		&& (double)$remote_addr <= (double)$config["last_local_addr"][$i] )
		{
		$localaccess=TRUE;
		break;
		}
	}

$forceSSL = $HTTP_SERVER_VARS["SERVER_PORT"] != 443 &&
			( $config["SSL"] == "always" ||
			!$localaccess && $config["SSL"] == "external" );


Function TWIGbaseconvert ($x, $b1, $b2)
	{
	if ( TRUE ) // set to FALSE, if you are using a PHP version with broken base_convert() function
		{
		if( $b1 == 16 && $b2 == 36 ) // workaround for broken base_convert() in PHP >= 4.1.0
			{
			$x = substr( $x, 1, 16 );
			}
    	return base_convert ( $x, $b1, $b2);
		}
	return $x;
	}

 // Set up database
 if( !$dbconfig["sqltype"] ) { $dbconfig["sqltype"] = "mysql"; }
 require( "lib/db/" . $dbconfig["sqltype"] . ".db.inc.php" );

 require( "lib/mail/php-imap.inc.php" );	// include the mail subsystem

 require( "lib/auth/" . $config["auth"] . ".inc.php" );		// include the auth system...
 require( "lib/session/" . $config["session_handler"] . ".session.php" );	// include the session data handler...
 require( "lib/login/" . $config["login_handler"] . ".login.php" );	// include the login data handler...
 require( "features/common.inc.php" );					// include common functions...

 $totaltime_dbg=$tdbg=timedebug_start ("TOTAL EXECUTION TIME");
 $companygroupID=CompanyGroupID();
 $companygroup = ( $config["companycontactsgroup"] != "" );

 // Set default URL paths
 $config["baseurl"] = $config["basedir"] . "/" . $config["index"];

 // Set default IMAP parameters
 if( !$config["imap_server"] ) { $config["imap_server"] = "localhost"; }
 if( !$config["imap_port"] ) { $config["imap_port"] = "143"; } 

 // Tell browsers not to cache us.  The if is a hack to get around a problem in IE, I hate this hack but see no other way
 if( !$attachment )
	{
	Header( "Cache-Control: no-cache" );
	Header( "Pragma: no-cache" );
	Header( "Expires: Tue, Jan 12 1999 01:01:01 GMT" );
	}

 $context = TWIGGetContext(); 
 $session = TWIGGetSession();
 $login = TWIGGetLogin();

 $config["defaults"]["mail"]["fromaddress"] = $login["username"] . "@" . $config["fromdomain"];
 $config["defaults"]["mail"]["realname"] = $config["localuser"][$login["username"]];
 $config["defaults"]["mail"]["signature"] = $config["defaults"]["mail"]["realname"];
 $config["defaults"]["mail"]["replyto"] = $config["defaults"]["mail"]["fromaddress"];
 $config["defaults"]["global"]["language"] = $config["language"];
 if ( $config["imap_path"] != "" )
 	{
 	$config["imap_path"] = preg_replace ("#^(.*?)\\$config[mail_folder_delimiter]*$#", "\\1$config[mail_folder_delimiter]", $config["imap_path"]);
 	}

 if( $GoToFeature ) { TWIGGoToFeature( $GoToFeature ); parse_str( $context["options"] ); }
 if( $newmailbox ) { $session["mailbox"] = $newmailbox; }

 require( "features/shared/prefs.inc.php" );
 // language code - turn into function to load feature/language.string.php

/* NEWMAIL-POPUP-BEGIN */ 
if ( $login["username"] && $config["auth"] == "forms" ) 
	{
	$query = "SELECT expire FROM " . $dbconfig["accounts_table"] . 
	" WHERE username='" . $login["username"] . "'";
	$result=dbquery( $query );
	$refresh_auth_timeout=dbResult( $result, 0, "expire" );
	}
/* NEWMAIL-POPUP-END */

 if (!$forceSSL)
 	{
/* NEWMAIL-POPUP-BEGIN */
	$logout = $logout || ($refresh_auth_timeout<0 && !$refreshed );
/* NEWMAIL-POPUP-END */
 	$mbox = TWIGAuth( "twiggi groupware", $logout );
	}

 $config["language"] = GetPref( "language", $dbconfig["global_prefs_table"], $config["defaults"]["global"]["language"] );
 
 // The order here is reversed from what you should expect.
 // You *might* think that the specific feature's language should override the global file.
 // But, in order to allow a gradual implementation of the distributed language files,
 // we let the global file override the specific file so that we don't get English
 // for languages that haven't been updated to the new layout.
 TWIGLoadLanguageFile( "features/" . $context["feature"] . "/strings/", "", $config["language"] );
 TWIGLoadLanguageFile( "lib/strings/", "", $config["language"] );
 require( "features/" . $context["feature"] . "/" . $context["feature"] . ".inc.php" );

 // Set group info
 require( "lib/system/groups.inc.php" );

 require( "features/twig.colorscheme.inc.php" );

 $sorted[0] = 1;

?>

<html>
<?php
	if( $config["metaheaders"] ) { echo $config["metaheaders"]; }
/* NEWMAIL-POPUP-BEGIN */
TWIGDebug( "refeshpage=" . is_refresh_page( $context["feature"], $context["action"], $localaccess ) );
TWIGDebug( "feature=<b>" .  $context["feature"] . "</b>" );
TWIGDebug( "action=<b>" . $context["action"] . "</b>" );
if( is_refresh_page( $context["feature"], $context["action"], $localaccess ) )
	{
	if ( !$refreshed ) $session["refreshstart"]=time();
	if ( !$refreshed || $config["session_handler"] == "php4session" )
		{
		$refreshed++;
		// very first refresh: do not refresh, but redirect. This causes
		// $session var to be set
		$url = "; url=" . $config["baseurl"] 
		. "?ts=" . TWIGbaseconvert(md5(uniqid(getmypid(),TRUE)), 16, 36)
		. "&refreshed=$refreshed" . TWIGSession( "get") . TWIGContext( "get", "main", "main");
		}
	$cf=$context["feature"]=="main"?"refreshmain":"returntomain";
	echo "<meta http-equiv=\"refresh\" content=\"" .
	60*GetPref( $cf, $dbconfig["main_prefs_table"], $config["defaults"]["main"][$cf] ) . "$url\">";

	// update session expiry for refresh mode
	if ( $refreshed && $config["auth"] == "forms" ) 
		{
		if( $refresh_auth_timeout >= 0 )
			{
			$refresh_auth_timeout
				=$session["refreshstart"] + $config["auth_timeout"] - time();
			$query = "UPDATE " . $dbconfig["accounts_table"] . " SET expire='" . 
			$refresh_auth_timeout . 
			"' WHERE username='" . $login["username"] . "'";   
			dbquery( $query );
			}

		}
	}
/* NEWMAIL-POPUP-END */
?>

<?php
 // check for new mail
if( !$forceSSL && 
	!GetPref( "mailfoot", $dbconfig["global_prefs_table"], $config["defaults"]["global"]["mailfoot"] ) &&
	acl( "r", "mail" ) )
	{
 	if ($config["tdbg"]) $tdbg=timedebug_start ("check for new mail");
 	if ( $context["feature"] == "mail" && 
			( $context["action"] == "main" || $context["action"] == "msgview" ) && 
			$session["mailbox"] == "INBOX" ) 
		{
		unset ( $session["newmsgs"] );
		}
 	$mbox_inbox = TWIGOpenMB( "INBOX" );
 	$newmsgs=TWIGCheckNewMail( $mbox_inbox );
	TWIGCloseMB( $mbox_inbox ); 
 	if ( $newmsgs > 0 ) $session["newmsgs"] += $newmsgs;
 	if ($config["tdbg"]) timedebug_stop ($tdbg);
 	}
?>

<head>
<title><?php echo $pagetitle;?></title>
<?php
//ADMIN ++ ADDED (start)
if (!empty($config["globalcharset"])) echo '<meta http-equiv="Content-Type" content="text/html; charset='.$config["globalcharset"].'">'."\n";
//ADMIN ++ ADDED (end)
?>
<!-- /* NEWMAIL-POPUP-BEGIN */ -->
<?php 
	$popup_newmail=is_refresh_page( $context["feature"], $context["action"], $localaccess ) &&
		$newmsgs>0 && $refreshed_get &&
		GetPref( "newmailpopup", $dbconfig["main_prefs_table"], $config["defaults"]["main"]["newmailpopup"] );
if( $popup_newmail )
	{
	js_start();
	echo "<!--\n";
	$url = $config["basedir"] . "/shp.php?" . 
	"msg=" . urlencode( $TWIGphrase["You have new mail"] ) . "&" .
	"time=" . urlencode( TWIGlocaldate( TWIGGetTimeFormat(), time() ) ) . "&" .
	"closewindow=" . urlencode( $TWIGphrase["Close window"] ) . "&" .
	"img=" . $img["logo"];
	echo "function topPopup(){\n";
	echo "popup =\n";
	echo "window.open(\"$url\",\"newmail\",\"height=200,width=250,location=0,directories=0,toolbar=0,resizable=0,scrollbars=0\");";
	echo "return popup;";
	echo "}\n";
	echo "// -->\n";
	js_end();
	}

if( $context["feature"] == "popups" )
	{
	echo '<meta http-equiv="pragma" content="no-cache">', "\n";
	}
?>
<!-- /* NEWMAIL-POPUP-END */ -->

</head>

<?php

/* NEWMAIL-POPUP-BEGIN */
 if( $refresh_auth_timeout >= 0 )
/* NEWMAIL-POPUP-END */
 	include( $config_dir . "/header.inc.php" );
 
/* NEWMAIL-POPUP-BEGIN */
if( $popup_newmail )
	{
	echo "\n";
	js_start();
	echo "<!--\n";
	echo "nw=topPopup();\n";
	echo "nw.close();\n";
	echo "nw=topPopup();\n";
	echo "nw.moveTo(1,30);\n";
	echo "// -->\n";
	js_end();
	echo "\n";
	}

 if( $refresh_auth_timeout >= 0 )
 	{
/* NEWMAIL-POPUP-END */
	 if ($forceSSL)
	 	{
		?>
		<H2>twiggi over HTTP is disabled</H2>
		<P>twiggi is currently disabled for access by a non-SSL enabled browser.<br>
		If you have an 128 bit SSL enabled browser and would like to access twiggi over an
		SSL connection, please click 
		<a href="https://<?php print $HTTP_SERVER_VARS["SERVER_NAME"].$HTTP_SERVER_VARS["PHP_SELF"];?>">
		<b>here</b></a>.
		<br>
		<br>
		<H2>twiggi &uuml;ber HTTP ist gesperrt</H2>
		<P>twiggi ist fr den Zugriff ohne Verschl&uuml;sselung gesperrt.<br>
		Falls Ihr Browser 128-bit-Verschl&uuml;sselung unterst&uuml;tzt, k&ouml;nnen Sie twiggi
		&uuml;ber eine sichere SSL-Verbindung nutzen. Bitte klicken Sie 
		<a href="https://<?php print $HTTP_SERVER_VARS["SERVER_NAME"].$HTTP_SERVER_VARS["PHP_SELF"];?>">
		<b>hier</b></a>.
		<?php
		}
	 else
	 	{
	 	if( !$TWIGNoHeader && $context["feature"] != "popups" ) 
	 		{ 
			include( "features/twig.header.inc.php" ); 
			}
	 	flush();
		

	 	require( "features/" . $context["feature"] . "/" . $context["feature"] . ".feature.php" );
	 	flush();
		$TWIGNoFooter=TRUE;
	 	if( !$TWIGNoFooter ) { include( "features/twig.footer.inc.php" ); }
	 	require( $config_dir . "/footer.inc.php" );
	
	 	TWIGCloseMB( $mbox );
		}
/* NEWMAIL-POPUP-BEGIN */
	}
else
	{
	echo "<body bgcolor=\"" . $config["bgcolor"] . "\">";
	echo "<img src=\"" . $img["logo"] . "\"><br><br>";
	echo "<font $celltext>";
	echo $TWIGphrase["Your session has been closed."] . "<br>";
	echo $TWIGphrase["You have been inactive for too long."] . "<br><br>";
	echo TwigLink( $TWIGphrase["Click here to log into twiggi..."],"main", "", "", "", "", "", "" );
	echo "</font>";
 	if( !$TWIGNoFooter ) { include( "features/twig.footer.inc.php" ); }
 	require( $config_dir . "/footer.inc.php" );

 	TWIGCloseMB( $mbox );
	}
/* NEWMAIL-POPUP-END */

 	TWIGDebug( "Page output time - " . ( getmicrotime() - $ts1 ) );
 	TWIGDebug( "IMAP open/close nesting=$imap_oc_nesting<br>" );
 if ( $config["tdbg"] ) 
 	{
	timedebug_stop( $totaltime_dbg );
 	timedebug_table ();
	}

 Function getmicrotime()
	{
 	$mtime = microtime();
 	$mtime = explode( " ", $mtime );
 	$mtime = $mtime[1] + $mtime[0];
 	return( $mtime );
	}


Function register_globals ($get=array(), $post=array(), $unset=TRUE )
	{
	GLOBAL $HTTP_POST_VARS, $HTTP_GET_VARS, $globalpost, $globalget, $unreg_post, $unreg_get, $config;

	if( is_array( $HTTP_GET_VARS ) )
		{
		reset( $HTTP_GET_VARS );
		while ( list( $k, $v )=each($HTTP_GET_VARS) )
			{
			if ( in_array( $k, $get ) )
				{
				GLOBAL $$k;
				$$k=$v;
				unset($HTTP_GET_VARS[$k]);
				if( $config["debug"] )
					{
					if( is_array( $v ) )
						{
						reset( $v );
						while ( list( $kv, $vv )=each($v) )
							{
							//ADMIN ++ ADDED (htmlentities -> TWIGhtmlentities)
							$globalget .= "<b>$k" . "[$kv]" . "</b> = \"" . TWIGhtmlentities( $vv ) . "\"<br>";
							}
						}
					else
						{
						//ADMIN ++ ADDED (htmlentities -> TWIGhtmlentities)
						$globalget .= "<b>$k</b> = \"" . TWIGhtmlentities( $v ) . "\"<br>";
						}
					}
				}
			elseif ( $unset )
				{
				//ADMIN ++ ADDED (htmlentities -> TWIGhtmlentities)
				$unreg_get[$k]=TWIGhtmlentities($v);
				unset( $GLOBALS[$k] );
				}
			}
		if( $unset ) unset( $GLOBALS["HTTP_GET_VARS"] );
		}

	if( is_array( $HTTP_POST_VARS ) )
		{
		reset( $HTTP_POST_VARS );
		while ( list( $k, $v )=each($HTTP_POST_VARS) )
			{
			if ( in_array( $k, $post ) )
				{
				GLOBAL $$k;
				$$k=$v;
				unset($HTTP_POST_VARS[$k]);
				if( $config["debug"] )
					{
					if( is_array( $v ) )
						{
						reset( $v );
						while ( list( $kv, $vv )=each($v) )
							{
							//ADMIN ++ ADDED (htmlentities -> TWIGhtmlentities)
							$globalpost .= "<b>$k" . "[$kv]" . "</b> = \"" . TWIGhtmlentities( $vv ) . "\"<br>";
							}
						}
					else
						{
						//ADMIN ++ ADDED (htmlentities -> TWIGhtmlentities)
						$globalpost .= "<b>$k</b> = \"" . TWIGhtmlentities( $v ) . "\"<br>";
						}
					}
				}
			elseif ( $unset ) 
				{
				//ADMIN ++ ADDED (htmlentities -> TWIGhtmlentities)
				$unreg_post[$k]=TWIGhtmlentities($v);
				unset( $GLOBALS[$k] );
				}
			}
		if( $unset ) unset( $GLOBALS["HTTP_POST_VARS"] );
		}
	}


Function print_unregistered_globals()
	{
	GLOBAL $unreg_post, $unreg_get;
	if( is_array($unreg_post) )
		{
		echo "<font color=#cc0000>";
		while ( list( $k, $v )=each($unreg_post) )
			{
			print "unreg. POSTVAR: $k = $v<br>";
			}
		echo "</font><br>";
		}

	if( is_array($unreg_get) )
		{
		echo "<font color=#cc0000>";
		while ( list( $k, $v )=each($unreg_get) )
			{
			print "unreg. GETVAR: $k = $v<br>";
			}
		echo "</font><br>";
		}
	}

print_unregistered_globals();

	if( $config["debug"] )
		{
		if( $globalpost) print "Global POST:<br>$globalpost";
		if( $globalget ) print "Global GET:<br>$globalget";
		}
?>
</html>
