# phpMyAdmin MySQL-Dump
# version 2.3.2
# http://www.phpmyadmin.net/ (download page)
#
# Pota: localhost
# Vygenerovno: ter  4. nora 2003, 09:26
# Verze MySQL: 3.23.48
# Verze PHP: 4.1.0
# Databze : `linmail`
# --------------------------------------------------------

#
# Struktura tabulky `twig_access`
#

DROP TABLE IF EXISTS twig_access;
CREATE TABLE twig_access (
  id int(11) NOT NULL auto_increment,
  username varchar(128) NOT NULL default '',
  twiggi int(11) NOT NULL default '0',
  mail int(11) NOT NULL default '0',
  contacts int(11) NOT NULL default '0',
  schedule int(11) NOT NULL default '0',
  files int(11) NOT NULL default '0',
  todo int(11) NOT NULL default '0',
  notes int(11) NOT NULL default '0',
  bookmarks int(11) NOT NULL default '0',
  groups int(11) NOT NULL default '0',
  prefs int(11) NOT NULL default '0',
  resources int(11) default '0',
  PRIMARY KEY  (id),
  KEY username (username)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Struktura tabulky `twig_accounts`
#

DROP TABLE IF EXISTS twig_accounts;
CREATE TABLE twig_accounts (
  id int(10) unsigned NOT NULL auto_increment,
  username varchar(128) NOT NULL default '',
  password varchar(128) default NULL,
  SID int(10) default NULL,
  onnow bigint(21) default NULL,
  expire bigint(21) default NULL,
  laston bigint(21) default NULL,
  PRIMARY KEY  (id),
  KEY username (username)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Struktura tabulky `twig_announce`
#

DROP TABLE IF EXISTS twig_announce;
CREATE TABLE twig_announce (
  id int(11) NOT NULL auto_increment,
  thedate timestamp(14) NOT NULL,
  username varchar(128) NOT NULL default '',
  email varchar(128) default NULL,
  subject varchar(128) NOT NULL default '',
  announce longtext NOT NULL,
  PRIMARY KEY  (id)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Struktura tabulky `twig_bookmarks`
#

DROP TABLE IF EXISTS twig_bookmarks;
CREATE TABLE twig_bookmarks (
  id int(11) NOT NULL auto_increment,
  username varchar(128) NOT NULL default '',
  cuser varchar(128) NOT NULL default '',
  permtype int(11) default '0',
  permid int(11) default NULL,
  thedate timestamp(14) NOT NULL,
  cdate timestamp(14) NOT NULL,
  groupid int(11) NOT NULL default '0',
  item text,
  description text,
  format int(11) default '0',
  url text,
  PRIMARY KEY  (id),
  KEY id (id),
  KEY username (username),
  KEY groupid (groupid)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Struktura tabulky `twig_bookmarks_prefs`
#

DROP TABLE IF EXISTS twig_bookmarks_prefs;
CREATE TABLE twig_bookmarks_prefs (
  id int(11) NOT NULL auto_increment,
  username varchar(128) NOT NULL default '',
  sortby varchar(10) NOT NULL default '',
  sortorder int(1) NOT NULL default '0',
  dgroup int(11) NOT NULL default '0',
  pagesize int(11) NOT NULL default '0',
  viewgrp int(11) NOT NULL default '0',
  descrwords int(11) NOT NULL default '0',
  dformat int(11) default '0',
  dperms int(11) default '0',
  tooltips int(11) default '1',
  fullurl int(11) default '1',
  PRIMARY KEY  (id),
  KEY username (username)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Struktura tabulky `twig_contacts`
#

DROP TABLE IF EXISTS twig_contacts;
CREATE TABLE twig_contacts (
  id int(11) NOT NULL auto_increment,
  username varchar(128) NOT NULL default '',
  cuser varchar(128) NOT NULL default '',
  permtype int(11) default '0',
  permid int(11) default NULL,
  thedate timestamp(14) NOT NULL,
  cdate timestamp(14) NOT NULL,
  groupid int(11) NOT NULL default '0',
  item text,
  description text,
  format int(11) default '0',
  url text,
  firstname varchar(100) default NULL,
  lastname varchar(100) default NULL,
  email varchar(100) default NULL,
  company varchar(100) default NULL,
  home_phone varchar(30) default NULL,
  work_phone varchar(30) default NULL,
  mobile varchar(30) default NULL,
  fax varchar(30) default NULL,
  address1 varchar(200) default NULL,
  address2 varchar(200) default NULL,
  city varchar(100) default NULL,
  state varchar(100) default NULL,
  zipcode varchar(10) default NULL,
  country varchar(100) default NULL,
  email2 varchar(100) default NULL,
  email3 varchar(100) default NULL,
  title varchar(100) default NULL,
  pager varchar(30) default NULL,
  ofax varchar(30) default NULL,
  department varchar(100) default NULL,
  office varchar(100) default NULL,
  spouse varchar(100) default NULL,
  bday varchar(40) default NULL,
  oaddress1 varchar(100) default NULL,
  oaddress2 varchar(100) default NULL,
  ocity varchar(100) default NULL,
  ozip varchar(10) default NULL,
  ostate varchar(100) default NULL,
  ocountry varchar(100) default NULL,
  type int(11) default NULL,
  userpers int(11) default '0',
  PRIMARY KEY  (id),
  KEY username (username),
  KEY groupid (groupid)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Struktura tabulky `twig_contacts_lists_entries`
#

DROP TABLE IF EXISTS twig_contacts_lists_entries;
CREATE TABLE twig_contacts_lists_entries (
  listid int(11) NOT NULL default '0',
  type int(11) NOT NULL default '0',
  item int(11) NOT NULL default '0',
  subitem int(11) default NULL,
  KEY listid (listid),
  KEY item (item)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Struktura tabulky `twig_contacts_prefs`
#

DROP TABLE IF EXISTS twig_contacts_prefs;
CREATE TABLE twig_contacts_prefs (
  id int(11) NOT NULL auto_increment,
  username varchar(128) NOT NULL default '',
  sortby varchar(10) NOT NULL default '',
  sortorder int(1) NOT NULL default '0',
  dgroup int(11) NOT NULL default '0',
  pagesize int(11) NOT NULL default '0',
  viewgrp varchar(10) NOT NULL default '0',
  descrwords int(11) NOT NULL default '0',
  dformat int(11) default '0',
  dperms int(11) default '0',
  tooltips int(11) default '1',
  PRIMARY KEY  (id),
  KEY username (username)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Struktura tabulky `twig_context`
#

DROP TABLE IF EXISTS twig_context;
CREATE TABLE twig_context (
  id varchar(40) NOT NULL default '',
  username varchar(128) NOT NULL default '',
  context longtext NOT NULL,
  sid int(11) NOT NULL default '0',
  KEY id (id),
  KEY username (username),
  KEY sid (sid)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Struktura tabulky `twig_file_pathes`
#

DROP TABLE IF EXISTS twig_file_pathes;
CREATE TABLE twig_file_pathes (
  id int(11) NOT NULL auto_increment,
  path text,
  groupid int(11) NOT NULL default '0',
  username varchar(128) NOT NULL default '',
  PRIMARY KEY  (id)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Struktura tabulky `twig_files`
#

DROP TABLE IF EXISTS twig_files;
CREATE TABLE twig_files (
  id int(11) NOT NULL auto_increment,
  pid int(11) NOT NULL default '0',
  item varchar(128) NOT NULL default '',
  keywords text,
  recentrev int(11) NOT NULL default '0',
  username varchar(128) NOT NULL default '',
  cuser varchar(128) NOT NULL default '',
  permtype int(11) default '0',
  permid int(11) default NULL,
  thedate timestamp(14) NOT NULL,
  cdate timestamp(14) NOT NULL,
  groupid int(11) NOT NULL default '0',
  description text,
  format int(11) default NULL,
  lockedby varchar(128) NOT NULL default '',
  lockedon timestamp(14) NOT NULL,
  nus text NOT NULL,
  fid int(11) NOT NULL default '0',
  revcnt int(11) NOT NULL default '0',
  revid text NOT NULL,
  filename varchar(128) NOT NULL default '',
  fspath text,
  filetype varchar(128) NOT NULL default '',
  filetypemime varchar(128) NOT NULL default '',
  filesize int(11) NOT NULL default '0',
  archive int(11) NOT NULL default '0',
  useblob int(11) NOT NULL default '0',
  thefile longblob NOT NULL,
  type int(11) default '0',
  PRIMARY KEY  (id),
  KEY item (item)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Struktura tabulky `twig_files_prefs`
#

DROP TABLE IF EXISTS twig_files_prefs;
CREATE TABLE twig_files_prefs (
  id int(11) NOT NULL auto_increment,
  username varchar(128) NOT NULL default '',
  sortby varchar(10) NOT NULL default '',
  sortorder int(1) NOT NULL default '0',
  dgroup int(11) NOT NULL default '0',
  pagesize int(11) default NULL,
  viewgrp varchar(10) NOT NULL default '0',
  descrwords int(11) NOT NULL default '0',
  dformat int(11) default NULL,
  dperms int(11) default '0',
  PRIMARY KEY  (id),
  KEY username (username)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Struktura tabulky `twig_folders`
#

DROP TABLE IF EXISTS twig_folders;
CREATE TABLE twig_folders (
  id int(10) unsigned NOT NULL auto_increment,
  owner varchar(128) NOT NULL default '',
  server varchar(255) NOT NULL default '',
  port int(11) NOT NULL default '0',
  groupname varchar(255) NOT NULL default '',
  username varchar(128) default NULL,
  password varchar(128) default NULL,
  servertype varchar(10) default NULL,
  PRIMARY KEY  (id),
  KEY owner (owner),
  KEY groupname (groupname)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Struktura tabulky `twig_global_prefs`
#

DROP TABLE IF EXISTS twig_global_prefs;
CREATE TABLE twig_global_prefs (
  id int(11) NOT NULL auto_increment,
  username varchar(128) NOT NULL default '',
  javascript int(11) default '0',
  mstyle1 tinyint(4) NOT NULL default '0',
  mstyle2 tinyint(4) NOT NULL default '3',
  language varchar(20) default NULL,
  helplanguage varchar(20) default NULL,
  mailfoot tinyint(4) default NULL,
  prevnext varchar(20) default NULL,
  timeformat int(11) default NULL,
  dateformat int(11) NOT NULL default '0',
  extgroupview int(11) NOT NULL default '0',
  colorscheme int(11) default '0',
  fontfamily int(11) default '0',
  fontsize int(11) default '1',
  office_hours_start float default '8',
  office_hours_end float default '17',
  tooltips int(11) default '1',
  singletimeselector int(11) default '0',
  usecss int(11) default '0',
  PRIMARY KEY  (id),
  KEY username (username)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Struktura tabulky `twig_groups`
#

DROP TABLE IF EXISTS twig_groups;
CREATE TABLE twig_groups (
  id int(11) NOT NULL auto_increment,
  owner varchar(128) NOT NULL default '',
  thedate timestamp(14) NOT NULL,
  cdate timestamp(14) NOT NULL,
  cuser varchar(128) NOT NULL default '',
  permtype int(11) default '0',
  permid int(11) default NULL,
  groupname varchar(100) default NULL,
  type varchar(20) default NULL,
  description text,
  PRIMARY KEY  (id),
  KEY owner (owner)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Struktura tabulky `twig_groups_prefs`
#

DROP TABLE IF EXISTS twig_groups_prefs;
CREATE TABLE twig_groups_prefs (
  id int(11) NOT NULL auto_increment,
  username varchar(128) NOT NULL default '',
  dperms int(11) default '0',
  tooltips int(11) default '1',
  PRIMARY KEY  (id),
  KEY username (username)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Struktura tabulky `twig_holiday_dates`
#

DROP TABLE IF EXISTS twig_holiday_dates;
CREATE TABLE twig_holiday_dates (
  nid int(11) NOT NULL default '0',
  thedate timestamp(14) NOT NULL
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Struktura tabulky `twig_holiday_names`
#

DROP TABLE IF EXISTS twig_holiday_names;
CREATE TABLE twig_holiday_names (
  nid int(11) NOT NULL default '0',
  name varchar(128) NOT NULL default '',
  countrycode text NOT NULL,
  fixed int(11) default NULL,
  PRIMARY KEY  (nid)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Struktura tabulky `twig_holiday_selection`
#

DROP TABLE IF EXISTS twig_holiday_selection;
CREATE TABLE twig_holiday_selection (
  nid int(11) NOT NULL default '0',
  type int(11) NOT NULL default '0'
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Struktura tabulky `twig_lhsqltable`
#

DROP TABLE IF EXISTS twig_lhsqltable;
CREATE TABLE twig_lhsqltable (
  LID varchar(40) NOT NULL default '0',
  username varchar(128) NOT NULL default '',
  password varchar(128) NOT NULL default '',
  expire bigint(21) NOT NULL default '0',
  PRIMARY KEY  (LID)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Struktura tabulky `twig_mail_prefs`
#

DROP TABLE IF EXISTS twig_mail_prefs;
CREATE TABLE twig_mail_prefs (
  id int(11) NOT NULL auto_increment,
  username varchar(128) NOT NULL default '',
  realname text,
  signature text,
  signature2 text,
  signature3 text,
  defaultsig int(11) default '1',
  signature4 text,
  linewrap text,
  replyto text,
  pagesize int(11) default NULL,
  sortby varchar(10) default NULL,
  sortorder int(11) default NULL,
  dande int(11) default NULL,
  savesent int(11) default NULL,
  sentfold text,
  draftfold text,
  cmdline2 int(11) default NULL,
  newwindow int(11) default NULL,
  newcontact int(11) default NULL,
  mailtree int(11) default NULL,
  mtexpand int(11) default NULL,
  mtview varchar(255) default NULL,
  mdn int(11) default NULL,
  mdn_mode int(11) default NULL,
  areply int(11) default NULL,
  aforward int(11) default NULL,
  clines int(11) default NULL,
  clines_ot int(11) default '27',
  mande int(11) default NULL,
  dreturn int(11) default NULL,
  fromaddress varchar(128) default NULL,
  checkbox_pos int(11) default NULL,
  strike_deleted int(11) default NULL,
  tooltips int(11) default '1',
  PRIMARY KEY  (id),
  KEY username (username)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Struktura tabulky `twig_mail_tree`
#

DROP TABLE IF EXISTS twig_mail_tree;
CREATE TABLE twig_mail_tree (
  id int(11) NOT NULL auto_increment,
  username varchar(128) NOT NULL default '',
  mtview varchar(255) default NULL,
  PRIMARY KEY  (id),
  KEY username (username)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Struktura tabulky `twig_maildrafts`
#

DROP TABLE IF EXISTS twig_maildrafts;
CREATE TABLE twig_maildrafts (
  id int(11) NOT NULL auto_increment,
  username varchar(128) NOT NULL default '',
  thedate timestamp(14) NOT NULL,
  body longtext NOT NULL,
  att text NOT NULL,
  PRIMARY KEY  (id),
  KEY username (username)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Struktura tabulky `twig_main_prefs`
#

DROP TABLE IF EXISTS twig_main_prefs;
CREATE TABLE twig_main_prefs (
  id int(11) NOT NULL auto_increment,
  username varchar(128) NOT NULL default '',
  schedule tinyint(1) NOT NULL default '1',
  recentmail tinyint(1) NOT NULL default '1',
  viewgrp varchar(10) default NULL,
  todo tinyint(1) NOT NULL default '1',
  maxmail int(11) default NULL,
  maxschedule int(11) default NULL,
  maxtodo int(11) default NULL,
  todaymail int(11) default NULL,
  tooltips int(11) default '1',
  onlyactivetodo int(11) default '0',
  returntomain int(11) default '0',
  refreshmain int(11) default '0',
  newmailpopup int(11) default '0',
  PRIMARY KEY  (id),
  KEY username (username)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Struktura tabulky `twig_members`
#

DROP TABLE IF EXISTS twig_members;
CREATE TABLE twig_members (
  id int(11) NOT NULL auto_increment,
  groupid int(11) NOT NULL default '0',
  username varchar(128) NOT NULL default '',
  writeperms int(11) default NULL,
  PRIMARY KEY  (id),
  KEY groupid (groupid)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Struktura tabulky `twig_notes`
#

DROP TABLE IF EXISTS twig_notes;
CREATE TABLE twig_notes (
  id int(11) NOT NULL auto_increment,
  username varchar(128) NOT NULL default '',
  cuser varchar(128) NOT NULL default '',
  permtype int(11) default '0',
  permid int(11) default NULL,
  thedate timestamp(14) NOT NULL,
  cdate timestamp(14) NOT NULL,
  groupid int(11) NOT NULL default '0',
  item text,
  description text,
  format int(11) default '0',
  attachname text,
  attachment text,
  PRIMARY KEY  (id),
  KEY username (username)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Struktura tabulky `twig_notes_prefs`
#

DROP TABLE IF EXISTS twig_notes_prefs;
CREATE TABLE twig_notes_prefs (
  id int(11) NOT NULL auto_increment,
  username varchar(128) NOT NULL default '',
  sortby varchar(10) NOT NULL default '',
  sortorder int(1) NOT NULL default '0',
  dgroup int(11) NOT NULL default '0',
  width int(11) default NULL,
  height int(11) default NULL,
  pagesize int(11) default NULL,
  viewgrp varchar(10) NOT NULL default '0',
  descrwords int(11) NOT NULL default '0',
  dformat int(11) default '0',
  dperms int(11) default '0',
  tooltips int(11) default '1',
  PRIMARY KEY  (id),
  KEY username (username)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Struktura tabulky `twig_resource_booking`
#

DROP TABLE IF EXISTS twig_resource_booking;
CREATE TABLE twig_resource_booking (
  sid int(11) NOT NULL default '0',
  rid int(11) NOT NULL default '0',
  status int(11) default '0',
  thedate timestamp(14) NOT NULL,
  recurr_end timestamp(14) NOT NULL,
  comment varchar(128) NOT NULL default '',
  KEY id (sid),
  KEY rid (rid)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Struktura tabulky `twig_resource_mgr`
#

DROP TABLE IF EXISTS twig_resource_mgr;
CREATE TABLE twig_resource_mgr (
  id int(11) NOT NULL default '0',
  groupid int(11) NOT NULL default '0',
  username varchar(128) NOT NULL default '',
  KEY id (id)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Struktura tabulky `twig_resource_prefs`
#

DROP TABLE IF EXISTS twig_resource_prefs;
CREATE TABLE twig_resource_prefs (
  id int(11) NOT NULL auto_increment,
  username varchar(128) NOT NULL default '',
  sortby varchar(10) NOT NULL default '',
  sortorder int(1) NOT NULL default '0',
  pagesize int(11) default NULL,
  descrwords int(11) NOT NULL default '0',
  dformat int(11) default NULL,
  dmanaged int(11) default NULL,
  dallusers int(11) default NULL,
  PRIMARY KEY  (id),
  KEY username (username)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Struktura tabulky `twig_resource_users`
#

DROP TABLE IF EXISTS twig_resource_users;
CREATE TABLE twig_resource_users (
  id int(11) NOT NULL default '0',
  groupid int(11) NOT NULL default '0',
  username varchar(128) NOT NULL default '',
  KEY id (id)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Struktura tabulky `twig_resources`
#

DROP TABLE IF EXISTS twig_resources;
CREATE TABLE twig_resources (
  id int(11) NOT NULL auto_increment,
  item varchar(128) NOT NULL default '',
  thedate timestamp(14) NOT NULL,
  cdate timestamp(14) NOT NULL,
  cuser varchar(128) NOT NULL default '',
  username varchar(128) NOT NULL default '',
  managed int(11) NOT NULL default '0',
  allusers int(11) NOT NULL default '0',
  description text,
  format int(11) default '0',
  PRIMARY KEY  (id)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Struktura tabulky `twig_schedule`
#

DROP TABLE IF EXISTS twig_schedule;
CREATE TABLE twig_schedule (
  id int(11) NOT NULL auto_increment,
  username varchar(128) NOT NULL default '',
  cuser varchar(128) NOT NULL default '',
  permtype int(11) default '0',
  permid int(11) default NULL,
  thedate timestamp(14) NOT NULL,
  cdate timestamp(14) NOT NULL,
  groupid int(11) NOT NULL default '0',
  itemstart timestamp(14) NOT NULL,
  itemstop timestamp(14) NOT NULL,
  item text,
  description text,
  format int(11) default '0',
  notime int(11) default NULL,
  recurtype int(11) default NULL,
  recurid int(11) default NULL,
  ress_note varchar(128) default '',
  location varchar(128) default '',
  allow_mrequests int(11) default '0',
  resourcebooked int(11) default '0',
  PRIMARY KEY  (id),
  KEY username (username),
  KEY thedate (thedate),
  KEY groupid (groupid),
  KEY itemstart (itemstart),
  KEY itemstop (itemstop)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Struktura tabulky `twig_schedule_prefs`
#

DROP TABLE IF EXISTS twig_schedule_prefs;
CREATE TABLE twig_schedule_prefs (
  id int(11) NOT NULL auto_increment,
  username varchar(128) NOT NULL default '',
  dgroup int(11) NOT NULL default '0',
  viewgrp varchar(10) NOT NULL default '0',
  descrwords int(11) default '9999',
  dformat int(11) default '0',
  dperms int(11) default '0',
  grid int(11) default NULL,
  tooltips int(11) default '1',
  extended_monthly_view int(11) default NULL,
  pagesize int(11) default '15',
  PRIMARY KEY  (id),
  KEY username (username)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Struktura tabulky `twig_schedule_recurring`
#

DROP TABLE IF EXISTS twig_schedule_recurring;
CREATE TABLE twig_schedule_recurring (
  id int(11) NOT NULL auto_increment,
  schid int(11) NOT NULL default '0',
  recurtype int(11) NOT NULL default '0',
  schedule int(11) default NULL,
  cycle int(11) default NULL,
  position int(11) default NULL,
  days varchar(13) default NULL,
  endtype int(11) NOT NULL default '0',
  first timestamp(14) NOT NULL,
  last timestamp(14) NOT NULL,
  end timestamp(14) NOT NULL,
  occure int(11) default '1',
  PRIMARY KEY  (id),
  KEY schid (schid),
  KEY recurtype (recurtype),
  KEY endtype (endtype),
  KEY end (end)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Struktura tabulky `twig_sclhsqltable`
#

DROP TABLE IF EXISTS twig_sclhsqltable;
CREATE TABLE twig_sclhsqltable (
  LID varchar(40) NOT NULL default '0',
  pwdata varchar(128) NOT NULL default '0',
  username varchar(128) NOT NULL default '',
  expire bigint(21) NOT NULL default '0',
  PRIMARY KEY  (LID)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Struktura tabulky `twig_session`
#

DROP TABLE IF EXISTS twig_session;
CREATE TABLE twig_session (
  id varchar(40) NOT NULL default '',
  username varchar(128) NOT NULL default '',
  sdata longtext NOT NULL,
  sid int(11) NOT NULL default '0',
  KEY id (id),
  KEY username (username),
  KEY sid (sid)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Struktura tabulky `twig_threadcache`
#

DROP TABLE IF EXISTS twig_threadcache;
CREATE TABLE twig_threadcache (
  fingerprint varchar(128) NOT NULL default '',
  Nmsgs int(11) NOT NULL default '0',
  mailbox text,
  username varchar(128) NOT NULL default '',
  type char(1) NOT NULL default '',
  cache longtext,
  thedate timestamp(14) NOT NULL,
  KEY fingerprint (fingerprint),
  KEY Nmsgs (Nmsgs),
  KEY username (username),
  KEY type (type)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Struktura tabulky `twig_todo`
#

DROP TABLE IF EXISTS twig_todo;
CREATE TABLE twig_todo (
  id int(11) NOT NULL auto_increment,
  username varchar(128) NOT NULL default '',
  cuser varchar(128) NOT NULL default '',
  permtype int(11) default '0',
  permid int(11) default NULL,
  thedate timestamp(14) NOT NULL,
  cdate timestamp(14) NOT NULL,
  groupid int(11) NOT NULL default '0',
  item text,
  description text,
  format int(11) default '0',
  priority int(11) default NULL,
  completed int(11) default NULL,
  duedate timestamp(14) NOT NULL,
  duetype int(11) default NULL,
  PRIMARY KEY  (id),
  KEY username (username)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Struktura tabulky `twig_todo_lists_entries`
#

DROP TABLE IF EXISTS twig_todo_lists_entries;
CREATE TABLE twig_todo_lists_entries (
  listid int(11) NOT NULL default '0',
  type int(11) NOT NULL default '0',
  item int(11) NOT NULL default '0',
  subitem int(11) default NULL,
  KEY listid (listid),
  KEY item (item)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Struktura tabulky `twig_todo_prefs`
#

DROP TABLE IF EXISTS twig_todo_prefs;
CREATE TABLE twig_todo_prefs (
  id int(11) NOT NULL auto_increment,
  username varchar(128) NOT NULL default '',
  sortby varchar(10) NOT NULL default '',
  sortorder int(1) NOT NULL default '0',
  dgroup int(11) NOT NULL default '0',
  priority int(11) NOT NULL default '0',
  pagesize int(11) NOT NULL default '0',
  viewgrp varchar(10) NOT NULL default '0',
  duetype int(11) NOT NULL default '0',
  descrwords int(11) NOT NULL default '0',
  dformat int(11) default '0',
  dperms int(11) default '0',
  tooltips int(11) default '1',
  PRIMARY KEY  (id),
  KEY username (username)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Struktura tabulky `twig_ums`
#

DROP TABLE IF EXISTS twig_ums;
CREATE TABLE twig_ums (
  username varchar(128) NOT NULL default '',
  fromaddress varchar(128) default NULL,
  realname text,
  replyto text,
  KEY username (username)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Struktura tabulky `twiggi`
#

DROP TABLE IF EXISTS twiggi;
CREATE TABLE twiggi (
  dbversion int(11) default NULL,
  password varchar(128) default 'twiggi'
) TYPE=MyISAM;

