<?php	// TWIG		Mail Relaying Functions.	?>
<?php

 Function TWIGMailSendMessage( $server = "localhost", $port = "25", $to , $from, $domain, $header, $body ) 
	{
	$body = preg_replace ("/^\./ms", "..", $body);
	$ret = FALSE;
	$cmdnum = 0;
    $outheader;
	$theader = explode( "\r\n", $header );

	if( !preg_match( "/\</", $from) ) { $from = "<" . $from . ">"; }

   	$SMTPCommands[$cmdnum] = array( "", "220" ); $cmdnum++;
	$SMTPCommands[$cmdnum] = array( "HELO $domain", "250" ); $cmdnum++;
	$SMTPCommands[$cmdnum] = array( "MAIL FROM:$from", "250" ); $cmdnum++;

	for( $i = 0; $i < count( $theader ); $i++ )
		{
		$fields = explode( ":", $theader[$i] );
		switch( strtoupper( $fields[0] ) )
			{
			case "TO":
			case "CC":
			case "BCC":
				$fields[1] = str_replace( "\r", "", $fields[1] );
				$parse = imap_rfc822_parse_adrlist( $fields[1], "" );

				for( $k = 0; $k < count( $parse ); $k++ )
					{
					if( $fields[0] == "TO" ) { $allowfail = 0; } else { $allowfail = 1; }

					$SMTPCommands[$cmdnum] = array( "RCPT TO:<" . $parse[$k]->mailbox . "@" . $parse[$k]->host . ">", "250", $allowfail ); $cmdnum++;
					if ( strtoupper( $fields[0] ) != "BCC" )
						{
						if ( $k==0 ) 
							{
								$fk=$fields[0] . ": ";
							}
						else 
							{
								$outheader[count($outheader)-1] .= ",";
								$fk="\t";
							}

						if ( $parse[$k]->personal != "" )
							{
								$ot="<"; $ct=">";
								$personal=$parse[$k]->personal . ' ';
							}
						else
							{
								$ot=""; $ct="";
								$personal="";
							}
						$outheader[count($outheader)] .= $fk . $personal . $ot .  $parse[$k]->mailbox . "@" . $parse[$k]->host . $ct;

						}

					}
				break;
			default:
				$outheader[count($outheader)] = $theader[$i];
			}
		}

	$SMTPCommands[$cmdnum] = array( "DATA", "354" ); $cmdnum++;
	$SMTPCommands[$cmdnum] = array( implode("\r\n",$outheader) . "\r\n" . $body . "\r\n.", "250" ); $cmdnum++;
	$SMTPCommands[$cmdnum] = array( "QUIT", "" ); $cmdnum++;
	
	if( !$server ) { $server = "localhost"; }
	if( !$port ) { $port = "25"; }

   	$smtpcon = fsockopen( $server, $port, $errno, $errstr );

   	if( $smtpcon != FALSE )
 		{
		$ret = TWIGExecuteServerCommands( $smtpcon, $SMTPCommands );
		TWIGPrintESCErrors( $ret );

		fclose( $smtpcon );
		}

	return $ret;
   	}
?>
