<?php if ( $HTTP_SERVER_VARS["PHP_SELF"] != $config["basedir"] . "/index.php" ) {exit;}; ?>
<?php	// TWIG		User Preferences Feature Module ?>
<?php

register_globals (array(

	# GET

), array(

	# POST
	"prefs_dgroup", "prefs_dperms", "prefs_viewgrp", "prefs_sortby", "prefs_pagesize", 
	"prefs_descrwords", "prefs_tooltips", "prefs_sortbyway", "prefs_dformat", "update", 
) );

if( !acl( "a", "prefs" ) || !acl( "r", "prefscontacts" ) ) return;
$canwrite = acl( "w", "prefscontacts" ) && acl( "a", "prefs" );

 if( $update  && $canwrite ) 
	{
	PutPref( "sortby", TWIGProcessGPCtoSQL( $prefs_sortby ), $dbconfig["contacts_prefs_table"] );
	PutPref( "dgroup", TWIGProcessGPCtoSQL( $prefs_dgroup ), $dbconfig["contacts_prefs_table"] );
	PutPref( "dperms", TWIGProcessGPCtoSQL( $prefs_dperms ), $dbconfig["contacts_prefs_table"] );
	PutPref( "pagesize", TWIGProcessGPCtoSQL( $prefs_pagesize ), $dbconfig["contacts_prefs_table"] );
	PutPref( "viewgrp", TWIGProcessGPCtoSQL( $prefs_viewgrp ), $dbconfig["contacts_prefs_table"] );
	
	if( $prefs_sortbyway == "on" ) { PutPref( "sortorder", 1, $dbconfig["contacts_prefs_table"] ); } else { PutPref( "sortorder", 0, $dbconfig["contacts_prefs_table"] ); }
	PutPref( "descrwords", TWIGProcessGPCtoSQL( intval( abs( $prefs_descrwords) ) ), $dbconfig["contacts_prefs_table"] );
	if( $prefs_dformat == "on" ) { PutPref( "dformat", 1, $dbconfig["contacts_prefs_table"] ); } else { PutPref( "dformat", 0, $dbconfig["contacts_prefs_table"] ); }
	if( $prefs_tooltips == "on" ) { PutPref( "tooltips", 1, $dbconfig["contacts_prefs_table"] ); } else { PutPref( "tooltips", 0, $dbconfig["contacts_prefs_table"] ); }
	}

$entry = 0;

$tableheaders = array( $TWIGphrase["Preference"], "&nbsp", $TWIGphrase["Setting"] );

$temp = "<select name=prefs_dgroup>\n";
$temp .= TWIGGroupsSelect( $login["username"], GetPref( "dgroup", $dbconfig["contacts_prefs_table"], $config["defaults"]["contacts"]["dgroup"] ) );
$temp .= "</select>\n";

$tablecontents[$entry] = array( array( "contents"=>"<b>" . $TWIGphrase["Default group for new items"] . ":</b>", "align"=>"right" ), "&nbsp", $temp ); $entry++;

$temp=TWIGPermsSelector("prefs_dperms", GetPref( "dperms", $dbconfig["contacts_prefs_table"], 0 ));
$tablecontents[$entry] = array( array( "contents"=>"<b>" . $TWIGphrase["Default permissions for new items"] . ":</b>", "align"=>"right" ), "&nbsp", $temp ); $entry++;

$temp = "<select name=prefs_viewgrp>\n";
$temp .= TWIGGroupsSelect( $login["username"], GetPref( "viewgrp", $dbconfig["contacts_prefs_table"], $config["defaults"]["contacts"]["viewgrp"] ), 1 );
$temp .= "</select>\n";

$tablecontents[$entry] = array( array( "contents"=>"<b>" . $TWIGphrase["Default group to view in feature"] . ":</b>", "align"=>"right" ), "&nbsp", $temp ); $entry++;

$temp = "<select name=prefs_sortby>\n";

$sortoptions = array( $TWIGphrase["nickname"], $TWIGphrase["name"], $TWIGphrase["company"], $TWIGphrase["group"], $TWIGphrase["email"] );
$sortcodes = array( "nickname", "name", "company", "group", "email" );

$j = count( $sortoptions );
$currentsort = $TWIGphrase[GetPref( "sortby", $dbconfig["contacts_prefs_table"], $config["defaults"]["contacts"]["sortby"] )];

for( $i = 0; $i < $j; $i++ )
	{
	if( $sortoptions[$i] == $currentsort ) { $selected = " selected"; } else { $selected = ""; }
	$temp .= "<option value=\"" . $sortcodes[$i] . "\"" . $selected . ">" . $sortoptions[$i] . "</option>\n";
	}

$temp .= "</select>\n";

$tablecontents[$entry] = array( array( "contents"=>"<b>" . $TWIGphrase["Default sort order for contacts list"] . ":</b>", "align"=>"right" ), "&nbsp", $temp ); $entry++;

if( GetPref( "sortorder", $dbconfig["contacts_prefs_table"], $config["defaults"]["contacts"]["sortorder"] ) )
	{
	$temp = "<input type=checkbox name=prefs_sortbyway checked>";
	}
else
	{
	$temp = "<input type=checkbox name=prefs_sortbyway>";
	}

$tablecontents[$entry] = array( array( "contents"=>"<b>" . $TWIGphrase["Invert sort order"] . ":</b>", "align"=>"right" ), "&nbsp", $temp ); $entry++;
$tablecontents[$entry] = array( array( "contents"=>"<b>" . $TWIGphrase["Number of items to index on one screen"] . ":</b>", "align"=>"right" ), "&nbsp", "<input name=prefs_pagesize size=5 value=\"" . GetPref( "pagesize", $dbconfig["contacts_prefs_table"], $config["defaults"]["contacts"]["pagesize"] ) . "\">" ); $entry++;

$tablecontents[$entry] = array( array( "contents"=>"<b>" . $TWIGphrase["Number of words of description text to be shown in list views"] . ":</b>", "align"=>"right" ), "&nbsp", "<input name=prefs_descrwords size=6 value=\"" . GetPref( "descrwords", $dbconfig["contacts_prefs_table"], $config["defaults"]["contacts"]["descrwords"] ) . "\">" ); $entry++;

if( GetPref( "dformat", $dbconfig["contacts_prefs_table"], $config["defaults"]["contacts"]["dformat"] ) )
	{
	$temp = "<input type=checkbox name=prefs_dformat checked>";
	}
else
	{
	$temp = "<input type=checkbox name=prefs_dformat>";
	}

$tablecontents[$entry] = array( array( "contents"=>"<b>" . $TWIGphrase["Default: Preserve format of description text"] . ":</b>", "align"=>"right" ), "&nbsp", $temp ); $entry++;


if( GetPref( "tooltips", $dbconfig["contacts_prefs_table"], $config["defaults"]["contacts"]["tooltips"] ) )
	{
	$temp = "<input type=checkbox name=prefs_tooltips checked>";
	}
else
	{
	$temp = "<input type=checkbox name=prefs_tooltips>";
	}
$tablecontents[$entry] = array( array( "contents"=>"<b>" . $TWIGphrase["Tooltips in list view"] . ":</b>", "align"=>"right" ), "&nbsp", $temp ); $entry++;

include "features/prefs/modules/submitbutton.inc.php";
?>

