<?php if ( $HTTP_SERVER_VARS["PHP_SELF"] != $config["basedir"] . "/index.php" ) {exit;}; ?>
<?php	// TWIG		User Preferences Feature Module ?>
<?php

register_globals (array(

	# GET

), array(

	# POST
	"prefs_dgroup", "prefs_dperms", "prefs_viewgrp", "prefs_sortby", "prefs_sortbyway", 
	"prefs_priority", "prefs_pagesize", "prefs_duetype", "prefs_descrwords", "prefs_dformat", 
	"update", 
) );

if( !acl( "a", "prefs" ) || !acl( "r", "prefstodo" ) ) return;
$canwrite = acl( "w", "prefstodo" ) && acl( "a", "prefs" );

if( $update && $canwrite )
	{
	PutPref( "sortby", TWIGProcessGPCtoSQL( $prefs_sortby ), $dbconfig["todo_prefs_table"] );
	PutPref( "dgroup", TWIGProcessGPCtoSQL( $prefs_dgroup ), $dbconfig["todo_prefs_table"] );
	PutPref( "dperms", TWIGProcessGPCtoSQL( $prefs_dperms ), $dbconfig["todo_prefs_table"] );
	PutPref( "priority", TWIGProcessGPCtoSQL( $prefs_priority ), $dbconfig["todo_prefs_table"] );
	PutPref( "pagesize", TWIGProcessGPCtoSQL( $prefs_pagesize ), $dbconfig["todo_prefs_table"] );
	PutPref( "viewgrp", TWIGProcessGPCtoSQL( $prefs_viewgrp ), $dbconfig["todo_prefs_table"] );
	PutPref( "duetype", TWIGProcessGPCtoSQL( $prefs_duetype ), $dbconfig["todo_prefs_table"] );
	PutPref( "descrwords", TWIGProcessGPCtoSQL( intval( abs( $prefs_descrwords) ) ), $dbconfig["todo_prefs_table"] );
	
	if( $prefs_sortbyway == "on" ) { PutPref( "sortorder", 1, $dbconfig["todo_prefs_table"] ); } else { PutPref( "sortorder", 0, $dbconfig["todo_prefs_table"] ); }
	if( $prefs_dformat == "on" ) { PutPref( "dformat", 1, $dbconfig["todo_prefs_table"] ); } else { PutPref( "dformat", 0, $dbconfig["todo_prefs_table"] ); }
	}

$entry = 0;

$tableheaders = array( $TWIGphrase["Preference"], "&nbsp", $TWIGphrase["Setting"] );

$temp = "<select name=prefs_dgroup>\n";
$temp .= TWIGGroupsSelect( $login["username"], GetPref( "dgroup", $dbconfig["todo_prefs_table"], $config["defaults"]["todo"]["dgroup"] ) );
$temp .= "</select>\n";

$tablecontents[$entry] = array( array( "contents"=>"<b>" . $TWIGphrase["Default group for new items"] . ":</b>", "align"=>"right" ), "&nbsp", $temp ); $entry++;

$temp=TWIGPermsSelector("prefs_dperms", GetPref( "dperms", $dbconfig["todo_prefs_table"], 0 ));
$tablecontents[$entry] = array( array( "contents"=>"<b>" . $TWIGphrase["Default permissions for new items"] . ":</b>", "align"=>"right" ), "&nbsp", $temp ); $entry++;

$temp = "<select name=prefs_viewgrp>\n";
$temp .= TWIGGroupsSelect( $login["username"], GetPref( "viewgrp", $dbconfig["todo_prefs_table"], $config["defaults"]["todo"]["viewgrp"] ), 1 );
$temp .= "</select>\n";

$tablecontents[$entry] = array( array( "contents"=>"<b>" . $TWIGphrase["Default group to view in feature"] . ":</b>", "align"=>"right" ), "&nbsp", $temp ); $entry++;

$temp = "<select name=prefs_sortby>\n";

$sortoptions = array( "item", "status", "priority", "group", "duedate" );
$TWIGphrase["duedate"]=$TWIGphrase["due date"]; // Hmmmm!

$j = count( $sortoptions );
$currentsort = GetPref( "sortby", $dbconfig["todo_prefs_table"], $config["defaults"]["todo"]["sortby"] );

for( $i = 0; $i < $j; $i++ )
	{
	if( $sortoptions[$i] == $currentsort ) { $selected = " selected"; } else { $selected = ""; }
 	$temp .= "<option value=\"" . $sortoptions[$i] . "\" " . $selected . ">" . $TWIGphrase[$sortoptions[$i]] . "</option>\n";
	}

$temp .= "</select>\n";

$tablecontents[$entry] = array( array( "contents"=>"<b>" . $TWIGphrase["Default sort order for todo list"] . ":</b>", "align"=>"right" ), "&nbsp", $temp ); $entry++;

if( GetPref( "sortorder", $dbconfig["todo_prefs_table"], $config["defaults"]["todo"]["sortorder"] ) )
	{
	$temp = "<input type=checkbox name=prefs_sortbyway checked>";
	}
else
	{
	$temp = "<input type=checkbox name=prefs_sortbyway>";
	}

$tablecontents[$entry] = array( array( "contents"=>"<b>" . $TWIGphrase["Invert sort order"] . ":</b>", "align"=>"right" ), "&nbsp", $temp ); $entry++;

$temp = "<select name=prefs_priority>\n";

$priorityoptions = array( 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10 );

$j = count( $priorityoptions );
$currentp = GetPref( "priority", $dbconfig["todo_prefs_table"], $config["defaults"]["todo"]["priority"] );

for( $i = 0; $i < $j; $i++ )
	{
	if( $priorityoptions[$i] == $currentp ) { $selected = " selected"; } else { $selected = ""; }
	$temp .= "<option" . $selected . ">" . $priorityoptions[$i] . "</option>\n";
	}

$temp .= "</select>\n";

$tablecontents[$entry] = array( array( "contents"=>"<b>" . $TWIGphrase["Default priority for new items"] . ":</b>", "align"=>"right" ), "&nbsp", $temp ); $entry++;
$tablecontents[$entry] = array( array( "contents"=>"<b>" . $TWIGphrase["Number of items to index on one screen"] . ":</b>", "align"=>"right" ), "&nbsp", "<input name=prefs_pagesize size=5 value=\"" . GetPref( "pagesize", $dbconfig["todo_prefs_table"], $config["defaults"]["todo"]["pagesize"] ) . "\">" ); $entry++;

$temp = "<select name=prefs_duetype>\n";

$dueoptions = array( $TWIGphrase["Never"], $TWIGphrase["On date"], $TWIGphrase["On date/time"] );

$j = count( $dueoptions );
$currentdue = GetPref( "duetype", $dbconfig["todo_prefs_table"], $config["defaults"]["todo"]["duetype"] );

for( $i = 0; $i < $j; $i++ )
	{
	if( $i == $currentdue ) { $selected = " selected"; } else { $selected = ""; }
 	$temp .= "<option value=\"" . $i . "\" " . $selected . ">" . $dueoptions[$i] . "</option>\n";
	}

$temp .= "</select>\n";

$tablecontents[$entry] = array( array( "contents"=>"<b>" . $TWIGphrase["Default due date type"] . ":</b>", "align"=>"right" ), "&nbsp", $temp ); $entry++;

$tablecontents[$entry] = array( array( "contents"=>"<b>" . $TWIGphrase["Number of words of description text to be shown in list views"] . ":</b>", "align"=>"right" ), "&nbsp", "<input name=prefs_descrwords size=6 value=\"" . GetPref( "descrwords", $dbconfig["todo_prefs_table"], $config["defaults"]["todo"]["descrwords"] ) . "\">" ); $entry++;

if( GetPref( "dformat", $dbconfig["todo_prefs_table"], $config["defaults"]["todo"]["dformat"] ) )
	{
	$temp = "<input type=checkbox name=prefs_dformat checked>";
	}
else
	{
	$temp = "<input type=checkbox name=prefs_dformat>";
	}

$tablecontents[$entry] = array( array( "contents"=>"<b>" . $TWIGphrase["Default: Preserve format of description text"] . ":</b>", "align"=>"right" ), "&nbsp", $temp ); $entry++;


include "features/prefs/modules/submitbutton.inc.php";
?>
