<?php
function datetime_js_selector ( $year, $month, $day, $hour, $minute, $dtext, $ttext, $verify )
{
GLOBAL $TWIGphrase, $dbconfig, $config, $formstext;
if( $verify) $verify = "onBlur='$verify'"; 
$dateformat = GetPref( "dateformat", $dbconfig["global_prefs_table"], $config["defaults"]["global"]["dateformat"] );
$timeformat = TWIGCheckTimeFormat( TWIGGetTimeFormat() );
if( $timeformat != 24 ) 
	{
	$hour_start=1;
	$hour_end=12;

	if( $hour > 11 )
		{
		$hour -= 12;
		$ampm = "pm";
		}
	else 
		{ 
		$ampm = "am"; 
		}

	if( $hour == 0 ) { $hour = 12; }
	}
  			
?>
<script language="javascript">
function setduedate( d, m, y )
	{
	document.edit.dueDay.value = d;
	document.edit.dueMonth.value = m;
	document.edit.dueYear.value = y;
	}
function setduetime( H, M, AMPM )
	{
	if( H >= 0 ) document.edit.dueHour.value = (H<10?"0":"") + H.toString();
	if( M >= 0 ) document.edit.dueMinute.value = (M<10?"0":"") + M.toString();
	if( AMPM != "" ) document.edit.dueAMPM.value = AMPM;
	}
</script>
<table border=0 cellpadding=0 cellspacing=2>
<tr>
<td nowrap align=right>
<font <?php echo $formstext?>><b style='' id="dueDate"><?php echo $dtext ?>:</b></font>
</td><td nowrap>
<?php
if( $dateformat == 1)
{
?>
<input style='' <?php echo $verify?> name=dueDay size=3 maxlength=2 value="<?echo $day?>"><b> . </b><input style='' <?php echo $verify?> name=dueMonth size=3 maxlength=2 value="<?echo $month?>"><b> . </b>
<?php
}
else
{
?>
<input style='' <?php echo $verify?> name=dueMonth size=3 maxlength=2 value="<?echo $month?>"><b> / </b><input style='' <?php echo $verify?> name=dueDay size=3 maxlength=2 value="<?echo $day?>"><b> / </b>
<?php
}
?>
<input style='' <?php echo $verify?> name=dueYear size=5 maxlength=4 value="<?echo $year?>"> 
</td>
</tr><tr>
<td align=right nowrap>
<font <?php echo $formstext?>><b style='' id="dueTime"><?php echo $ttext?>:</b></font>
</td><td nowrap><input style='' <?php echo $verify?> name=dueHour size=3 maxlength=2 value="<?echo printf( '%02d', $hour)?>"><b> : </b><input style='' <?php echo $verify?> name=dueMinute size=3 maxlength=2 value="<?printf( '%02d', $minute)?>"><?php
if( $timeformat != 24 )
{
?>&nbsp;&nbsp;<input style='' <?php echo $verify?> name=dueAMPM size=3 maxlength=2 value="<?echo $ampm?>">
<?php
}
?>
</td>
</tr>
</table>
<?php
} // function datetime_js_selector

?>
<script language="javascript">
function sd( d, m, y )
	{
	setduedate( d, m, y );
	iverify(0);
	}
function st( H, M )
	{
	var AMPM = "";
	<?php
	if( $timeformat != 24 )
	{
	?>
	if( H > 11 )
		{
		AMPM = "pm"; 
		}
	else if( H>=0 )
		{
		AMPM = "am"; 
		}
	if( H>=0 )
		{
		H = (H+12)%12;
		if( H == 0) H = 12;
		}
	<?php
	}
	?>
	setduetime( H, M, AMPM );
	iverify(0);
	}
function mid(x)
	{
	x.style.color='#FF0000';
	x.style.textDecoration='none'; 
	}
function mod(x, bg)
	{
	x.style.textDecoration='none'; 
	x.style.color='<?php echo $config["link"]?>'; 
	}
function timez (d)
	{
	var j = new Date();
	return d + parseInt(j.getTimezoneOffset()/60,10) * 3600 * 1000;
	}
function iverify( abox )
	{
	var err_all=0;
	var err_both=0;
	var err_ds=0;
	var err_ts=0;
	var sd = new Date();
	var sh = document.edit.dueHour.value;
	var sm = document.edit.dueMinute.value;

	sh = Number(sh);

	sm = Math.floor(sm/5) * 5;

	<?php
	if ( $timeformat != 24 )
		{
	?>
	document.edit.dueAMPM.value = document.edit.dueAMPM.value.toLowerCase();
	err_ts |= document.edit.dueAMPM.value != "am" && document.edit.dueAMPM.value != "pm";
	sh = Number(sh);
	if( document.edit.dueAMPM.value == "pm" )
		{
		if( sh < 12 ) sh += 12;
		}
	else
		{
		if( sh == 12 ) sh = 0;
		}
	
	<?php
		}
	?>

	if( document.edit.dueYear.value < 100 )
		{
		document.edit.dueYear.value = Number(document.edit.dueYear.value) 
				+ (document.edit.dueYear.value < 70 ? 2000 : 1900);
		}
	var utc_duedate = Date.UTC(document.edit.dueYear.value, 
					document.edit.dueMonth.value-1, 
					document.edit.dueDay.value,
					12, 0, 0 );
	utc_duedate = timez(utc_duedate);
	var utc_duetime = Date.UTC( document.edit.dueYear.value,
					document.edit.dueMonth.value-1,
					document.edit.dueDay.value, 
					sh,
					sm,
					0 );
	utc_duetime = timez(utc_duetime)-utc_duedate-12*3600*1000;

	sd.setTime(utc_duedate);

	err_ds = err_ds || utc_duedate<0;
	err_ds = err_ds || sd.getDate() != document.edit.dueDay.value;
	err_ds = err_ds || sd.getMonth() != document.edit.dueMonth.value-1;
	err_ds = err_ds || sd.getFullYear() != document.edit.dueYear.value;

	err_ts = err_ts || sh < 0 || sh > 23;
	err_ts = err_ts || sm < 0 || sh > 59;

	err_all = err_both || err_ds || err_ts;

	document.getElementById("dueTime").style.color =  err_ts || err_both ? 'red' : '<?php echo $config["formstext"]?>';
	document.getElementById("dueDate").style.color =  err_ds || err_both ? 'red' : '<?php echo $config["formstext"]?>';
	
	if( navigator.userAgent.indexOf("Netscape") != -1 || navigator.userAgent.indexOf("Konqueror") != -1 )
		{
		document.edit.dueHour.removeAttribute( 'disabled');
		document.edit.dueMinute.removeAttribute( 'disabled');
		document.edit.dueYear.removeAttribute( 'disabled');
		document.edit.dueMonth.removeAttribute( 'disabled');
		document.edit.dueDay.removeAttribute( 'disabled');
		<?php
		if ( $timeformat != 24 )
		{
		?>
		document.edit.dueAMPM.removeAttribute( 'disabled');
		<?php
		}
		?>
		}
	else
		{
		document.edit.dueHour.setAttribute( 'disabled', false);
		document.edit.dueMinute.setAttribute( 'disabled', false);
		document.edit.dueYear.setAttribute( 'disabled', false);
		document.edit.dueMonth.setAttribute( 'disabled', false);
		document.edit.dueDay.setAttribute( 'disabled', false);
		<?php
		if ( $timeformat != 24 )
		{
		?>
		document.edit.dueAMPM.setAttribute( 'disabled', false);
		<?php
		}
		?>
		}	

	if( document.getElementById("duetype").value < 2 )
		{
		document.getElementById("dueTime").style.color =  '<?php echo DimColor($config["formscolor"], 0.7) ?>';
		document.edit.dueHour.setAttribute( 'disabled', true);
		document.edit.dueMinute.setAttribute( 'disabled', true);
		<?php
		if ( $timeformat != 24 )
		{
		?>
		document.edit.dueAMPM.setAttribute( 'disabled', true);
		<?php
		}
		?>
		}
	if( document.getElementById("duetype").value < 1 )
		{
		document.getElementById("dueDate").style.color =  '<?php echo DimColor($config["formscolor"], 0.7) ?>';
		document.getElementById("dueOn").style.color =  '<?php echo DimColor($config["formscolor"], 0.7) ?>';
		document.edit.dueYear.setAttribute( 'disabled', true);
		document.edit.dueMonth.setAttribute( 'disabled', true);
		document.edit.dueDay.setAttribute( 'disabled', true);
		}

	if( !err_all )
		{
		<?php
		if ( $timeformat != 24 )
		{
		?>
		if( document.edit.dueAMPM.value == "pm" )
			{
			if( sh > 12 ) sh -= 12;
			}
		else
			{
			if( sh == 0 ) sh = 12;
			}
		<?php
		}
		?>
		document.edit.dueHour.value = (sh<10?"0":"") + sh.toString();
		document.edit.dueMinute.value = (sm<10?"0":"") + sm.toString();
		}

	if( err_all && abox )
		{
		alert('<?php echo $TWIGphrase["Error: Bad input values."]?>');
		}
	return !err_all;
	}
var pageinit=false;
function initpage ()
	{
	if( !pageinit ) iverify(0); // needed for Opera browser
	pageinit=true;
	}
</script>
