<?php

require( "lib/auth/" . $config["auth_provider"] . ".authpro.inc.php" );

Function TWIGLogout( $realm = "TWIG" )
	{
	global $context, $TWIGphrase, $config_dir, $error, $mbox, $config, $img, $version;

	TWIGCheckAuth( $mbox, 1 );

#	TWIGCleanSession();
#	TWIGCleanContext();

	if( $config["auth_logout_redirect"] ) 
		{  
		header( "Location: " . $config["auth_logout_redirect"] );	
		}

	Header( "WWW-authenticate: basic realm=\"$realm\"" );
	Header( "HTTP/1.0 401 Unauthorized" );
	include( "$config_dir/header.inc.php" );
 	TWIGLoadLanguageFile( "features/" . $context["feature"] . "/strings/", "", $config["language"] );
	TWIGPrintError( $TWIGphrase["To completely logout you must close your browser now."] );
	include( "$config_dir/footer.inc.php" );

	exit;
	}

 // Basic Authentication Method
Function TWIGAuth( $realm = "TWIG", $logout = "" ) 
	{
	global $version, $login, $session, $config, $config_dir, $img, $twig_username, $twig_password, $PHP_AUTH_USER, $PHP_AUTH_PW, $localaccess;

	// Require a username/password from the user
	if( $logout ) 
		{
		if( !$PHP_AUTH_USER || $error["auth"] || $logout ) 
			{
			TWIGLogout( $realm );
			}
		else 
			{
			$login["username"] = $PHP_AUTH_USER;
			$login["password"] = $PHP_AUTH_PW;
			TWIGStoreLogin( $login["username"], $login["password"], $config["auth_timeout"] );
			}
		}
	else if( !is_array( $login ) ) 
		{
		Header( "WWW-authenticate: basic realm=\"$realm\"" );
		Header( "HTTP/1.0 401 Unauthorized" );
		include( "$config_dir/header.inc.php" );
		include( "$config_dir/footer.inc.php" );

		exit;
		}
	else 	
		{
		$login["username"] = $PHP_AUTH_USER;
		$login["password"] = $PHP_AUTH_PW;
		list( $validuser, $mbox ) = TWIGCheckAuth( $mbox );

		if( !$validuser || !TWIGisLocalUser ( $login["username"] ) || 
				( !acl("extern", "twiggi") && !$localaccess ) ||
				!acl("local", "twiggi") ) 
			{
			if ( $validuser && !TWIGisLocalUser ( $login["username"] ) )
				{
				$login["username"] = rand() . $login["username"];
				$login["password"] = rand() . $login["password"];
				list($validuser,$mbox) = TWIGCheckAuth( $mbox );
				}
			$login["password"]="";
			Header( "WWW-authenticate: basic realm=\"$realm\"" );
			Header( "HTTP/1.0 401 Unauthorized" );
			include( "$config_dir/header.inc.php" );
			TWIGPrintError( "Login failed - Probably a misspelled username or password, please try again." );
			include( "$config_dir/footer.inc.php" );

			exit;
			}
		else 
			{ 
			return $mbox; 
			}
		}
 	}
?>
