<?php

require( "lib/auth/" . $config["auth_provider"] . ".authpro.inc.php" );

Function TWIGLogout( $realm = "TWIG" )
	{
	global $HTTP_SESSION_VARS, $config_dir, $error, $mbox, $config, $img, $version;

	TWIGCheckAuth( $mbox, 1 );

	TWIGStoreLogin( "", "", 0, 1 );

	TWIGCleanSession();
	TWIGCleanContext();
	$HTTP_SESSION_VARS=array();

	if( $config["auth_logout_redirect"] ) 
		{  
		header( "Location: " . $config["auth_logout_redirect"] );	
		}

	include( $config_dir . "/login.header.inc.php" );
	include( $config_dir . "/header.inc.php" );
	if( $error["auth"] ) { TWIGPrintError( $error[auth] ); }
	include( $config_dir . "/login.form.php" );
	include( $config_dir . "/footer.inc.php" );
	include( $config_dir . "/login.footer.inc.php" );

	exit;
	}

// Forms-Based Authentication Method
Function TWIGAuth( $realm = "TWIG", $logout = "" ) 
	{
	global $HTTP_COOKIE_VARS, $HTTP_SERVER_VARS, $inDemoMode, $config_dir, $session, $login, $error, $config, $login_username, $login_password, $mbox, $version, $img, $localaccess;

	register_globals (array(), array("login_username", "login_password", "twig_authenticated", "set_twig_authenticated"), FALSE );
	if ($config["tdbg"]) $tdbg=timedebug_start ("TWIGAuth");

	if ( $inDemoMode ) { $login_password=$config["password"];}
	
	if( $logout )
		{
		TWIGLogout( $realm );	
		}
	else if( !$login_username && !$login["username"] )
		{
		include( $config_dir . "/login.header.inc.php" );
		include( $config_dir . "/header.inc.php" );
		if( $error["auth"] ) { TWIGPrintError( $error[auth] ); }
		include( $config_dir . "/login.form.php" );
		include( $config_dir . "/footer.inc.php" );
		include( $config_dir . "/login.footer.inc.php" );

		if ($config["tdbg"]) timedebug_stop ($tdbg);
		exit;
		}
	else 
		{
		if( $login_username )
			{
			$login["username"] = $login_username;
			$login["password"] = $login_password;
			}

		list($validuser,$mbox) = TWIGCheckAuth( $mbox );

		if( !$validuser || !TWIGisLocalUser ( $login["username"] ) || 
				( !acl("extern", "twiggi") && !$localaccess ) ||
				!acl("local", "twiggi") ) 
			{
			if ( $validuser )
				{
				$login["username"] = rand() . $login["username"];
				$login["password"] = rand() . $login["password"];
				list($validuser,$mbox) = TWIGCheckAuth( $mbox );
				}
			$login["password"]="";
			include( $config_dir . "/login.header.inc.php" );
			include( $config_dir . "/header.inc.php" );
			TWIGPrintError( "Login failed - Probably a misspelled username or password, please try again." );
			include( $config_dir . "/login.form.php" );
			include( $config_dir . "/footer.inc.php" );
			include( $config_dir . "/login.footer.inc.php" );

			if ($config["tdbg"]) timedebug_stop ($tdbg);
			exit;
			} 
		else
			{
			TWIGStoreLogin( $login["username"], $login["password"], $config["auth_timeout"] );

			/* NEWMAIL-POPUP-BEGIN */
			if ( $login_username )
				{
				GLOBAL $config, $dbconfig;
				$query = "UPDATE " . $dbconfig["accounts_table"] . " SET expire='" . $config["auth_timeout"] . "'" .
				" WHERE username='" . $login["username"] . "'";
				dbquery( $query );
				}
			/* NEWMAIL-POPUP-END */

			if ($config["tdbg"]) timedebug_stop ($tdbg);
			return $mbox;
			}
		}
	}

?>
