<?php

	$imap_oc_nesting=0;

	Function TWIGMailGetFrom()
		{
		GLOBAL $config, $dbconfig, $login;
	
		if( !acl( "y", "mailfrom" ) )
			{
			$pdb=$dbconfig["pseudonyms"];
			$query = "SELECT * FROM " . $pdb . " WHERE username='" . $login["username"] . "'";
			$result = dbQuery( $query );
			if ( dbNumRows ($result) > 0 )
				{
				$data=dbResultArrayAssoc( $result, 0 );
 				$from = $data["fromaddress"];
				}
			}

		if( !isset( $from ) )
			{
			$from = GetPref( "fromaddress", $dbconfig["prefs_table"], $config["defaults"]["mail"]["fromaddress"] );
			}

		$from =  stripslashes(str_replace( "\n", "", $from ));

		if( !$from ) $from = $login["username"]; 
		if ( !preg_match ("/@/", $from ) ) $from .= "@" . $config["fromdomain"];

		return $from;
		}

	Function TWIGMailGetReplyto()
		{
		GLOBAL $config, $dbconfig, $login;
		if( !acl( "y", "mailreplyto" ) )
			{
			$pdb=$dbconfig["pseudonyms"];
			$query = "SELECT * FROM " . $pdb . " WHERE username='" . $login["username"] . "'";
			$result = dbQuery( $query );
			if ( dbNumRows ($result) > 0 )
				{
				$data=dbResultArrayAssoc( $result, 0 );
 				$replyto = $data["replyto"];
				}
			}

		if( !isset( $replyto ) )
			{
			$replyto = GetPref( "replyto", $dbconfig["prefs_table"], $config["defaults"]["mail"]["replyto"] );
			}

		$replyto =  stripslashes(str_replace( "\n", "", $replyto ));

		if( !$replyto ) $replyto = $login["username"]; 
		if ( !preg_match ("/@/", $replyto ) ) $replyto .= "@" . $config["fromdomain"];

		return $replyto;
		}

	Function TWIGMailGetRealname()
		{
		GLOBAL $config, $dbconfig, $login;
		if( !acl( "y", "mailrealname" ) )
			{
			$pdb=$dbconfig["pseudonyms"];
			$query = "SELECT * FROM " . $pdb . " WHERE username='" . $login["username"] . "'";
			$result = dbQuery( $query );
			if ( dbNumRows ($result) > 0 )
				{
				$data=dbResultArrayAssoc( $result, 0 );
 				$realname = $data["realname"];
				}
			}

		if( !isset( $realname ) )
			{
			$realname = GetPref( "realname", $dbconfig["prefs_table"], $config["defaults"]["mail"]["realname"] );
			}

		$realname =  stripslashes(str_replace( "\n", "", $realname ));

		if( !$realname ) { $config["localuser"][$login["username"]]; }

		return $realname;
		}


	Function TWIGMailDuplicateAddressCheck( $alist )
		{
		$addresses = imap_rfc822_parse_adrlist( $alist, "" );

		for( $i = 0, $j = count( $addresses ); $i < $j; $i++ )
			{
			$emaila = $addresses[$i]->mailbox . "@" . $addresses[$i]->host;

			if( !$found[$emaila] )
				{
				$found[$emaila] = 1;
				if( $out ) { $out .= ", "; }
				if( $addresses[$i]->personal ) { $out .= "\"" . $addresses[$i]->personal . "\" "; }
				$out .= "<" . $emaila . ">";
				}
			}

		return $out;		
		}
	
 	Function TWIGCloseMB( &$mbox ) 
		{
		GLOBAL $imap_oc_nesting;
		TWIGDebug( "TWIGCloseMB( \"" . $mbox . "\" );" );

		if( $mbox )
			{
			TWIGDebug( "TWIGCloseMB()" );
			$imap_oc_nesting--;
			imap_close( $mbox );
			$mbox="";
			}
		}

 	// Open a mailbox without a lot of hassle
 	Function TWIGOpenMB( $mailbox, $recur = 0) 
		{
  		global $errortext, $session, $config, $login, $imap_oc_nesting;
  		
		TWIGDebug( "TWIGOpenMB( \"" . $mailbox . "\", \"" . $recur . "\" );" );

		if( CheckMBType( MailboxDecode( $mailbox ) ) > 0 ) { $mailbox = "INBOX"; }

  		if( !$config["imap_server"] ) { $config["imap_server"] = "localhost"; }
  		if( !$config["imap_port"] ) { $config["imap_port"] = "143"; }

		TWIGDebug( "TWIGOpenMB( \"" . "{" . $config["imap_server"] . ":" . $config["imap_port"] . "}" . $mailbox . "\")" );
		$imap_oc_nesting++;
	  	$mbox = @imap_open( "{" . $config["imap_server"] . ":" . $config["imap_port"] . "}" . $mailbox, $login["username"], $login["password"] );
		if  ( $mbox == FALSE )
			{
			if ( $recur > 10 )
				{
				TWIGPrintError( "IMAP error: Could not open $mailbox after $recur tries.<br> please click <a href=\"" 
					. $config["baseurl"] . "\">here</a> to restart twig and try again." );
				exit;
				}
			$recur++;
			#print "<font $errortext><b>TWIGOpenMB failed! recur=$recur</b></font><br>";
			usleep ( 100000 );
			return TWIGOpenMB( $mailbox, $recur );
			}

  		return $mbox;
 		}

	Function TWIGMailOpenMailbox( $mailbox, $user, $password, $options )
		{
		GLOBAL $imap_oc_nesting;
		$imap_oc_nesting++;
		return imap_open( $mailbox, $user, $password, $options );
		}

	Function TWIGCheckNewMail( $mbox ) 
		{
		return $mbox ? imap_num_recent( $mbox ) : FALSE;
	 	}

	Function TWIGGetMessageCount( $mbox ) 
		{
		TWIGDebug( "TWIGGetMessageCount( \"" . $mbox . "\" );" );

	  	$check = imap_check( $mbox );
  		return $check->Nmsgs;
	 	}

 	Function MailboxDecode( $mb, $strip = "" ) 
		{ 
  		GLOBAL $config;

  		$mb = str_replace( "!", "/", $mb);

  		if( $strip )
			{
    			return ereg_replace( "^$config[imap_path]", "", $mb );
  			}
  		else 
			{
    			return $mb;
  			}
 		}

 	Function MailboxEncode( $mb ) 
		{ 
		return str_replace( "/", "!", $mb ); 
		}

 	//Check to see what type of mailbox we have, 0 imap, 1 news 2 pop3
 	Function CheckMBType($str) 
		{
   		if( strstr( $str, "/nntp" ) ) { return 1; }
   		else { if( strstr( $str, "/pop3" ) ) { return 2; } 
   		else { return 0; } }
   		}

	Function TWIGMailFetchStructure( $mailbox, $message )
		{
		return imap_fetchstructure( $mailbox, $message );
		}

	Function TWIGMailFetchBody( $mailbox, $message, $section )
		{
		return imap_fetchbody( $mailbox, $message, $section );
		}
	
	Function TWIGMailBoxCheck( $mailbox )
		{
		return imap_check( $mailbox );
		}

	Function TWIGMailCopy( $mailbox, $message, $destination )
		{
		GLOBAL $config;

		$ret = imap_mail_copy( $mailbox, $message, $destination );

		if( $ret == FALSE )
			{
   			imap_createmailbox( $mailbox, $destination );
			$ret = imap_mail_copy( $mailbox, $message, $destination );
			}

		return $ret;
		}

	Function TWIGMailMove( $mailbox, $message, $destination )
		{
		GLOBAL $config;

		$ret = imap_mail_move( $mailbox, $message, $destination );

		if( $ret == FALSE )
			{
   			imap_createmailbox( $mailbox, $destination );
			$ret = imap_mail_move( $mailbox, $message, $destination );
			}

		return $ret;
		}
		
	Function TWIGMailDelete( $mailbox, $item )
		{
		return imap_delete( $mailbox, $item ); 
		}

	Function TWIGMailSubscribedFolders( $mailbox, $path, $filter )
		{
		return imap_listsubscribed( $mailbox, $path, $filter );
		}

	Function TWIGMailEmptyTrash( $mailbox )
		{
		GLOBAL $config, $session;
		$Nmsgs = imap_num_msg ( $mailbox );
		if ( $config["cachethreshold"] >0 && $config["cachethreshold"] < $Nmsgs )
			{
			if ($config["tdbg"]) $tdbg=timedebug_start ("TWIGMailEmptyTrash");
			$mb=imap_fetch_overview ( $mailbox, "1:$Nmsgs" ); 
			if ($config["tdbg"]) timedebug_stop ($tdbg);
			for ($i=0, $k=count ($mb); $i<$k && !$mb[$i]->deleted; $i++);
			if ( $i<$k )
				{
				CleanUpMailboxCache ();
				}
			}
		return imap_expunge( $mailbox );
		}


Function CleanUpExpiredMailCache ()
	{
	GLOBAL $config, $login, $dbconfig;
	if ($config["tdbg"]) $tdbg=timedebug_start ("CleanUpMailCache");
	$th = convertUTimeToSQLTime( gmmktime() - $config["cachexpiry"] );
	$query="SELECT cache FROM " . $dbconfig["threadcache"] 
				. " WHERE username='" . $login["username"] . "'"
				. " AND thedate<='" . $th . "'";
	$result=dbQuery ( $query );
	for ( $i=0, $k=dbNumRows( $result ); $i<$k; $i++ )
		{
		$cname=dbResult( $result, $i, "cache" );
		$query="DELETE FROM " . $dbconfig["threadcache"] 
				. " WHERE username='" . $login["username"] . "'"
				. " AND cache='" . SQLString( $cname ) . "'";
		dbQuery ( $query );
		if ( file_exists($cname) ) unlink ( $cname );
		}
	if ($config["tdbg"]) timedebug_stop( $tdbg );
	}

Function CleanUpMailboxCache ( $exclude_Nmsgs="-1" )
	{
	GLOBAL $config, $login, $dbconfig, $session;
	$mbx=TWIGMailGetFolderString( $config["imap_server"], $config["imap_port"], "", $session["mailbox"] );
	if ($config["tdbg"]) $tdbg=timedebug_start ("CleanUpMailCache");
	$query="SELECT cache FROM " . $dbconfig["threadcache"] 
				. " WHERE username='" . $login["username"] . "'"
				. " AND mailbox='" . $mbx . "'"
				. " AND Nmsgs!='" . $exclude_Nmsgs . "'";
	$result=dbQuery ( $query );
	for ( $i=0, $k=dbNumRows( $result ); $i<$k; $i++ )
		{
		$cname=dbResult( $result, $i, "cache" );
		$query="DELETE FROM " . $dbconfig["threadcache"] 
				. " WHERE username='" . $login["username"] . "'"
				. " AND mailbox='" . $mbx . "'"
				. " AND Nmsgs!='" . $exclude_Nmsgs . "'"
				. " AND cache='" . SQLString( $cname ) . "'";
		dbQuery ( $query );
		if ( file_exists($cname) ) unlink ( $cname );
		}
	if ($config["tdbg"]) timedebug_stop( $tdbg );
	}

# this is a specialized version of imap_fetch_overview()
# for message threading
# the original imap_fetch_overview() does not return the
# In-Reply-To header field
#
# $mbox is the current mailbox IMAP stream, $session["mailbox"]
# is the name of the correspondig mailbox
#
Function thread_imap_fetch_overview ( &$mbox, $mbx )
	{
	GLOBAL $config, $dbconfig, $login, $session;

	$force_reread = ( imap_num_recent ($mbox) != 0 );
	$Nmsgs=imap_num_msg ($mbox);
	$fingerprint_mbox=$Nmsgs;

	if ( $config["cachethreshold"] >0 && $config["cachethreshold"] < $Nmsgs )
		{
		if ($config["tdbg"]) $tdbg=timedebug_start ("thread_imap_fetch_overview: fingerprint_mbox db query\nfp=$fingerprint_mbox");
		$query="SELECT cache FROM " . $dbconfig["threadcache"] 
					. " WHERE fingerprint='" . $fingerprint_mbox . "'"
					. " AND username='" . $login["username"] . "'"
					. " AND mailbox='" . SQLString( $mbx ) . "'"
					. " AND type='M'";
		$result=dbQuery ( $query );
		$ret=dbResultArray( $result, 0 );
		if ($config["tdbg"]) timedebug_stop( $tdbg );
    
		if ( $ret && file_exists( $ret[0] ) && !$force_reread )
			{
				if ($config["tdbg"]) $tdbg=timedebug_start ("thread_imap_fetch_overview: read from cache + unserialize header");
				//reset expiry time
				$query="UPDATE " . $dbconfig["threadcache"] . " SET thedate=NULL WHERE fingerprint='" . $fingerprint_mbox . "'";
				dbQuery ( $query );
				$fp = fopen ( $ret[0], "r");
				while ( !feof( $fp ) )
					{
					$header .= fgets( $fp, 1048576 ); 
					}
				fclose ($fp);
				$header = unserialize( $header );
				if ($config["tdbg"]) timedebug_stop( $tdbg );
				return $header;
			}
		}

	TWIGCloseMB( $mbox ) ;

	if ($config["tdbg"]) $tdbg=timedebug_start ("twiggi_imap_fetch_overview: IMAP get headers");
	$loginstr=	"aw0 CAPABILITY\r\n" .
				"aw1 LOGIN \"" . $login["username"] . "\" \"" . $login["password"] . "\"\r\n";
	$initstr=	"aw2 LIST \"\" \"\"\r\n" .
				"aw3 SELECT \"" . $session["mailbox"] . "\"\r\n" .
				"aw4 NOOP\r\n";
	$fetchstr = "aw5 FETCH 1:" . $Nmsgs .
				" (BODY.PEEK[HEADER.FIELDS (SUBJECT MESSAGE-ID REFERENCES IN-REPLY-TO)])\r\n" .
				"aw6 NOOP\r\n";
	$logoutstr = "aw7 LOGOUT\r\n";
	$fp = fsockopen ( $config["imap_server"], $config["imap_port"], $errno, $errstr, 5);
	if ( !$fp )
		{
		print "$errstr ($errno)<br>";
		}
	else
		{
		fputs( $fp, $loginstr);
		$resp="";
		while( strncmp ("aw1", $resp, 3) )
			{
				$resp=fgets ( $fp, 4096);
			}
		fputs( $fp, $initstr);
		while( strncmp ("aw4", $resp, 3) )
			{
				$resp=fgets ( $fp, 4096);
			}
		fputs( $fp, $fetchstr);
		$msgno=0;
		$resp="";
		$r=array();
		while( strncmp ("aw6", $resp, 3) )
			{
			$resp = fgets ($fp, 4096);
			if( preg_match( "/^[ \t]/", $resp) )
				{
				$r[count($r)-1] .= " " . trim( $resp );
				}
			else
				{
				array_push( $r, trim( $resp ) );
				}
			}
		for( $m=0, $n=count($r); $m<$n; $m++ )
			{
				$resp = $r[$m];
				//ADMIN ++ ADDED (htmlentities -> TWIGhtmlentities)
				#print TWIGhtmlentities($resp) . "<br>";
				if ( !strncmp ("*", $resp, 1) ) 
					{ 
					$msgno=preg_replace ("/^\* ([0-9]*?) .*$/", "\\1", $resp );
					}
				elseif ( !strncmp ("Message-ID:", $resp, 11) )
					{
					$header[$msgno]->message_id=str_replace ("Message-ID: ", "", $resp);
					}
				elseif ( !strncmp ("References:", $resp, 11) )
					{
					$header[$msgno]->references=str_replace ("References: ", "", $resp);
					}
				elseif ( !strncmp ("In-Reply-To:", $resp, 12) )
					{
					$header[$msgno]->in_reply_to=str_replace ("In-Reply-To: ", "", $resp);
					}
				elseif ( !strncmp ("Subject:", $resp, 8) )
					{
					$header[$msgno]->subject=str_replace ("Subject: ", "", $resp);
					}
			}
		fputs( $fp, $logoutstr);
		$resp="";
		while( strncmp ("aw7", $resp, 3) )
			{
			$resp=fgets ( $fp, 4096);
			#print "$resp<br>"; 
			}
		fclose( $fp );
		}
	if ($config["tdbg"]) timedebug_stop( $tdbg );

	if ( $config["cachethreshold"] >0 && $config["cachethreshold"] < $Nmsgs )
		{

		if ($config["tdbg"]) $tdbg=timedebug_start ("twiggi_imap_fetch_overview: save to DISK cache");
		$cname = tempnam( GetCacheDir(), "");
		$fp = fopen ( $cname, "w");
		fputs ( $fp, serialize ( $header ) );
		fclose ($fp);

		$query="INSERT INTO " . $dbconfig["threadcache"] . " (fingerprint, Nmsgs, mailbox, username, type, cache) VALUES (" . 
				"'" . $fingerprint_mbox . "'," . 
				"'" . $Nmsgs . "'," . 
				"'" . SQLString( $mbx ) . "'," .
				"'" . $login["username"] . "'," .
				"'M'," .
				"'" .  SQLString ( $cname ) . "')";
		dbQuery ( $query );
		if ($config["tdbg"]) timedebug_stop( $tdbg );
		}

	$mbox=TWIGOpenMB ( $session["mailbox"] );

	if ( imap_num_msg ($mbox) != $Nmsgs )
		{
		return thread_imap_fetch_overview ($mbox, $mbx);
		}

	return $header;
	}

# this is a specialized version of imap_fetch_overview()
# for message list view
Function twiggi_imap_fetch_overview (&$mbox, $sequence)
	{
	GLOBAL $config, $dbconfig, $login, $session;

	TWIGCloseMB( $mbox ) ;

	if ($config["tdbg"]) $tdbg=timedebug_start ("twiggi_imap_fetch_overview: IMAP get headers");
	$loginstr=	"aw0 CAPABILITY\r\n" .
				"aw1 LOGIN \"" . $login["username"] . "\" \"" . $login["password"] . "\"\r\n";
	$initstr=
				"aw2 LIST \"\" \"\"\r\n" .
				"aw3 SELECT \"" . $session["mailbox"] . "\"\r\n" .
				"aw4 NOOP\r\n";
	$fetchstr = "aw5 FETCH $sequence" .
				" (FLAGS RFC822.SIZE INTERNALDATE BODY.PEEK[HEADER.FIELDS (SUBJECT FROM TO MESSAGE-ID REFERENCES IN-REPLY-TO DELIVERY-DATE DATE)])\r\n" .
				"aw6 NOOP\r\n";
	$logoutstr = "aw7 LOGOUT\r\n";
	$fp = fsockopen ( $config["imap_server"], $config["imap_port"], $errno, $errstr, 5);
	if ( !$fp )
		{
		print "$errstr ($errno)<br>";
		}
	else
		{
		fputs( $fp, $loginstr);
		$resp="";
		while( strncmp ("aw1", $resp, 3) )
			{
				$resp=fgets ( $fp, 4096);
			}
		fputs( $fp, $initstr);
		while( strncmp ("aw4", $resp, 3) )
			{
				$resp=fgets ( $fp, 4096);
			}
		fputs( $fp, $fetchstr);
		$resp="";
		$r=array();
		while( strncmp ("aw6", $resp, 3) )
			{
			$resp = fgets ($fp, 4096);
			if( preg_match( "/^[ \t]/", $resp) )
				{
				$r[count($r)-1] .= " " . trim( $resp );
				}
			else
				{
				array_push( $r, trim( $resp ) );
				}
			}
		for( $m=0, $n=count($r); $m<$n; $m++ )
			{
				$resp = $r[$m];
				//ADMIN ++ ADDED (htmlentities -> TWIGhtmlentities)
		#		print $ccc++. TWIGhtmlentities($resp) . "<br>";
				if ( !strncmp ("*", $resp, 1) ) 
					{ 
					$msgno=preg_replace ("/^\* ([0-9]*?) .*$/", "\\1", $resp );
					$header[$msgno]->size=preg_replace ("/^.*RFC822.SIZE ([0-9]*?) .*$/", "\\1", $resp );
					$header[$msgno]->udate=strtotime( preg_replace ("/^.*INTERNALDATE \"(.*?)\".*$/", "\\1", $resp ) );
					$flags = preg_replace ("/^.*FLAGS \((.*?)\).*$/", "\\1", $resp );
					$flags = preg_replace ("/\\\\/", "", $flags );
					$flags = explode (" ",  $flags);
					for( $i=0, $k=count($flags); $i<$k; $i++ )
						{
						if ( $flags[$i] == "Answered" )
							{
							$header[$msgno]->Answered=TRUE;
							}
						if ( $flags[$i] == "Deleted" )
							{
							$header[$msgno]->Deleted=TRUE;
							}
						if ( $flags[$i] == "Seen" )
							{
							$header[$msgno]->Seen=TRUE;
							}
						}
					}
				elseif ( !strncmp ("Delivery-date:", $resp, 14) )
					{
					$header[$msgno]->DeliveryDate=str_replace ("Delivery-date: ", "", $resp);
					}
				elseif ( !strncmp ("Date:", $resp, 5) )
					{
					$header[$msgno]->date=str_replace ("Date: ", "", $resp);
					}
				elseif ( !strncmp ("Message-ID:", $resp, 11) )
					{
					$header[$msgno]->message_id=str_replace ("Message-ID: ", "", $resp);
					}
				elseif ( !strncmp ("References:", $resp, 11) )
					{
					$header[$msgno]->references=str_replace ("References: ", "", $resp);
					}
				elseif ( !strncmp ("In-Reply-To:", $resp, 12) )
					{
					$header[$msgno]->in_reply_to=str_replace ("In-Reply-To: ", "", $resp);
					}
				elseif ( !strncmp ("Subject:", $resp, 8) )
					{
					$header[$msgno]->subject=preg_replace ("/^Subject: */", "", $resp);
					}
				elseif ( !strncmp ("From:", $resp, 5) )
					{
					$header[$msgno]->fromaddress=preg_replace ("/^From: */", "", $resp);
					}
				elseif ( !strncmp ("To:", $resp, 3) )
					{
					$header[$msgno]->toaddress=preg_replace ("/^To: */", "", $resp);
					}
			}
		fputs( $fp, $logoutstr);
		$resp="";
		while( strncmp ("aw7", $resp, 3) )
			{
			$resp=fgets ( $fp, 4096);
			#print "$resp<br>"; 
			}
		fclose( $fp );
		}
		
	$mbox=TWIGOpenMB ( $session["mailbox"] );
	if ($config["tdbg"]) timedebug_stop( $tdbg );
	return $header;
	}

# this is a specialized version of imap_status()
Function twiggi_imap_status (&$mbox)
	{
	GLOBAL $config, $dbconfig, $login, $session;

	$status->Nmsgs=imap_num_msg( $mbox );
	$status->Answered=0;
	$status->Deleted=0;
	$status->Seen=0;
	TWIGCloseMB( $mbox ) ;

	if ($config["tdbg"]) $tdbg=timedebug_start ("twiggi_imap_status");
	$loginstr=	"aw0 CAPABILITY\r\n" .
				"aw1 LOGIN \"" . $login["username"] . "\" \"" . $login["password"] . "\"\r\n";
	$initstr=	"aw2 LIST \"\" \"\"\r\n" .
				"aw3 SELECT \"" . $session["mailbox"] . "\"\r\n" .
				"aw4 NOOP\r\n";
	$fetchstr = "aw5 FETCH 1:" . $status->Nmsgs .
				" (FLAGS)\r\n" .
				"aw6 NOOP\r\n";
	$logoutstr = "aw7 LOGOUT\r\n";
	$fp = fsockopen ( $config["imap_server"], $config["imap_port"], $errno, $errstr, 5);
	if ( !$fp )
		{
		print "$errstr ($errno)<br>";
		}
	else
		{
		fputs( $fp, $loginstr);
		$resp="";
		while( strncmp ("aw1", $resp, 3) )
			{
				$resp=fgets ( $fp, 4096);
			}
		fputs( $fp, $initstr);
		while( strncmp ("aw4", $resp, 3) )
			{
				$resp=fgets ( $fp, 4096);
			}
		fputs( $fp, $fetchstr);
		while( strncmp ("aw6", $resp, 3) )
			{
				$resp = trim( fgets ( $fp, 4096) );
				//ADMIN ++ ADDED (htmlentities -> TWIGhtmlentities)
				# print TWIGhtmlentities($resp) . "<br>";
				if ( !strncmp ("*", $resp, 1) ) 
					{ 
					$flags = preg_replace ("/^.*FLAGS \((.*?)\).*$/", "\\1", $resp );
					$flags = preg_replace ("/\\\\/", "", $flags );
					$flags = explode (" ",  $flags);
					for( $i=0, $k=count($flags); $i<$k; $i++ )
						{
						if ( $flags[$i] == "Answered" )
							{
							$status->Answered++;
							}
						if ( $flags[$i] == "Deleted" )
							{
							$status->Deleted++;
							}
						if ( $flags[$i] == "Seen" )
							{
							$status->Seen++;
							}
						}
					}
			}
		fputs( $fp, $logoutstr);
		$resp="";
		while( strncmp ("aw7", $resp, 3) )
			{
			$resp=fgets ( $fp, 4096);
			#print "$resp<br>"; 
			}
		fclose( $fp );
		}
	$mbox=TWIGOpenMB ( $session["mailbox"] );
	$status->Unseen=$status->Nmsgs-$status->Seen;
	if ($config["tdbg"]) timedebug_stop( $tdbg );
	return $status;
	}


Function MailCacheGetSortedList ($mbox, $mbx, $sortby, $sortbyway, $filtercmd="")
	{
	GLOBAL $config, $dbconfig, $login, $sortbyint;
	$Nmsgs=imap_num_msg ($mbox);
	unset ($sorted);
	if ( $config["cachethreshold"] >0 && $config["cachethreshold"] < $Nmsgs )
		{
		$force_reread = ( imap_num_recent ($mbox) != 0 );
		$fingerprint_slist = SQLString( $Nmsgs 
							. "-" . $filtercmd 
							. "-" . $sortbyway 
							. "-" . $sortby );
		if ($config["tdbg"]) $tdbg=timedebug_start ("try to get sorted list from DISK cache\nfp=$fingerprint_slist");
		$query="SELECT cache FROM " . $dbconfig["threadcache"] 
					. " WHERE fingerprint='" . $fingerprint_slist . "'"
					. " AND username='" . $login["username"] . "'"
					. " AND mailbox='" . SQLString( $mbx ) . "'"
					. " AND type='S'";
		$result=dbQuery ( $query );
		$ret=dbResultArray( $result, 0 );
		if ( $ret && file_exists( $ret[0] ) && !$force_reread )
			{
			// reset expiry time
			$query="UPDATE " . $dbconfig["threadcache"] . " SET thedate=NULL WHERE fingerprint='" . $fingerprint_slist . "'";
			dbQuery ( $query );
			$fp = fopen ( $ret[0], "r");
			while ( !feof( $fp ) )
				{
				$sorted .= fgets( $fp, 1048576 ); 
				}
			fclose ($fp);
			$sorted=unserialize ( $sorted ); 
			}
			if ($config["tdbg"]) timedebug_stop ($tdbg);
		}
	if ( !$sorted )
		{
		if ($config["tdbg"]) $tdbg=timedebug_start ("get sorted list from IMAP");
		$sorted = TWIGMailGetSortedList( $mbox, 
			$sortbyint[$sortby], 
			$sortbyway, 
			$filtercmd);
		if ($config["tdbg"]) timedebug_stop ($tdbg);
		if ( $config["cachethreshold"] >0 && $config["cachethreshold"] < $Nmsgs )
			{
			if ($config["tdbg"]) $tdbg=timedebug_start ("sorted list: save to DISK cache");
			CleanUpMailboxCache ( $Nmsgs );
			CleanUpMailboxCache ( $Nmsgs );
			CleanUpMailboxCache ( $Nmsgs );
			$cname=tempnam( GetCacheDir(), "");
			$fp = fopen ( $cname, "w");
			fputs ( $fp, serialize ( $sorted ) );
			fclose ($fp);
			$query="INSERT INTO " . $dbconfig["threadcache"] . " (fingerprint, Nmsgs, mailbox, username, type, cache) VALUES (" . 
					"'" . $fingerprint_slist . "'," . 
					"'" . $Nmsgs . "'," . 
					"'" . SQLString( $mbx ) . "'," .
					"'" . $login["username"] . "'," .
					"'S'," .
					"'" . SQLString( $cname ) . "')";
			dbQuery ( $query );
			if ($config["tdbg"]) timedebug_stop ($tdbg);
			}
		}
	if ( imap_num_msg ($mbox) != $Nmsgs )
		{
		return MailCacheGetSortedList ($mbox, $mbx, $sortby, $sortbyway, $filtercmd);
		}
	return $sorted;
	}

	Function TWIGMailGetSortedList( $mailbox, $sortedby, $sorteddirection, $filter="" )
		{
		// sort by SENTDATE, if using UWIMAP with maildir patch
		$sortedby = $config["fix_imap_maildir_date_bug"] && $sortedby==1 ? 0 : $sortedby;
		if ($sortedby==99) 
			{
			$recent=imap_search ( $mailbox, "RECENT UNANSWERED");
			if ( is_array ($recent) ) { $so=array_merge ($so, $recent);}
			$unseen=imap_search ( $mailbox, "UNSEEN UNANSWERED");
			if ( is_array ($unseen) ) { $so=array_merge ($so, $unseen);}
			$seen=imap_search ( $mailbox, "SEEN UNANSWERED");
			if ( is_array ($seen) ) { $so=array_merge ($so, $seen);}
			$answered=imap_search ( $mailbox, "ANSWERED");
			if ( is_array ($answered) ) { $so=array_merge ($so, $answered);}
			if ($sorteddirection==0) 
				{ 
				$so =  array_reverse ($so);
				}
			}
			else
			{
			$so =  imap_sort( $mailbox, $sortedby, $sorteddirection );
			}
			if ( $filter )
				{
				$sr=imap_search ( $mailbox, $filter);
				if ( is_array( $sr ) )
					{
					for ($i=0, $z=0, $k=count($so); $i<$k; $i++) 
						{
						if ( in_array ($so[$i], $sr) )
							{
							$ret[$z++]=$so[$i];
							}
						}
					}
				else
					{
					unset( $ret );
					}
				return $ret;
				}
			else
				{
				return $so;
				}
		}

	Function TWIGMailCreateFolder( $mailbox, $folder )
		{
   		return imap_createmailbox( $mailbox, $folder );
		}

	Function TWIGMailSubscribeFolder( $mailbox, $folder )
		{
	  	return imap_subscribe( $mailbox, $folder );
		}
	
	Function TWIGMailUnSubscribeFolder( $mailbox, $folder )
		{
    		return imap_unsubscribe( $mailbox, $folder );
		}

	Function TWIGMailDeleteFolder( $mailbox, $folder )
		{
    		return imap_deletemailbox( $mailbox, $folder );
		}

	Function TWIGMailRenameFolder( $mailbox, $folder, $newname )
		{
		return imap_renamemailbox( $mailbox, $folder, $newname );	
		}

	Function TWIGMailFolderList( $mailbox, $startingfolder, $filter )
		{
		return imap_listmailbox( $mailbox, $startingfolder, $filter );
		}

	Function TWIGGetMailboxList( $mailbox, $folder, $filter )
		{
		GLOBAL $config;
		$ibx=TWIGMailGetFolderString( $config["imap_server"], $config["imap_port"], $config["imap_path"], "INBOX" );
		$startingfolder=TWIGMailGetFolderString( $config["imap_server"], $config["imap_port"], "", $config["imap_path"] );
		$filter=TWIGMailGetFolderString( $config["imap_server"], $config["imap_port"], "", $folder.$filter );
 		$mblist = imap_getmailboxes( $mailbox, $startingfolder, $filter );
		$result=array();
		if ( $mblist )
			{
			while ( list($k, $v) = each ($mblist) )
				{
				if ( $v->name != $ibx )
					{
					array_push($result, $v->name);
					if ( $config["UWIMAPmdir"] &&  $v->delimiter && !($v->attributes&LATT_NOINFERIORS) && $v->name != $startingfolder )
						{
						$v->name=preg_replace( "#\{.*?\}#", "", $v->name) . $v->delimiter;
						$result=array_merge( $result, TWIGGetMailboxList( $mailbox, $v->name, "*"  ) );
						}
					}
				}
			}
			return $result;
		}

	Function TWIGMailFolderInfo( $mailbox )
		{
		return imap_mailboxmsginfo( $mailbox );
		}

	Function TWIGMailHeader( $mailbox, $message, $fromlength, $subjectlength, $defaultdomain )
		{
		return imap_header( $mailbox, $message, $fromlength, $subjectlength, $defaultdomain );
		}

	Function TWIGMailSetMessageFlag( $mailbox, $message, $flag )
		{
		return imap_setflag_full( $mailbox, $message, $flag );
		}

	Function TWIGMailUnSetMessageFlag( $mailbox, $message, $flag )
		{
		return imap_clearflag_full( $mailbox, $message, $flag );
		}

	Function TWIGMailAppendMessage( $mailbox, $folder, $message, $flags )
		{
		GLOBAL $config;

		$ret = imap_append( $mailbox, $folder, $message, $flags );

		if( $ret == FALSE )
			{
   			imap_createmailbox( $mailbox, $folder );
			$ret = imap_append( $mailbox, $folder, $message, $flags );
			}

		return $ret;
		}

	Function TWIGMailUndelete( $mailbox, $message )
		{
		return imap_undelete( $mailbox, $message ); 
		}

	Function TWIGMailFetchHeader( $mailbox, $message )
		{
		return imap_fetchheader( $mailbox, $message );
		}

	Function TWIGMailParseAddresssList( $list, $defaultdomain )
		{		
		return imap_rfc822_parse_adrlist( $list, $defaultdomain );
		}

	Function TWIGMailDecodeBase64( $text )
		{
		return imap_base64( $text );
		}

	Function TWIGMailDecodeQPrint( $text )
		{
		return imap_qprint( $text );
		}

	Function TWIGMailGetFolderString( $server, $port, $type, $folder, $user = "", $pass = "" )
		{
		return "{" . $server . $type . ":" . $port . "}" . $folder;
		}

	Function TWIGMailParseFolderString( $FolderString )
		{
    	$foldersplit = explode( "}", $FolderString, 2 );
		if( count( $foldersplit ) > 1 ) { $mbfolder = $foldersplit[1]; }

		$portsplit = explode( ":", $foldersplit[0] );
		if( count( $portsplit ) > 1 ) { $mbport = $portsplit[1]; }
			
		$typesplit = explode( "/", $portsplit[0] );
		if( count( $typesplit ) > 1 ) { $mbtype = $typesplit[1]; }

		$serversplit = explode( "{", $typesplit[0] );
		if( count( $serversplit ) > 1 ) { $mbserver = $serversplit[1]; }

		return array( $mbserver, $mbport, $mbtype, $mbfolder, $mbuser, $mbpass );
		}

	Function TWIGMailGetDisplayName( $Folder, $splittop=1 )
		{
		GLOBAL $config, $TWIGphrase;
		if ( $Folder == "INBOX" )
			{
			$Folder=$TWIGphrase["INBOX"];
			}
		else
			{
			$Folder = twiggi_imap_utf7_decode( ereg_replace( "^" . $config["imap_path"], "", $Folder ));
			if ( $splittop )
				{
				$Folder = preg_replace ("#^(.*)\\$config[mail_folder_delimiter](.*)$#", "\\1 --> \\2", $Folder);
				$Folder = preg_replace ("#^\\$config[mail_folder_delimiter]#", "", $Folder);
				}
			$Folder= preg_replace ("/\\$config[mail_folder_delimiter]/", "/", $Folder );
			//ADMIN ++ ADDED (htmlentities -> TWIGhtmlentities)
			$Folder= preg_replace ("/ /", "&nbsp;", TWIGhtmlentities($Folder) );
			}
		return $Folder;
		}

Function TWIGDeliveryDate( $mbox, $message )
	{
	GLOBAL $config;
	if ( $config["fix_imap_maildir_date_bug"] == TRUE )
		{
		$h=TWIGMailFetchHeader ( $mbox, $message );
		if ( preg_match ("/Delivery-date: /", $h ) )
			{
			return preg_replace ("/^(?:.*?)Delivery-date: (.*?)\n.*$/ms", "\\1", $h );
			}
		}
	return;
	}


Function twiggi_imap_utf7_encode ($s)
	{
	$s = preg_replace("/([\x80-\xff])/", "\0\\1", $s);
	return imap_utf7_encode($s);
	}

Function twiggi_imap_utf7_decode ($s)
	{
	$s=imap_utf7_decode($s);
	return preg_replace("/\\0([\x80-\xff])/", "\\1", $s);
	}

?>
