<?php
	$sessionts = TWIGbaseconvert ( mktime(),  10, 36) ;
	$sessionid = 1;
	$sessioncache = array();

	Function TWIGGetContext() 
		{
		GLOBAL $ctx, $dbconfig, $config;

		if( !$ctx ) { return array( "feature"=>"main", "action"=>"main" ); }

		$cids = explode( "@", $ctx );

		$query = "SELECT context FROM " . $dbconfig["context_table"] . " WHERE id='" . $cids[0] . "' AND sid='" . $cids[1] . "' AND username='" . $cids[2] . "'";
		$result = dbquery( $query );

		if( dbnumrows( $result ) > 0 )
			{
			$data = dbresultarray( $result, 0 );
			$context = unserialize( $data[0] );

			$trig = TWIGbaseconvert( TWIGbaseconvert( $cids[0], 36, 10 ) - $config["session_expiry"], 10, 36);
			$query = "DELETE FROM " . $dbconfig["context_table"] . " WHERE id<='" . $trig . "' AND username='" . $cids[2] . "'";
			dbquery( $query );

			return $context;
			}
		else
			{
			TWIGPrintError( "Unable to find context data, please click <a href=\"" . $config["baseurl"] . "\">here</a> to restart twig and try again." );

			exit;
			}
 		}

	Function TWIGContext( $type = "get", $feature = "", $action = "", $other = "" )
		{
		global $context, $login, $sessionts, $sessionid, $sessioncache, $dbconfig;

		$tcontext = $context;

		if( $feature ) { $tcontext["feature"] = $feature; }
		if( $action ) { $tcontext["action"] = $action; }

		if( $other )
			{
			$j = count( $other );

			for( $i = 0; $i < $j; $i++ )
				{
				$tcontext[$other[$i]["item"]] = $other[$i]["value"];
				}
			}

		$scontext = SQLString( serialize( $tcontext ) );

		if( $scontext == $sessioncache["context"] )
			{
			$sid = $sessioncache["contextid"];
			}
		else
			{
			$sid = $sessionid;
			$sessionid++;
			$query = "INSERT INTO " . $dbconfig["context_table"] . " (id, sid, username, context) VALUES ('" . $sessionts . "', '" . $sid . "', '" . $login["username"] . "', '" . $scontext . "')"; 

			dbquery( $query );

			$sessioncache["context"] = $scontext;
			$sessioncache["contextid"] = $sid;
			}

	 	if( $type == "get" ) { $str .= "&ctx=" . $sessionts . "@" . $sid . "@" . $login["username"]; }
		else { $str .= "<input type=hidden name=ctx value=\"" . $sessionts . "@" . $sid . "@" . $login["username"] . "\">\n"; }

		return $str;
 		}

 	Function TWIGSession( $type = "get", $other = "" ) 
		{
		global $session, $login, $sessionts, $sessionid, $sessioncache, $dbconfig;

		if( $login["username"] )
			{
			$tsession = $session;

			if( $other )
				{
				$j = count( $other );

				for( $i = 0; $i < $j; $i++ )
					{
					$tsession[$other[$i]["item"]] = $other[$i]["value"];
					}
				}
			

			$ssession = SQLString( serialize( $tsession ) );

			if( $ssession == $sessioncache["session"] )
				{
				$sid = $sessioncache["sessionid"];
				}
			else
				{
				$sid = $sessionid;
				$sessionid++;
				$query = "INSERT INTO " . $dbconfig["session_table"] . " (id, sid, username, sdata) VALUES ('" . $sessionts . "', '" . $sid . "', '" . $login["username"] . "', '" . $ssession . "')"; 

				dbquery( $query );

				$sessioncache["session"] = $ssession;
				$sessioncache["sessionid"] = $sid;
				}
	
		 	if( $type == "get" ) { $str .= "&ses=" . $sessionts . "@" . $sid . "@" . $login["username"]; }
			else { $str .= "<input type=hidden name=ses value=\"" . $sessionts . "@" . $sid . "@" . $login["username"] . "\">\n"; }
			}

		return $str;
 		}

	Function TWIGGetSession() 
		{
		GLOBAL $ses, $dbconfig, $config;

		if( !$ses ) { return array( "feature"=>"main", "action"=>"main" ); }

		$sids = explode( "@", $ses );

		$query = "SELECT sdata FROM " . $dbconfig["session_table"] . " WHERE id='" . $sids[0] . "' AND sid='" . $sids[1] . "' AND username='" . $sids[2] . "'";
		$result = dbquery( $query );

		if( dbnumrows( $result ) > 0 )
			{
			$data = dbresultarray( $result, 0 );
			$session = unserialize( $data[0] );
			$trig = TWIGbaseconvert( TWIGbaseconvert( $sids[0], 36, 10 ) - $config["session_expiry"], 10, 36);
			$query = "DELETE FROM " . $dbconfig["session_table"] . " WHERE id<='" . $trig . "' AND username='" . $sids[2] . "'";
			dbquery( $query );
			return $session;
			}
		else
			{
			TWIGPrintError( "Unable to find session data, please click <a href=\"" . $config["baseurl"] . "\">here</a> to restart twig and try again." );

			exit;
			}
 		}

	Function TWIGCleanSession()
		{
		GLOBAL $ses, $dbconfig, $config;

		if( !$ses ) { return; }

		$sids = explode( "@", $ses );

		$query = "DELETE FROM " . $dbconfig["session_table"] . " WHERE username='" . $sids[2] . "'";
		dbquery( $query );
		}

	Function TWIGCleanContext()
		{
		GLOBAL $ctx, $dbconfig, $config;

		if( !$ctx ) { return; }

		$cids = explode( "@", $ctx );

		$query = "DELETE FROM " . $dbconfig["context_table"] . " WHERE username='" . $cids[2] . "'";
		dbquery( $query );
		}
?>
