<?php	// TWIG		TEST Script ?>
<?php
if ( !preg_match ("/\/index.php$/", $HTTP_SERVER_VARS["PHP_SELF"] ) )
	{
	?>
	<html><body><head></head>
	<a href="./index.php?test=yes">click here to run the test</a>
	</body></html>
	<?php
	exit;
	};

	register_globals (array(
	
		# GET
	
	), array(
	
		# POST
		"currenttest", "username", "password", 
	
	) );


 // Load the config options
 include("config/config.inc.php");	// Global Configuration Variables

 // Load the image source files
 include("config/images.inc.php");

 // Load the common functions lib...
 include( "features/common.inc.php" );

 // Allow for virtual hosting
 $config_dir="config";
 if( $vhosts[$SERVER_NAME] ) { 
   $config_dir = $vhosts[$SERVER_NAME]; 
   include("$config_dir/config.inc.php");
   include("$config_dir/images.inc.php");
 }

 // Set up database
 if (!$disabled["database"]) {
  $dbconfigfile="config/dbconfig.inc.php";
  include($dbconfigfile);
  if (!$dbconfig["sqltype"]) { $dbconfig["sqltype"] = "mysql"; }
  include("lib/db/" . $dbconfig["sqltype"] . ".db.inc.php");
 }
 else {
  include("config/nodbconfig.inc.php");
 }

 include("config/custom.inc.php");  // Customized Global Configuration Variables 
 if( !$config["imap_server"]) { $config["imap_server"]="localhost"; }
 if( !$config["imap_port"]) { $config["imap_port"] = 143; }

 include( "lib/mail/php-imap.inc.php" );		// include the mail subsystem

 include("config/header.inc.php");
?>
<table border=0 cellspacing=0 width=100%>
<tr bgcolor="<?php echo $config["cellheadcolor"];?>"><td><font color="<?php echo $config["cellheadtext"];?>"><a name=GENERAL><b>General</b></a></font></td><td colspan=2 align=right><font color="<?php echo $config["cellheadtext"];?>">Back to <a href="#top">top</a>.</font></td></tr>
</table>
<BR>
Welcome to the TWIG test page!<BR>
<BR>
If you've executed a test that has failed and can no longer see the complete form click <a href="index.php?test=yes">here</a> to get back to a clean form.<br>
<br>
This page is divied in to several sections:<br>
<ul>
<li>This section</li>
<li><a href="#IMAP">An IMAP test</a></li>
<li><a href="#SQL">A SQL test</a></li>
<li><a href="#PHPINFO">PHP Version Information</a></li>
</ul>

<hr>
<?php
$phpver = explode( ".", phpversion() );

if( $phpver[0] <= 3 )
	{
	if( $phpver[0] == 3 )
		{
		if( $phpver[1] == 0 )
			{
			if( $phpver[2] < 11 )
				{
				echo "<H1><FONT COLOR=\"#FF0000\"><B>WARNING: You are running a version " . phpversion() ." of PHP, however TWIG needs at least version 3.0.11!</B></FONT></H1><BR><HR>";
				}
			}
		}
	else
		{
		echo "<H1><FONT COLOR=\"#FF0000\"><B>WARNING: You are running a version " . phpversion() ." of PHP, however TWIG needs at least version 3.0.11!</B></FONT></H1><BR><HR>";
		}
	}
?>
<?php flush();?>

<table border=0 cellspacing=0 width=100%>
<tr bgcolor="<?php echo $config["cellheadcolor"];?>"><td><font color="<?php echo $config["cellheadtext"];?>"><a name=IMAP><b>IMAP</b></a></font></td><td colspan=2 align=right><font color="<?php echo $config["cellheadtext"];?>">Back to <a href="#top">top</a>.</font></td></tr>
<tr><td>&nbsp;</td><td valign=top width=40%>
<B>Test #1</B><BR>
<BR>
This IMAP test will execute a php imap function, if imap is compiled in to php a result should be returned, otherwise php will generate an undefined function error.<BR>
<BR>
<form action="index.php?test=yes#IMAP" method=post>
<input type=submit name=currenttest value="Execute IMAP Test">
</form>
Test result: <font color="#FF0000">
<?php 
 if( $currenttest == "Execute IMAP Test" ) 
	{
	$aparse = TWIGMailParseAddresssList( "twig@screwdriver.net", $config["fromdomain"] );

	if( count( $aparse ) > 0 ) { echo "Works"; } else { echo "Failed"; }
	}
 else
	{
	echo "Test not run";
	}
?>
</font>
</td><td valign=top width=40%>
<B>Test #2</B><BR>
<BR>
This IMAP test will try and connect to:<br>
<BR>
<table border=0>
<tr>
<td align=right>Server name:</td><td><?php echo $config["imap_server"]?></td>
</tr><tr>
<td align=right>Server port:</td><td><?php echo $config["imap_port"]?></td>
</tr>
</table>
<br>
Enter a username and password to connect to the IMAP server
<form action="index.php?test=yes#IMAP" method=post>
<table>
 <tr>
  <td>Name<br><input name=username></td>
  <td>Password<br><input name=password type=password></td>
 </tr>
</table>
<input type=submit name=currenttest value="Execute IMAP Connection Test">
</form>
Test result: <font color="#FF0000">
<?php 
 if( $currenttest == "Execute IMAP Connection Test" ) 
	{
 	$mbox = TWIGMailOpenMailbox( TWIGMailGetFolderString( $config["imap_server"], $config["imap_port"], "", "INBOX" ), $username, $password, "" );

	if( $mbox ) { echo "Works"; } else { echo "Failed"; }
	}
 else
	{
	echo "Test not run";
	}
?>
</font>
</td></tr></table>

<hr>

<table border=0 cellspacing=0 width=100%>
<tr bgcolor="<?php echo $config["cellheadcolor"];?>"><td><font color="<?php echo $config["cellheadtext"];?>"><a name=SQL><b>SQL</b></a></font></td><td colspan=2 align=right><font color="<?php echo $config["cellheadtext"];?>">Back to <a href="#top">top</a>.</font></td></tr>
<tr><td>&nbsp;</td><td valign=top width=80%>
<B>Test #1</B><BR>
<BR>
This SQL test will try and connect to:<br>
<BR>
<table border=0>
<tr>
<td align=right>Server type:</td><td><?php echo $dbconfig["sqltype"]?></td>
</tr><tr>
<td align=right>Server name:</td><td><?php echo $dbconfig["sqlserver"]?></td>
</tr><tr>
<td align=right>Server port:</td><td><?php echo $dbconfig["sqlport"]?></td>
</tr><tr>
<td align=right>Database name:</td><td><?php echo $dbconfig["defaultdb"]?></td>
</tr><tr>
<td align=right>Database table:</td><td><?php echo $dbconfig["global_prefs_table"]?></td>
</tr>
</table>
<BR>
If sql is not compiled in to php will generate an undefined function error.<BR>
<form action="index.php?test=yes#SQL" method=post>
<input type=submit name=currenttest value="Execute SQL Connection Test">
</form>
Test result: <font color="#FF0000">
<?php 
 if( $currenttest == "Execute SQL Connection Test" ) 
	{
	$st = "SELECT * FROM " . $dbconfig["global_prefs_table"];
	$rc = dbQuery( $st );

	if( $rc ) { echo "Working"; } else { echo "Failed"; }
	}
 else
	{
	echo "Test not run";
	}
?>
</font>
</td></tr></table>

<hr>

<table border=0 cellspacing=0 width=100%>
<tr bgcolor="<?php echo $config["cellheadcolor"];?>"><td colspan=2><font color="<?php echo $config["cellheadtext"];?>"><a name=PHPINFO><b>PHP Version Information</b></a></font></td><td colspan=2 align=right><font color="<?php echo $config["cellheadtext"];?>">Back to <a href="#top">top</a>.</font></td></tr>
</table>
<?php phpinfo();?>

